/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.42.0-dev-20230906(e7d7a5b072e74702a912a4c855a3bda21a7757e7)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arrays","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(T){for(var n=[],A=0,M=T.length;A<M;A++)n[A]=X[T[A]];return n};const Ee=this,Re=typeof global=="object"?global:{};var oe;(function(T){T.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof T.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}T.Environment=n})(oe||(oe={}));var oe;(function(T){class n{constructor(h,g,L){this.type=h,this.detail=g,this.timestamp=L}}T.LoaderEvent=n;class A{constructor(h){this._events=[new n(1,"",h)]}record(h,g){this._events.push(new n(h,g,T.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}T.LoaderEventRecorder=A;class M{record(h,g){}getEvents(){return[]}}M.INSTANCE=new M,T.NullLoaderEventRecorder=M})(oe||(oe={}));var oe;(function(T){class n{static fileUriToFilePath(M,i){if(i=decodeURI(i).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(M,i){return M.length>=i.length&&M.substr(0,i.length)===i}static endsWith(M,i){return M.length>=i.length&&M.substr(M.length-i.length)===i}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,i){if(M){let h;for(h in M)M.hasOwnProperty(h)&&i(h,M[h])}}static isEmpty(M){let i=!0;return n.forEachProperty(M,()=>{i=!1}),i}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let i=Array.isArray(M)?[]:{};return n.forEachProperty(M,(h,g)=>{g&&typeof g=="object"?i[h]=n.recursiveClone(g):i[h]=g}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return n.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=T.global.performance&&typeof T.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?T.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,T.Utilities=n})(oe||(oe={}));var oe;(function(T){function n(i){if(i instanceof Error)return i;const h=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(h.stack=i.stack),h}T.ensureError=n;class A{static validateConfigurationOptions(h){function g(L){if(L.phase==="loading"){console.error('Loading "'+L.moduleId+'" failed'),console.error(L),console.error("Here are the modules that depend on it:"),console.error(L.neededBy);return}if(L.phase==="factory"){console.error('The factory function of "'+L.moduleId+'" has thrown an exception'),console.error(L),console.error("Here are the modules that depend on it:"),console.error(L.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=g),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(T.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const L=n(new Error("INVALID cached data configuration, 'path' MUST be set"));L.phase="configuration",h.onError(L),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,g=null){let L=T.Utilities.recursiveClone(g||{});return T.Utilities.forEachProperty(h,(l,s)=>{l==="ignoreDuplicateModules"&&typeof L.ignoreDuplicateModules<"u"?L.ignoreDuplicateModules=L.ignoreDuplicateModules.concat(s):l==="paths"&&typeof L.paths<"u"?T.Utilities.forEachProperty(s,(_,e)=>L.paths[_]=e):l==="config"&&typeof L.config<"u"?T.Utilities.forEachProperty(s,(_,e)=>L.config[_]=e):L[l]=T.Utilities.recursiveClone(s)}),A.validateConfigurationOptions(L)}}T.ConfigurationOptionsUtil=A;class M{constructor(h,g){if(this._env=h,this.options=A.mergeConfigurationOptions(g),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let L=this.options.nodeRequire.main.filename,l=Math.max(L.lastIndexOf("/"),L.lastIndexOf("\\"));this.options.baseUrl=L.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],T.Utilities.forEachProperty(this.options.paths,(h,g)=>{Array.isArray(g)?this.sortedPathsRules.push({from:h,to:g}):this.sortedPathsRules.push({from:h,to:[g]})}),this.sortedPathsRules.sort((h,g)=>g.from.length-h.from.length)}cloneAndMerge(h){return new M(this._env,A.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let g;for(let L=0,l=this.sortedPathsRules.length;L<l;L++)if(g=this.sortedPathsRules[L],T.Utilities.startsWith(h,g.from)){let s=[];for(let _=0,e=g.to.length;_<e;_++)s.push(g.to[_]+h.substr(g.from.length));return s}return[h]}_addUrlArgsToUrl(h){return T.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let g=0,L=h.length;g<L;g++)h[g]=this._addUrlArgsToUrl(h[g]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let g=h,L;if(!T.Utilities.endsWith(g,".js")&&!T.Utilities.isAbsolutePath(g)){L=this._applyPaths(g);for(let l=0,s=L.length;l<s;l++)this.isBuild()&&L[l]==="empty:"||(T.Utilities.isAbsolutePath(L[l])||(L[l]=this.options.baseUrl+L[l]),!T.Utilities.endsWith(L[l],".js")&&!T.Utilities.containsQueryString(L[l])&&(L[l]=L[l]+".js"))}else!T.Utilities.endsWith(g,".js")&&!T.Utilities.containsQueryString(g)&&(g=g+".js"),L=[g];return this._addUrlArgsIfNecessaryToUrls(L)}requireToUrl(h){let g=h;return T.Utilities.isAbsolutePath(g)||(g=this._applyPaths(g)[0],T.Utilities.isAbsolutePath(g)||(g=this.options.baseUrl+g)),this._addUrlArgsIfNecessaryToUrl(g)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||T.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}T.Configuration=M})(oe||(oe={}));var oe;(function(T){class n{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,_,e,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:f}=s.getConfig().getOptionsLiteral();f?this._scriptLoader=new A:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new A;let u={callback:e,errorback:b};if(this._callbackMap.hasOwnProperty(_)){this._callbackMap[_].push(u);return}this._callbackMap[_]=[u],this._scriptLoader.load(s,_,()=>this.triggerCallback(_),f=>this.triggerErrorback(_,f))}triggerCallback(s){let _=this._callbackMap[s];delete this._callbackMap[s];for(let e=0;e<_.length;e++)_[e].callback()}triggerErrorback(s,_){let e=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<e.length;b++)e[b].errorback(_)}}class A{attachListeners(s,_,e){let b=()=>{s.removeEventListener("load",u),s.removeEventListener("error",f)},u=m=>{b(),_()},f=m=>{b(),e(m)};s.addEventListener("load",u),s.addEventListener("error",f)}load(s,_,e,b){if(/^node\|/.test(_)){let u=s.getConfig().getOptionsLiteral(),f=g(s.getRecorder(),u.nodeRequire||T.global.nodeRequire),m=_.split("|"),c=null;try{c=f(m[1])}catch(y){b(y);return}s.enqueueDefineAnonymousModule([],()=>c),e()}else{let u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript"),this.attachListeners(u,e,b);const{trustedTypesPolicy:f}=s.getConfig().getOptionsLiteral();f&&(_=f.createScriptURL(_)),u.setAttribute("src",_);const{cspNonce:m}=s.getConfig().getOptionsLiteral();m&&u.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(u)}}}function M(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(s)),this._cachedCanUseEval}load(s,_,e,b){if(/^node\|/.test(_)){const u=s.getConfig().getOptionsLiteral(),f=g(s.getRecorder(),u.nodeRequire||T.global.nodeRequire),m=_.split("|");let c=null;try{c=f(m[1])}catch(y){b(y);return}s.enqueueDefineAnonymousModule([],function(){return c}),e()}else{const{trustedTypesPolicy:u}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(_)&&_.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(_).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${_}`,(u?self.eval(u.createScript("",m)):new Function(m)).call(self),e()}).then(void 0,b);return}try{u&&(_=u.createScriptURL(_)),importScripts(_),e()}catch(m){b(m)}}}}class h{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,_){const{nodeCachedData:e}=_.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,u=s("module");function f(m){const c=m.constructor;let y=function(N){try{return m.require(N)}finally{}};return y.resolve=function(N,p){return c._resolveFilename(N,m,!1,p)},y.resolve.paths=function(N){return c._resolveLookupPaths(N,m)},y.main=process.mainModule,y.extensions=c._extensions,y.cache=c._cache,y}u.prototype._compile=function(m,c){const y=u.wrap(m.replace(/^#!.*/,"")),w=_.getRecorder(),N=b._getCachedDataPath(e,c),p={filename:c};let S;try{const R=b._fs.readFileSync(N);S=R.slice(0,16),p.cachedData=R.slice(16),w.record(60,N)}catch{w.record(61,N)}const r=new b._vm.Script(y,p),o=r.runInThisContext(p),a=b._path.dirname(c),v=f(this),d=[this.exports,v,this,c,a,process,Re,Buffer],C=o.apply(this.exports,d);return b._handleCachedData(r,y,N,!p.cachedData,_),b._verifyCachedData(r,y,N,S,_),C}}load(s,_,e,b){const u=s.getConfig().getOptionsLiteral(),f=g(s.getRecorder(),u.nodeRequire||T.global.nodeRequire),m=u.nodeInstrumenter||function(y){return y};this._init(f),this._initNodeRequire(f,s);let c=s.getRecorder();if(/^node\|/.test(_)){let y=_.split("|"),w=null;try{w=f(y[1])}catch(N){b(N);return}s.enqueueDefineAnonymousModule([],()=>w),e()}else{_=T.Utilities.fileUriToFilePath(this._env.isWindows,_);const y=this._path.normalize(_),w=this._getElectronRendererScriptPathOrUri(y),N=!!u.nodeCachedData,p=N?this._getCachedDataPath(u.nodeCachedData,_):void 0;this._readSourceAndCachedData(y,p,c,(S,r,o,a)=>{if(S){b(S);return}let v;r.charCodeAt(0)===h._BOM?v=h._PREFIX+r.substring(1)+h._SUFFIX:v=h._PREFIX+r+h._SUFFIX,v=m(v,y);const d={filename:w,cachedData:o},C=this._createAndEvalScript(s,v,d,e,b);this._handleCachedData(C,v,p,N&&!o,s),this._verifyCachedData(C,v,p,a,s)})}}_createAndEvalScript(s,_,e,b,u){const f=s.getRecorder();f.record(31,e.filename);const m=new this._vm.Script(_,e),c=m.runInThisContext(e),y=s.getGlobalAMDDefineFunc();let w=!1;const N=function(){return w=!0,y.apply(null,arguments)};return N.amd=y.amd,c.call(T.global,s.getGlobalAMDRequireFunc(),N,e.filename,this._path.dirname(e.filename)),f.record(32,e.filename),w?b():u(new Error(`Didn't receive define call in ${e.filename}!`)),m}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let _=s.match(/^([a-z])\:(.*)/i);return _?`file:///${(_[1].toUpperCase()+":"+_[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,_){const e=this._crypto.createHash("md5").update(_,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(_).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${e}.code`)}_handleCachedData(s,_,e,b,u){s.cachedDataRejected?this._fs.unlink(e,f=>{u.getRecorder().record(62,e),this._createAndWriteCachedData(s,_,e,u),f&&u.getConfig().onError(f)}):b&&this._createAndWriteCachedData(s,_,e,u)}_createAndWriteCachedData(s,_,e,b){let u=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),f=-1,m=0,c;const y=()=>{setTimeout(()=>{c||(c=this._crypto.createHash("md5").update(_,"utf8").digest());const w=s.createCachedData();if(!(w.length===0||w.length===f||m>=5)){if(w.length<f){y();return}f=w.length,this._fs.writeFile(e,Buffer.concat([c,w]),N=>{N&&b.getConfig().onError(N),b.getRecorder().record(63,e),y()})}},u*Math.pow(4,m++))};y()}_readSourceAndCachedData(s,_,e,b){if(!_)this._fs.readFile(s,{encoding:"utf8"},b);else{let u,f,m,c=2;const y=w=>{w?b(w):--c===0&&b(void 0,u,f,m)};this._fs.readFile(s,{encoding:"utf8"},(w,N)=>{u=N,y(w)}),this._fs.readFile(_,(w,N)=>{!w&&N&&N.length>0?(m=N.slice(0,16),f=N.slice(16),e.record(60,_)):e.record(61,_),y()})}}_verifyCachedData(s,_,e,b,u){b&&(s.cachedDataRejected||setTimeout(()=>{const f=this._crypto.createHash("md5").update(_,"utf8").digest();b.equals(f)||(u.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,m=>{m&&u.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function g(l,s){if(s.__$__isRecorded)return s;const _=function(b){l.record(33,b);try{return s(b)}finally{l.record(34,b)}};return _.__$__isRecorded=!0,_}T.ensureRecordedNodeRequire=g;function L(l){return new n(l)}T.createScriptLoader=L})(oe||(oe={}));var oe;(function(T){class n{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,_;for(_=/\/\.\//;_.test(s);)s=s.replace(_,"/");for(s=s.replace(/^\.\//g,""),_=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;_.test(s);)s=s.replace(_,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return T.Utilities.isAbsolutePath(s)||(T.Utilities.startsWith(s,"./")||T.Utilities.startsWith(s,"../"))&&(s=n._normalizeModuleId(this.fromModulePath+s)),s}}n.ROOT=new n(""),T.ModuleIdResolver=n;class A{constructor(l,s,_,e,b,u){this.id=l,this.strId=s,this.dependencies=_,this._callback=e,this._errorback=b,this.moduleIdResolver=u,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(T.global,s),producedError:null}}catch(_){return{returnedValue:null,producedError:_}}}static _invokeFactory(l,s,_,e){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(_,e):{returnedValue:_.apply(T.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,_,e){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let u=A._invokeFactory(s,this.strId,this._callback,_);b=u.producedError,l.record(22,this.strId),!b&&typeof u.returnedValue<"u"&&(!this.exportsPassedIn||T.Utilities.isEmpty(this.exports))&&(this.exports=u.returnedValue)}else this.exports=this._callback;if(b){let u=T.ensureError(b);u.phase="factory",u.moduleId=this.strId,u.neededBy=e(this.id),this.error=u,s.onError(u)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}T.Module=A;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class i{constructor(l){this.id=l}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),T.RegularDependency=i;class h{constructor(l,s,_){this.id=l,this.pluginId=s,this.pluginParam=_}}T.PluginDependency=h;class g{constructor(l,s,_,e,b=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=_,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new T.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new g(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let _=u=>u.replace(/\\/g,"/"),e=_(l),b=s.split(/\n/);for(let u=0;u<b.length;u++){let f=b[u].match(/(.*):(\d+):(\d+)\)?$/);if(f){let m=f[1],c=f[2],y=f[3],w=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(w),m=_(m),m===e){let N={line:parseInt(c,10),col:parseInt(y,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let _=0,e=this._modules2.length;_<e;_++){let b=this._modules2[_];if(!b)continue;let u=this._buildInfoPath[b.id]||null,f=this._buildInfoDefineStack[b.id]||null,m=this._buildInfoDependencies[b.id];l[s++]={id:b.strId,path:u,defineLocation:u&&f?g._findRelevantLocationInStack(u,f):null,dependencies:m,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new T.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=T.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let _=null;this._config.isBuild()&&(_=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:_,dependencies:l,callback:s}}defineModule(l,s,_,e,b,u=new n(l)){let f=this._moduleIdProvider.getModuleId(l);if(this._modules2[f]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let m=new A(f,l,this._normalizeDependencies(s,u),_,e,u);this._modules2[f]=m,this._config.isBuild()&&(this._buildInfoDefineStack[f]=b,this._buildInfoDependencies[f]=(m.dependencies||[]).map(c=>this._moduleIdProvider.getStrModuleId(c.id))),this._resolve(m)}_normalizeDependency(l,s){if(l==="exports")return i.EXPORTS;if(l==="module")return i.MODULE;if(l==="require")return i.REQUIRE;let _=l.indexOf("!");if(_>=0){let e=s.resolveModule(l.substr(0,_)),b=s.resolveModule(l.substr(_+1)),u=this._moduleIdProvider.getModuleId(e+"!"+b),f=this._moduleIdProvider.getModuleId(e);return new h(u,f,b)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let _=[],e=0;for(let b=0,u=l.length;b<u;b++)_[e++]=this._normalizeDependency(l[b],s);return _}_relativeRequire(l,s,_,e){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(T.Utilities.generateAnonymousModule(),s,_,e,null,l)}synchronousRequire(l,s=new n(l)){let _=this._normalizeDependency(l,s),e=this._modules2[_.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(l,s){let _=this._config.shouldRecordStats();s?this._config=new T.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!_&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let _=this._moduleIdProvider.getStrModuleId(l),e=(this._inverseDependencies2[l]||[]).map(u=>this._moduleIdProvider.getStrModuleId(u));const b=T.ensureError(s);return b.phase="loading",b.moduleId=_,b.neededBy=e,b}_onLoadError(l,s){const _=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new A(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let e=[];for(let f=0,m=this._moduleIdProvider.getMaxModuleId();f<m;f++)e[f]=!1;let b=!1,u=[];for(u.push(l),e[l]=!0;u.length>0;){let f=u.shift(),m=this._modules2[f];m&&(b=m.onDependencyError(_)||b);let c=this._inverseDependencies2[f];if(c)for(let y=0,w=c.length;y<w;y++){let N=c[y];e[N]||(u.push(N),e[N]=!0)}}b||this._config.onError(_)}_hasDependencyPath(l,s){let _=this._modules2[l];if(!_)return!1;let e=[];for(let u=0,f=this._moduleIdProvider.getMaxModuleId();u<f;u++)e[u]=!1;let b=[];for(b.push(_),e[l]=!0;b.length>0;){let f=b.shift().dependencies;if(f)for(let m=0,c=f.length;m<c;m++){let y=f[m];if(y.id===s)return!0;let w=this._modules2[y.id];w&&!e[y.id]&&(e[y.id]=!0,b.push(w))}}return!1}_findCyclePath(l,s,_){if(l===s||_===50)return[l];let e=this._modules2[l];if(!e)return null;let b=e.dependencies;if(b)for(let u=0,f=b.length;u<f;u++){let m=this._findCyclePath(b[u].id,s,_+1);if(m!==null)return m.push(l),m}return null}_createRequire(l){let s=(_,e,b)=>this._relativeRequire(l,_,e,b);return s.toUrl=_=>this._config.requireToUrl(l.resolveModule(_)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(_,e=!1)=>{this.configure(_,e)},s.__$__nodeRequire=T.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),_=this._config.moduleIdToPaths(s),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||e.test(s))&&_.push("node|"+s);let b=-1,u=f=>{if(b++,b>=_.length)this._onLoadError(l,f);else{let m=_[b],c=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[l]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}c.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=m),c.record(11,m),this._onLoad(l)},y=>{c.record(12,m),u(y)})}};u(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let _=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],e,null,null)};_.error=e=>{this._config.onError(this._createLoadError(s.id,e))},l.load(s.pluginParam,this._createRequire(n.ROOT),_,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let _=0,e=s.length;_<e;_++){let b=s[_];if(b===i.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===i.MODULE){l.unresolvedDependenciesCount--;continue}if(b===i.REQUIRE){l.unresolvedDependenciesCount--;continue}let u=this._modules2[b.id];if(u&&u.isComplete()){if(u.error){l.onDependencyError(u.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let f=this._findCyclePath(b.id,l.id,0)||[];f.reverse(),f.push(b.id),console.warn(f.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof h){let f=this._modules2[b.pluginId];if(f&&f.isComplete()){this._loadPluginDependency(f.exports,b);continue}let m=this._inversePluginDependencies2.get(b.pluginId);m||(m=[],this._inversePluginDependencies2.set(b.pluginId,m)),m.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let _=l.dependencies,e=[];if(_)for(let m=0,c=_.length;m<c;m++){let y=_[m];if(y===i.EXPORTS){e[m]=l.exports;continue}if(y===i.MODULE){e[m]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(y===i.REQUIRE){e[m]=this._createRequire(l.moduleIdResolver);continue}let w=this._modules2[y.id];if(w){e[m]=w.exports;continue}e[m]=null}const b=m=>(this._inverseDependencies2[m]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));l.complete(s,this._config,e,b);let u=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,u)for(let m=0,c=u.length;m<c;m++){let y=u[m],w=this._modules2[y];w.unresolvedDependenciesCount--,w.unresolvedDependenciesCount===0&&this._onModuleComplete(w)}let f=this._inversePluginDependencies2.get(l.id);if(f){this._inversePluginDependencies2.delete(l.id);for(let m=0,c=f.length;m<c;m++)this._loadPluginDependency(l.exports,f[m])}}}T.ModuleManager=g})(oe||(oe={}));var Y,oe;(function(T){const n=new T.Environment;let A=null;const M=function(L,l,s){typeof L!="string"&&(s=l,l=L,L=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),L?A.defineModule(L,l,s,null,null):A.enqueueDefineAnonymousModule(l,s)};M.amd={jQuery:!0};const i=function(L,l=!1){A.configure(L,l)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return A.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){A.defineModule(T.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=i,h.getConfig=function(){return A.getConfig().getOptionsLiteral()},h.reset=function(){A=A.reset()},h.getBuildInfo=function(){return A.getBuildInfo()},h.getStats=function(){return A.getLoaderEvents()},h.define=M;function g(){if(typeof T.global.require<"u"||typeof require<"u"){const L=T.global.require||require;if(typeof L=="function"&&typeof L.resolve=="function"){const l=T.ensureRecordedNodeRequire(A.getRecorder(),L);T.global.nodeRequire=l,h.nodeRequire=l,h.__$__nodeRequire=l}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=h:(n.isElectronRenderer||(T.global.define=M),T.global.require=h)}T.init=g,(typeof T.global.define!="function"||!T.global.define.amd)&&(A=new T.ModuleManager(n,T.createScriptLoader(n),M,h,T.Utilities.getHighPerformanceTimestamp()),typeof T.global.require<"u"&&typeof T.global.require!="function"&&h.config(T.global.require),Y=function(){return M.apply(null,arguments)},Y.amd=M.amd,typeof doNotInitLoader>"u"&&g())})(oe||(oe={}));var le=this&&this.__awaiter||function(T,n,A,M){function i(h){return h instanceof A?h:new A(function(g){g(h)})}return new(A||(A=Promise))(function(h,g){function L(_){try{s(M.next(_))}catch(e){g(e)}}function l(_){try{s(M.throw(_))}catch(e){g(e)}}function s(_){_.done?h(_.value):i(_.value).then(L,l)}s((M=M.apply(T,n||[])).next())})};Y(X[19],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let A=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function i(f,m){let c;return m.length===0?c=f:c=f.replace(/\{(\d+)\}/g,(y,w)=>{const N=w[0],p=m[N];let S=y;return typeof p=="string"?S=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(S=String(p)),S}),A&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function h(f,m){let c=f[m];return c||(c=f["*"],c)?c:null}function g(f){return f.charAt(f.length-1)==="/"?f:f+"/"}function L(f,m,c){return le(this,void 0,void 0,function*(){const y=g(f)+g(m)+"vscode/"+g(c),w=yield fetch(y);if(w.ok)return yield w.json();throw new Error(`${w.status} - ${w.statusText}`)})}function l(f){return function(m,c){const y=Array.prototype.slice.call(arguments,2);return i(f[m],y)}}function s(f,m,...c){return i(m,c)}n.localize=s;function _(f){}n.getConfiguredDefaultLocale=_;function e(f){A=f}n.setPseudoTranslation=e;function b(f,m){var c;return{localize:l(m[f]),getConfiguredDefaultLocale:(c=m.getConfiguredDefaultLocale)!==null&&c!==void 0?c:y=>{}}}n.create=b;function u(f,m,c,y){var w;const N=(w=y["vs/nls"])!==null&&w!==void 0?w:{};if(!f||f.length===0)return c({localize:s,getConfiguredDefaultLocale:()=>{var a;return(a=N.availableLanguages)===null||a===void 0?void 0:a["*"]}});const p=N.availableLanguages?h(N.availableLanguages,f):null,S=p===null||p===M;let r=".nls";S||(r=r+"."+p);const o=a=>{Array.isArray(a)?a.localize=l(a):a.localize=l(a[f]),a.getConfiguredDefaultLocale=()=>{var v;return(v=N.availableLanguages)===null||v===void 0?void 0:v["*"]},c(a)};typeof N.loadBundle=="function"?N.loadBundle(f,p,(a,v)=>{a?m([f+".nls"],o):o(v)}):N.translationServiceUrl&&!S?le(this,void 0,void 0,function*(){var a;try{const v=yield L(N.translationServiceUrl,p,f);return o(v)}catch(v){if(!p.includes("-"))return console.error(v),m([f+".nls"],o);try{const d=p.split("-")[0],C=yield L(N.translationServiceUrl,d,f);return(a=N.availableLanguages)!==null&&a!==void 0||(N.availableLanguages={}),N.availableLanguages["*"]=d,o(C)}catch(d){return console.error(d),m([f+".nls"],o)}}}):m([f+r],o,a=>{if(r===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${p}. Falling back to the default language:`,a),m([f+".nls"],o)})}n.load=u}),function(){const T=globalThis.MonacoEnvironment,n=T&&T.baseUrl?T.baseUrl:"../../../";function A(_,e){var b;if(T?.createTrustedTypesPolicy)try{return T.createTrustedTypesPolicy(_,e)}catch(u){console.warn(u);return}try{return(b=self.trustedTypes)===null||b===void 0?void 0:b.createPolicy(_,e)}catch(u){console.warn(u);return}}const M=A("amdLoader",{createScriptURL:_=>_,createScript:(_,...e)=>{const b=e.slice(0,-1).join(","),u=e.pop().toString();return`(function anonymous(${b}) { ${u}
})`}});function i(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((_,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return _();const b=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(b).then(f=>{if(f.status!==200)throw new Error(f.statusText);return f.text()}).then(f=>{f=`${f}
//# sourceURL=${b}`,(M?globalThis.eval(M.createScript("",f)):new Function(f)).call(globalThis),_()}).then(void 0,e);return}M?importScripts(M.createScriptURL(b)):importScripts(b),_()})}function g(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function L(_){h().then(()=>{g(),require([_],function(e){setTimeout(function(){const b=e.create((u,f)=>{globalThis.postMessage(u,f)},null);for(globalThis.onmessage=u=>b.onmessage(u.data,u.ports);s.length>0;){const u=s.shift();b.onmessage(u.data,u.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&g();let l=!0;const s=[];globalThis.onmessage=_=>{if(!l){s.push(_);return}l=!1,L(_.data)}}(),Y(X[8],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.reverseOrder=n.booleanComparator=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.forEachAdjacent=n.groupAdjacentBy=n.groupBy=n.quickSelect=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function A(x,k=0){return x[x.length-(1+k)]}n.tail=A;function M(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}n.tail2=M;function i(x,k,O=(W,z)=>W===z){if(x===k)return!0;if(!x||!k||x.length!==k.length)return!1;for(let W=0,z=x.length;W<z;W++)if(!O(x[W],k[W]))return!1;return!0}n.equals=i;function h(x,k){const O=x.length-1;k<O&&(x[k]=x[O]),x.pop()}n.removeFastWithoutKeepingOrder=h;function g(x,k,O){return L(x.length,W=>O(x[W],k))}n.binarySearch=g;function L(x,k){let O=0,W=x-1;for(;O<=W;){const z=(O+W)/2|0,G=k(z);if(G<0)O=z+1;else if(G>0)W=z-1;else return z}return-(O+1)}n.binarySearch2=L;function l(x,k,O){if(x=x|0,x>=k.length)throw new TypeError("invalid index");const W=k[Math.floor(k.length*Math.random())],z=[],G=[],t=[];for(const ne of k){const se=O(ne,W);se<0?z.push(ne):se>0?G.push(ne):t.push(ne)}return x<z.length?l(x,z,O):x<z.length+t.length?t[0]:l(x-(z.length+t.length),G,O)}n.quickSelect=l;function s(x,k){const O=[];let W;for(const z of x.slice(0).sort(k))!W||k(W[0],z)!==0?(W=[z],O.push(W)):W.push(z);return O}n.groupBy=s;function*_(x,k){let O,W;for(const z of x)W!==void 0&&k(W,z)?O.push(z):(O&&(yield O),O=[z]),W=z;O&&(yield O)}n.groupAdjacentBy=_;function e(x,k){for(let O=0;O<=x.length;O++)k(O===0?void 0:x[O-1],O===x.length?void 0:x[O])}n.forEachAdjacent=e;function b(x){return x.filter(k=>!!k)}n.coalesce=b;function u(x){let k=0;for(let O=0;O<x.length;O++)x[O]&&(x[k]=x[O],k+=1);x.length=k}n.coalesceInPlace=u;function f(x){return!Array.isArray(x)||x.length===0}n.isFalsyOrEmpty=f;function m(x){return Array.isArray(x)&&x.length>0}n.isNonEmptyArray=m;function c(x,k=O=>O){const O=new Set;return x.filter(W=>{const z=k(W);return O.has(z)?!1:(O.add(z),!0)})}n.distinct=c;function y(x,k){return x.length>0?x[0]:k}n.firstOrDefault=y;function w(x,k){let O=typeof k=="number"?x:0;typeof k=="number"?O=x:(O=0,k=x);const W=[];if(O<=k)for(let z=O;z<k;z++)W.push(z);else for(let z=O;z>k;z--)W.push(z);return W}n.range=w;function N(x,k,O){const W=x.slice(0,k),z=x.slice(k);return W.concat(O,z)}n.arrayInsert=N;function p(x,k){const O=x.indexOf(k);O>-1&&(x.splice(O,1),x.unshift(k))}n.pushToStart=p;function S(x,k){const O=x.indexOf(k);O>-1&&(x.splice(O,1),x.push(k))}n.pushToEnd=S;function r(x,k){for(const O of k)x.push(O)}n.pushMany=r;function o(x){return Array.isArray(x)?x:[x]}n.asArray=o;function a(x,k,O){const W=d(x,k),z=x.length,G=O.length;x.length=z+G;for(let t=z-1;t>=W;t--)x[t+G]=x[t];for(let t=0;t<G;t++)x[t+W]=O[t]}n.insertInto=a;function v(x,k,O,W){const z=d(x,k);let G=x.splice(z,O);return G===void 0&&(G=[]),a(x,z,W),G}n.splice=v;function d(x,k){return k<0?Math.max(k+x.length,0):Math.min(k,x.length)}var C;(function(x){function k(G){return G<0}x.isLessThan=k;function O(G){return G<=0}x.isLessThanOrEqual=O;function W(G){return G>0}x.isGreaterThan=W;function z(G){return G===0}x.isNeitherLessOrGreaterThan=z,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(C||(n.CompareResult=C={}));function R(x,k){return(O,W)=>k(x(O),x(W))}n.compareBy=R;function E(...x){return(k,O)=>{for(const W of x){const z=W(k,O);if(!C.isNeitherLessOrGreaterThan(z))return z}return C.neitherLessOrGreaterThan}}n.tieBreakComparators=E;const D=(x,k)=>x-k;n.numberComparator=D;const F=(x,k)=>(0,n.numberComparator)(x?1:0,k?1:0);n.booleanComparator=F;function B(x){return(k,O)=>-x(k,O)}n.reverseOrder=B;class I{constructor(k){this.items=k,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(k){let O=this.firstIdx;for(;O<this.items.length&&k(this.items[O]);)O++;const W=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,W}takeFromEndWhile(k){let O=this.lastIdx;for(;O>=0&&k(this.items[O]);)O--;const W=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,W}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const k=this.items[this.firstIdx];return this.firstIdx++,k}takeCount(k){const O=this.items.slice(this.firstIdx,this.firstIdx+k);return this.firstIdx+=k,O}}n.ArrayQueue=I;class U{constructor(k){this.iterate=k}toArray(){const k=[];return this.iterate(O=>(k.push(O),!0)),k}filter(k){return new U(O=>this.iterate(W=>k(W)?O(W):!0))}map(k){return new U(O=>this.iterate(W=>O(k(W))))}findLast(k){let O;return this.iterate(W=>(k(W)&&(O=W),!0)),O}findLastMaxBy(k){let O,W=!0;return this.iterate(z=>((W||C.isGreaterThan(k(z,O)))&&(W=!1,O=z),!0)),O}}n.CallbackIterable=U,U.empty=new U(x=>{})}),Y(X[11],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.mapFindFirst=n.findMaxIdxBy=n.findFirstMinBy=n.findLastMaxBy=n.findFirstMaxBy=n.MonotonousArray=n.findFirstIdxMonotonousOrArrLen=n.findFirstMonotonous=n.findLastIdxMonotonous=n.findLastMonotonous=n.findLastIdx=n.findLast=void 0;function A(f,m){const c=M(f,m);if(c!==-1)return f[c]}n.findLast=A;function M(f,m){for(let c=f.length-1;c>=0;c--){const y=f[c];if(m(y))return c}return-1}n.findLastIdx=M;function i(f,m){const c=h(f,m);return c===-1?void 0:f[c]}n.findLastMonotonous=i;function h(f,m,c=0,y=f.length){let w=c,N=y;for(;w<N;){const p=Math.floor((w+N)/2);m(f[p])?w=p+1:N=p}return w-1}n.findLastIdxMonotonous=h;function g(f,m){const c=L(f,m);return c===f.length?void 0:f[c]}n.findFirstMonotonous=g;function L(f,m,c=0,y=f.length){let w=c,N=y;for(;w<N;){const p=Math.floor((w+N)/2);m(f[p])?N=p:w=p+1}return w}n.findFirstIdxMonotonousOrArrLen=L;class l{constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const y of this._array)if(this._prevFindLastPredicate(y)&&!m(y))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const c=h(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=c+1,c===-1?void 0:this._array[c]}}n.MonotonousArray=l,l.assertInvariants=!1;function s(f,m){if(f.length===0)return;let c=f[0];for(let y=1;y<f.length;y++){const w=f[y];m(w,c)>0&&(c=w)}return c}n.findFirstMaxBy=s;function _(f,m){if(f.length===0)return;let c=f[0];for(let y=1;y<f.length;y++){const w=f[y];m(w,c)>=0&&(c=w)}return c}n.findLastMaxBy=_;function e(f,m){return s(f,(c,y)=>-m(c,y))}n.findFirstMinBy=e;function b(f,m){if(f.length===0)return-1;let c=0;for(let y=1;y<f.length;y++){const w=f[y];m(w,f[c])>0&&(c=y)}return c}n.findMaxIdxBy=b;function u(f,m){for(const c of f){const y=m(c);if(y!==void 0)return y}}n.mapFindFirst=u}),Y(X[32],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class A{constructor(h){this.fn=h,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const g=JSON.stringify(h);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(h)),this.lastCache}}n.LRUCachedFunction=A;class M{get cachedValues(){return this._map}constructor(h){this.fn=h,this._map=new Map}get(h){if(this._map.has(h))return this._map.get(h);const g=this.fn(h);return this._map.set(h,g),g}}n.CachedFunction=M}),Y(X[33],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.diffSets=void 0;function A(i,h){const g=[],L=[];for(const l of i)h.has(l)||g.push(l);for(const l of h)i.has(l)||L.push(l);return{removed:g,added:L}}n.diffSets=A;class M{constructor(){this.map=new Map}add(h,g){let L=this.map.get(h);L||(L=new Set,this.map.set(h,L)),L.add(g)}delete(h,g){const L=this.map.get(h);L&&(L.delete(g),L.size===0&&this.map.delete(h))}forEach(h,g){const L=this.map.get(h);L&&L.forEach(g)}get(h){const g=this.map.get(h);return g||new Set}}n.SetMap=M}),Y(X[34],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function A(L,l){const s=Math.pow(10,l);return Math.round(L*s)/s}class M{constructor(l,s,_,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,_))|0,this.a=A(Math.max(Math.min(1,e),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}n.RGBA=M;class i{constructor(l,s,_,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=A(Math.max(Math.min(1,s),0),3),this.l=A(Math.max(Math.min(1,_),0),3),this.a=A(Math.max(Math.min(1,e),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,_=l.g/255,e=l.b/255,b=l.a,u=Math.max(s,_,e),f=Math.min(s,_,e);let m=0,c=0;const y=(f+u)/2,w=u-f;if(w>0){switch(c=Math.min(y<=.5?w/(2*y):w/(2-2*y),1),u){case s:m=(_-e)/w+(_<e?6:0);break;case _:m=(e-s)/w+2;break;case e:m=(s-_)/w+4;break}m*=60,m=Math.round(m)}return new i(m,c,y,b)}static _hue2rgb(l,s,_){return _<0&&(_+=1),_>1&&(_-=1),_<1/6?l+(s-l)*6*_:_<1/2?s:_<2/3?l+(s-l)*(2/3-_)*6:l}static toRGBA(l){const s=l.h/360,{s:_,l:e,a:b}=l;let u,f,m;if(_===0)u=f=m=e;else{const c=e<.5?e*(1+_):e+_-e*_,y=2*e-c;u=i._hue2rgb(y,c,s+1/3),f=i._hue2rgb(y,c,s),m=i._hue2rgb(y,c,s-1/3)}return new M(Math.round(u*255),Math.round(f*255),Math.round(m*255),b)}}n.HSLA=i;class h{constructor(l,s,_,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=A(Math.max(Math.min(1,s),0),3),this.v=A(Math.max(Math.min(1,_),0),3),this.a=A(Math.max(Math.min(1,e),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,_=l.g/255,e=l.b/255,b=Math.max(s,_,e),u=Math.min(s,_,e),f=b-u,m=b===0?0:f/b;let c;return f===0?c=0:b===s?c=((_-e)/f%6+6)%6:b===_?c=(e-s)/f+2:c=(s-_)/f+4,new h(Math.round(c*60),m,b,l.a)}static toRGBA(l){const{h:s,s:_,v:e,a:b}=l,u=e*_,f=u*(1-Math.abs(s/60%2-1)),m=e-u;let[c,y,w]=[0,0,0];return s<60?(c=u,y=f):s<120?(c=f,y=u):s<180?(y=u,w=f):s<240?(y=f,w=u):s<300?(c=f,w=u):s<=360&&(c=u,w=f),c=Math.round((c+m)*255),y=Math.round((y+m)*255),w=Math.round((w+m)*255),new M(c,y,w,b)}}n.HSVA=h;class g{static fromHex(l){return g.Format.CSS.parseHex(l)||g.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:h.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof M)this.rgba=l;else if(l instanceof i)this._hsla=l,this.rgba=i.toRGBA(l);else if(l instanceof h)this._hsva=l,this.rgba=h.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&M.equals(this.rgba,l.rgba)&&i.equals(this.hsla,l.hsla)&&h.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=g._relativeLuminanceForComponent(this.rgba.r),s=g._relativeLuminanceForComponent(this.rgba.g),_=g._relativeLuminanceForComponent(this.rgba.b),e=.2126*l+.7152*s+.0722*_;return A(e,4)}static _relativeLuminanceForComponent(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),_=l.getRelativeLuminance();return s>_}isDarkerThan(l){const s=this.getRelativeLuminance(),_=l.getRelativeLuminance();return s<_}lighten(l){return new g(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new g(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g:_,b:e,a:b}=this.rgba;return new g(new M(s,_,e,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new g(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g:_,b:e,a:b}=this.rgba;return new g(new M(l.rgba.r-b*(l.rgba.r-s),l.rgba.g-b*(l.rgba.g-_),l.rgba.b-b*(l.rgba.b-e),1))}toString(){return this._toString||(this._toString=g.Format.CSS.format(this)),this._toString}static getLighterColor(l,s,_){if(l.isLighterThan(s))return l;_=_||.5;const e=l.getRelativeLuminance(),b=s.getRelativeLuminance();return _=_*(b-e)/b,l.lighten(_)}static getDarkerColor(l,s,_){if(l.isDarkerThan(s))return l;_=_||.5;const e=l.getRelativeLuminance(),b=s.getRelativeLuminance();return _=_*(e-b)/e,l.darken(_)}}n.Color=g,g.white=new g(new M(255,255,255,1)),g.black=new g(new M(0,0,0,1)),g.red=new g(new M(255,0,0,1)),g.blue=new g(new M(0,0,255,1)),g.green=new g(new M(0,255,0,1)),g.cyan=new g(new M(0,255,255,1)),g.lightgrey=new g(new M(211,211,211,1)),g.transparent=new g(new M(0,0,0,0)),function(L){let l;(function(s){let _;(function(e){function b(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:L.Format.CSS.formatRGBA(r)}e.formatRGB=b;function u(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=u;function f(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:L.Format.CSS.formatHSLA(r)}e.formatHSL=f;function m(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=m;function c(r){const o=r.toString(16);return o.length!==2?"0"+o:o}function y(r){return`#${c(r.rgba.r)}${c(r.rgba.g)}${c(r.rgba.b)}`}e.formatHex=y;function w(r,o=!1){return o&&r.rgba.a===1?L.Format.CSS.formatHex(r):`#${c(r.rgba.r)}${c(r.rgba.g)}${c(r.rgba.b)}${c(Math.round(r.rgba.a*255))}`}e.formatHexA=w;function N(r){return r.isOpaque()?L.Format.CSS.formatHex(r):L.Format.CSS.formatRGBA(r)}e.format=N;function p(r){const o=r.length;if(o===0||r.charCodeAt(0)!==35)return null;if(o===7){const a=16*S(r.charCodeAt(1))+S(r.charCodeAt(2)),v=16*S(r.charCodeAt(3))+S(r.charCodeAt(4)),d=16*S(r.charCodeAt(5))+S(r.charCodeAt(6));return new L(new M(a,v,d,1))}if(o===9){const a=16*S(r.charCodeAt(1))+S(r.charCodeAt(2)),v=16*S(r.charCodeAt(3))+S(r.charCodeAt(4)),d=16*S(r.charCodeAt(5))+S(r.charCodeAt(6)),C=16*S(r.charCodeAt(7))+S(r.charCodeAt(8));return new L(new M(a,v,d,C/255))}if(o===4){const a=S(r.charCodeAt(1)),v=S(r.charCodeAt(2)),d=S(r.charCodeAt(3));return new L(new M(16*a+a,16*v+v,16*d+d))}if(o===5){const a=S(r.charCodeAt(1)),v=S(r.charCodeAt(2)),d=S(r.charCodeAt(3)),C=S(r.charCodeAt(4));return new L(new M(16*a+a,16*v+v,16*d+d,(16*C+C)/255))}return null}e.parseHex=p;function S(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(_=s.CSS||(s.CSS={}))})(l=L.Format||(L.Format={}))}(g||(n.Color=g={}))}),Y(X[35],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class A{constructor(i,h,g,L){this.originalStart=i,this.originalLength=h,this.modifiedStart=g,this.modifiedLength=L}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=A}),Y(X[5],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class A{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?u.isErrorNoTelemetry(c)?new u(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}emit(c){this.listeners.forEach(y=>{y(c)})}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}n.ErrorHandler=A,n.errorHandler=new A;function M(m){L(m)||n.errorHandler.onUnexpectedError(m)}n.onUnexpectedError=M;function i(m){L(m)||n.errorHandler.onUnexpectedExternalError(m)}n.onUnexpectedExternalError=i;function h(m){if(m instanceof Error){const{name:c,message:y}=m,w=m.stacktrace||m.stack;return{$isError:!0,name:c,message:y,stack:w,noTelemetry:u.isErrorNoTelemetry(m)}}return m}n.transformErrorForSerialization=h;const g="Canceled";function L(m){return m instanceof l?!0:m instanceof Error&&m.name===g&&m.message===g}n.isCancellationError=L;class l extends Error{constructor(){super(g),this.name=this.message}}n.CancellationError=l;function s(){const m=new Error(g);return m.name=m.message,m}n.canceled=s;function _(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}n.illegalArgument=_;function e(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}n.illegalState=e;class b extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}n.NotSupportedError=b;class u extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof u)return c;const y=new u;return y.message=c.message,y.stack=c.stack,y}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}n.ErrorNoTelemetry=u;class f extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}n.BugIndicatingError=f}),Y(X[12],J([0,1,5]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function M(L,l){if(!L)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}n.ok=M;function i(L,l="Unreachable"){throw new Error(l)}n.assertNever=i;function h(L){if(!L()){debugger;L(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}n.assertFn=h;function g(L,l){let s=0;for(;s<L.length-1;){const _=L[s],e=L[s+1];if(!l(_,e))return!1;s++}return!0}n.checkAdjacentItems=g}),Y(X[20],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function A(M){const i=this;let h=!1,g;return function(){return h||(h=!0,g=M.apply(i,arguments)),g}}n.once=A}),Y(X[21],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var A;(function(M){function i(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}M.is=i;const h=Object.freeze([]);function g(){return h}M.empty=g;function*L(p){yield p}M.single=L;function l(p){return i(p)?p:L(p)}M.wrap=l;function s(p){return p||h}M.from=s;function _(p){return!p||p[Symbol.iterator]().next().done===!0}M.isEmpty=_;function e(p){return p[Symbol.iterator]().next().value}M.first=e;function b(p,S){for(const r of p)if(S(r))return!0;return!1}M.some=b;function u(p,S){for(const r of p)if(S(r))return r}M.find=u;function*f(p,S){for(const r of p)S(r)&&(yield r)}M.filter=f;function*m(p,S){let r=0;for(const o of p)yield S(o,r++)}M.map=m;function*c(...p){for(const S of p)for(const r of S)yield r}M.concat=c;function y(p,S,r){let o=r;for(const a of p)o=S(o,a);return o}M.reduce=y;function*w(p,S,r=p.length){for(S<0&&(S+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);S<r;S++)yield p[S]}M.slice=w;function N(p,S=Number.POSITIVE_INFINITY){const r=[];if(S===0)return[r,p];const o=p[Symbol.iterator]();for(let a=0;a<S;a++){const v=o.next();if(v.done)return[r,M.empty()];r.push(v.value)}return[r,{[Symbol.iterator](){return o}}]}M.consume=N})(A||(n.Iterable=A={}))}),Y(X[36],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,u){this._keyCodeToStr[b]=u,this._strToKeyCode[u.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||0}}const M=new A,i=new A,h=new A;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],L=Object.create(null),l=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",b=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],u=[],f=[];for(const m of b){const[c,y,w,N,p,S,r,o,a]=m;if(f[y]||(f[y]=!0,g[y]=w,L[w]=y,l[w.toLowerCase()]=y,c&&(n.IMMUTABLE_CODE_TO_KEY_CODE[y]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[N]=y))),!u[N]){if(u[N]=!0,!p)throw new Error(`String representation missing for key code ${N} around scan code ${w}`);M.define(N,p),i.define(N,o||p),h.define(N,a||o||p)}S&&(n.EVENT_KEY_CODE_MAP[S]=N),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=N)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var s;(function(e){function b(w){return M.keyCodeToStr(w)}e.toString=b;function u(w){return M.strToKeyCode(w)}e.fromString=u;function f(w){return i.keyCodeToStr(w)}e.toUserSettingsUS=f;function m(w){return h.keyCodeToStr(w)}e.toUserSettingsGeneral=m;function c(w){return i.strToKeyCode(w)||h.strToKeyCode(w)}e.fromUserSettings=c;function y(w){if(w>=98&&w<=113)return null;switch(w){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(w)}e.toElectronAccelerator=y})(s||(n.KeyCodeUtils=s={}));function _(e,b){const u=(b&65535)<<16>>>0;return(e|u)>>>0}n.KeyChord=_}),Y(X[37],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class A{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=A}),Y(X[13],J([0,1,20,21]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let h=null;function g(r){h=r}if(n.setDisposableTracker=g,i){const r="__is_disposable_tracked__";g(new class{trackDisposable(o){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(a)},3e3)}setParent(o,a){if(o&&o!==y.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==y.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function L(r){return h?.trackDisposable(r),r}function l(r){h?.markAsDisposed(r)}function s(r,o){h?.setParent(r,o)}function _(r,o){if(h)for(const a of r)h.setParent(a,o)}function e(r){return h?.markAsSingleton(r),r}n.markAsSingleton=e;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=b;function u(r){if(M.Iterable.is(r)){const o=[];for(const a of r)if(a)try{a.dispose()}catch(v){o.push(v)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=u;function f(...r){const o=m(()=>u(r));return _(r,o),o}n.combinedDisposable=f;function m(r){const o=L({dispose:(0,A.once)(()=>{l(o),r()})});return o}n.toDisposable=m;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1,L(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return s(o,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}n.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new c,L(this),s(this._store,this)}dispose(){l(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}n.Disposable=y,y.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,L(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var a;this._isDisposed||o===this._value||((a=this._value)===null||a===void 0||a.dispose(),o&&s(o,this),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,l(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}n.MutableDisposable=w;class N{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=N;class p{constructor(o){this.object=o}dispose(){}}n.ImmortalReference=p;class S{constructor(){this._store=new Map,this._isDisposed=!1,L(this)}dispose(){l(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}get(o){return this._store.get(o)}set(o,a,v=!1){var d;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),v||(d=this._store.get(o))===null||d===void 0||d.dispose(),this._store.set(o,a)}deleteAndDispose(o){var a;(a=this._store.get(o))===null||a===void 0||a.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=S}),Y(X[22],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class A{constructor(h){this.element=h,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class M{constructor(){this._first=A.Undefined,this._last=A.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===A.Undefined}clear(){let h=this._first;for(;h!==A.Undefined;){const g=h.next;h.prev=A.Undefined,h.next=A.Undefined,h=g}this._first=A.Undefined,this._last=A.Undefined,this._size=0}unshift(h){return this._insert(h,!1)}push(h){return this._insert(h,!0)}_insert(h,g){const L=new A(h);if(this._first===A.Undefined)this._first=L,this._last=L;else if(g){const s=this._last;this._last=L,L.prev=s,s.next=L}else{const s=this._first;this._first=L,L.next=s,s.prev=L}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(L))}}shift(){if(this._first!==A.Undefined){const h=this._first.element;return this._remove(this._first),h}}pop(){if(this._last!==A.Undefined){const h=this._last.element;return this._remove(this._last),h}}_remove(h){if(h.prev!==A.Undefined&&h.next!==A.Undefined){const g=h.prev;g.next=h.next,h.next.prev=g}else h.prev===A.Undefined&&h.next===A.Undefined?(this._first=A.Undefined,this._last=A.Undefined):h.next===A.Undefined?(this._last=this._last.prev,this._last.next=A.Undefined):h.prev===A.Undefined&&(this._first=this._first.next,this._first.prev=A.Undefined);this._size-=1}*[Symbol.iterator](){let h=this._first;for(;h!==A.Undefined;)yield h.element,h=h.next}}n.LinkedList=M}),Y(X[23],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(h){return new M(h)}constructor(h){this._now=A&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=M}),Y(X[9],J([0,1,5,20,13,22,23]),function(T,n,A,M,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const L=!1,l=!1;var s;(function(d){d.None=()=>i.Disposable.None;function C(Z){if(l){const{onDidAddListener:H}=Z,$=u.create();let Q=0;Z.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$.print()),H?.()}}}function R(Z,H){return W(Z,()=>{},0,void 0,!0,void 0,H)}d.defer=R;function E(Z){return(H,$=null,Q)=>{let K=!1,te;return te=Z(P=>{if(!K)return te?te.dispose():K=!0,H.call($,P)},null,Q),K&&te.dispose(),te}}d.once=E;function D(Z,H,$){return k((Q,K=null,te)=>Z(P=>Q.call(K,H(P)),null,te),$)}d.map=D;function F(Z,H,$){return k((Q,K=null,te)=>Z(P=>{H(P),Q.call(K,P)},null,te),$)}d.forEach=F;function B(Z,H,$){return k((Q,K=null,te)=>Z(P=>H(P)&&Q.call(K,P),null,te),$)}d.filter=B;function I(Z){return Z}d.signal=I;function U(...Z){return(H,$=null,Q)=>{const K=(0,i.combinedDisposable)(...Z.map(te=>te(P=>H.call($,P))));return O(K,Q)}}d.any=U;function x(Z,H,$,Q){let K=$;return D(Z,te=>(K=H(K,te),K),Q)}d.reduce=x;function k(Z,H){let $;const Q={onWillAddFirstListener(){$=Z(K.fire,K)},onDidRemoveLastListener(){$?.dispose()}};H||C(Q);const K=new y(Q);return H?.add(K),K.event}function O(Z,H){return H instanceof Array?H.push(Z):H&&H.add(Z),Z}function W(Z,H,$=100,Q=!1,K=!1,te,P){let q,V,j,ee=0,ie;const ae={leakWarningThreshold:te,onWillAddFirstListener(){q=Z(fe=>{ee++,V=H(V,fe),Q&&!j&&(ce.fire(V),V=void 0),ie=()=>{const re=V;V=void 0,j=void 0,(!Q||ee>1)&&ce.fire(re),ee=0},typeof $=="number"?(clearTimeout(j),j=setTimeout(ie,$)):j===void 0&&(j=0,queueMicrotask(ie))})},onWillRemoveListener(){K&&ee>0&&ie?.()},onDidRemoveLastListener(){ie=void 0,q.dispose()}};P||C(ae);const ce=new y(ae);return P?.add(ce),ce.event}d.debounce=W;function z(Z,H=0,$){return d.debounce(Z,(Q,K)=>Q?(Q.push(K),Q):[K],H,void 0,!0,void 0,$)}d.accumulate=z;function G(Z,H=(Q,K)=>Q===K,$){let Q=!0,K;return B(Z,te=>{const P=Q||!H(te,K);return Q=!1,K=te,P},$)}d.latch=G;function t(Z,H,$){return[d.filter(Z,H,$),d.filter(Z,Q=>!H(Q),$)]}d.split=t;function ne(Z,H=!1,$=[]){let Q=$.slice(),K=Z(q=>{Q?Q.push(q):P.fire(q)});const te=()=>{Q?.forEach(q=>P.fire(q)),Q=null},P=new y({onWillAddFirstListener(){K||(K=Z(q=>P.fire(q)))},onDidAddFirstListener(){Q&&(H?setTimeout(te):te())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return P.event}d.buffer=ne;function se(Z,H){return(Q,K,te)=>{const P=H(new me);return Z(function(q){const V=P.evaluate(q);V!==ue&&Q.call(K,V)},void 0,te)}}d.chain=se;const ue=Symbol("HaltChainable");class me{constructor(){this.steps=[]}map(H){return this.steps.push(H),this}forEach(H){return this.steps.push($=>(H($),$)),this}filter(H){return this.steps.push($=>H($)?$:ue),this}reduce(H,$){let Q=$;return this.steps.push(K=>(Q=H(Q,K),Q)),this}latch(H=($,Q)=>$===Q){let $=!0,Q;return this.steps.push(K=>{const te=$||!H(K,Q);return $=!1,Q=K,te?K:ue}),this}evaluate(H){for(const $ of this.steps)if(H=$(H),H===ue)break;return H}}function Le(Z,H,$=Q=>Q){const Q=(...q)=>P.fire($(...q)),K=()=>Z.on(H,Q),te=()=>Z.removeListener(H,Q),P=new y({onWillAddFirstListener:K,onDidRemoveLastListener:te});return P.event}d.fromNodeEventEmitter=Le;function pe(Z,H,$=Q=>Q){const Q=(...q)=>P.fire($(...q)),K=()=>Z.addEventListener(H,Q),te=()=>Z.removeEventListener(H,Q),P=new y({onWillAddFirstListener:K,onDidRemoveLastListener:te});return P.event}d.fromDOMEventEmitter=pe;function Ce(Z){return new Promise(H=>E(Z)(H))}d.toPromise=Ce;function be(Z){const H=new y;return Z.then($=>{H.fire($)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}d.fromPromise=be;function we(Z,H){return H(void 0),Z($=>H($))}d.runAndSubscribe=we;function Se(Z,H){let $=null;function Q(te){$?.dispose(),$=new i.DisposableStore,H(te,$)}Q(void 0);const K=Z(te=>Q(te));return(0,i.toDisposable)(()=>{K.dispose(),$?.dispose()})}d.runAndSubscribeWithStore=Se;class ye{constructor(H,$){this._observable=H,this._counter=0,this._hasChanged=!1;const Q={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};$||C(Q),this.emitter=new y(Q),$&&$.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,$){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function _e(Z,H){return new ye(Z,H).emitter.event}d.fromObservable=_e;function de(Z){return H=>{let $=0,Q=!1;const K={beginUpdate(){$++},endUpdate(){$--,$===0&&(Z.reportChanges(),Q&&(Q=!1,H()))},handlePossibleChange(){},handleChange(){Q=!0}};return Z.addObserver(K),Z.reportChanges(),{dispose(){Z.removeObserver(K)}}}}d.fromObservableLight=de})(s||(n.Event=s={}));class _{constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${_._idPool++}`,_.all.add(this)}start(C){this._stopWatch=new g.StopWatch,this.listenerCount=C}stop(){if(this._stopWatch){const C=this._stopWatch.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=_,_.all=new Set,_._idPool=0;let e=-1;class b{constructor(C,R=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=R,this._warnCountdown=0}dispose(){var C;(C=this._stacks)===null||C===void 0||C.clear()}check(C,R){const E=this.threshold;if(E<=0||R<E)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(C.value)||0;if(this._stacks.set(C.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let F,B=0;for(const[I,U]of this._stacks)(!F||B<U)&&(F=I,B=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${B}):`),console.warn(F)}return()=>{const F=this._stacks.get(C.value)||0;this._stacks.set(C.value,F-1)}}}class u{static create(){var C;return new u((C=new Error().stack)!==null&&C!==void 0?C:"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(C){this.value=C}}const m=2,c=(d,C)=>{if(d instanceof f)C(d);else for(let R=0;R<d.length;R++){const E=d[R];E&&C(E)}};class y{constructor(C){var R,E,D,F,B;this._size=0,this._options=C,this._leakageMon=e>0||!((R=this._options)===null||R===void 0)&&R.leakWarningThreshold?new b((D=(E=this._options)===null||E===void 0?void 0:E.leakWarningThreshold)!==null&&D!==void 0?D:e):void 0,this._perfMon=!((F=this._options)===null||F===void 0)&&F._profName?new _(this._options._profName):void 0,this._deliveryQueue=(B=this._options)===null||B===void 0?void 0:B.deliveryQueue}dispose(){var C,R,E,D;if(!this._disposed){if(this._disposed=!0,((C=this._deliveryQueue)===null||C===void 0?void 0:C.current)===this&&this._deliveryQueue.reset(),this._listeners){if(L){const F=this._listeners;queueMicrotask(()=>{c(F,B=>{var I;return(I=B.stack)===null||I===void 0?void 0:I.print()})})}this._listeners=void 0,this._size=0}(E=(R=this._options)===null||R===void 0?void 0:R.onDidRemoveLastListener)===null||E===void 0||E.call(R),(D=this._leakageMon)===null||D===void 0||D.dispose()}}get event(){var C;return(C=this._event)!==null&&C!==void 0||(this._event=(R,E,D)=>{var F,B,I,U,x;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;E&&(R=R.bind(E));const k=new f(R);let O,W;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(k.stack=u.create(),O=this._leakageMon.check(k.stack,this._size+1)),L&&(k.stack=W??u.create()),this._listeners?this._listeners instanceof f?((x=this._deliveryQueue)!==null&&x!==void 0||(this._deliveryQueue=new N),this._listeners=[this._listeners,k]):this._listeners.push(k):((B=(F=this._options)===null||F===void 0?void 0:F.onWillAddFirstListener)===null||B===void 0||B.call(F,this),this._listeners=k,(U=(I=this._options)===null||I===void 0?void 0:I.onDidAddFirstListener)===null||U===void 0||U.call(I,this)),this._size++;const z=(0,i.toDisposable)(()=>{O?.(),this._removeListener(k)});return D instanceof i.DisposableStore?D.add(z):Array.isArray(D)&&D.push(z),z}),this._event}_removeListener(C){var R,E,D,F;if((E=(R=this._options)===null||R===void 0?void 0:R.onWillRemoveListener)===null||E===void 0||E.call(R,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(F=(D=this._options)===null||D===void 0?void 0:D.onDidRemoveLastListener)===null||F===void 0||F.call(D,this),this._size=0;return}const B=this._listeners,I=B.indexOf(C);if(I===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,B[I]=void 0;const U=this._deliveryQueue.current===this;if(this._size*m<=B.length){let x=0;for(let k=0;k<B.length;k++)B[k]?B[x++]=B[k]:U&&(this._deliveryQueue.end--,x<this._deliveryQueue.i&&this._deliveryQueue.i--);B.length=x}}_deliver(C,R){var E;if(!C)return;const D=((E=this._options)===null||E===void 0?void 0:E.onListenerError)||A.onUnexpectedError;if(!D){C.value(R);return}try{C.value(R)}catch(F){D(F)}}_deliverQueue(C){const R=C.current._listeners;for(;C.i<C.end;)this._deliver(R[C.i++],C.value);C.reset()}fire(C){var R,E,D,F;if(!((R=this._deliveryQueue)===null||R===void 0)&&R.current&&(this._deliverQueue(this._deliveryQueue),(E=this._perfMon)===null||E===void 0||E.stop()),(D=this._perfMon)===null||D===void 0||D.start(this._size),this._listeners)if(this._listeners instanceof f)this._deliver(this._listeners,C);else{const B=this._deliveryQueue;B.enqueue(this,C,this._listeners.length),this._deliverQueue(B)}(F=this._perfMon)===null||F===void 0||F.stop()}hasListeners(){return this._size>0}}n.Emitter=y;const w=()=>new N;n.createEventDeliveryQueue=w;class N{constructor(){this.i=-1,this.end=0}enqueue(C,R,E){this.i=0,this.end=E,this.current=C,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class p extends y{constructor(C){super(C),this._isPaused=0,this._eventQueue=new h.LinkedList,this._mergeFn=C?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const C=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(C))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(C){this._size&&(this._isPaused!==0?this._eventQueue.push(C):super.fire(C))}}n.PauseableEmitter=p;class S extends p{constructor(C){var R;super(C),this._delay=(R=C.delay)!==null&&R!==void 0?R:100}fire(C){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(C)}}n.DebounceEmitter=S;class r extends y{constructor(C){super(C),this._queuedEvents=[],this._mergeFn=C?.merge}fire(C){this.hasListeners()&&(this._queuedEvents.push(C),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(R=>super.fire(R)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(C){const R={event:C,listener:null};this.events.push(R),this.hasListeners&&this.hook(R);const E=()=>{this.hasListeners&&this.unhook(R);const D=this.events.indexOf(R);this.events.splice(D,1)};return(0,i.toDisposable)((0,M.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(C=>this.hook(C))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(C=>this.unhook(C))}hook(C){C.listener=C.event(R=>this.emitter.fire(R))}unhook(C){C.listener&&C.listener.dispose(),C.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=o;class a{constructor(){this.buffers=[]}wrapEvent(C){return(R,E,D)=>C(F=>{const B=this.buffers[this.buffers.length-1];B?B.push(()=>R.call(E,F)):R.call(E,F)},void 0,D)}bufferEvents(C){const R=[];this.buffers.push(R);const E=C();return this.buffers.pop(),R.forEach(D=>D()),E}}n.EventBufferer=a;class v{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(C){this.inputEvent=C,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=C(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=v}),Y(X[38],J([0,1,9]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(L,l){const s=setTimeout(L.bind(l),0);return{dispose(){clearTimeout(s)}}});var i;(function(L){function l(s){return s===L.None||s===L.Cancelled||s instanceof h?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}L.isCancellationToken=l,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i||(n.CancellationToken=i={}));class h{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new A.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class g{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new h),this._token}cancel(){this._token?this._token instanceof h&&this._token.cancel():this._token=i.Cancelled}dispose(l=!1){var s;l&&this.cancel(),(s=this._parentListener)===null||s===void 0||s.dispose(),this._token?this._token instanceof h&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=g}),Y(X[6],J([0,1,32,37]),function(T,n,A,M){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function h(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=h;const g=/{(\d+)}/g;function L(P,...q){return q.length===0?P:P.replace(g,function(V,j){const ee=parseInt(j,10);return isNaN(ee)||ee<0||ee>=q.length?V:q[ee]})}n.format=L;function l(P){return P.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}n.escape=l;function s(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=s;function _(P,q=" "){const V=e(P,q);return b(V,q)}n.trim=_;function e(P,q){if(!P||!q)return P;const V=q.length;if(V===0||P.length===0)return P;let j=0;for(;P.indexOf(q,j)===j;)j=j+V;return P.substring(j)}n.ltrim=e;function b(P,q){if(!P||!q)return P;const V=q.length,j=P.length;if(V===0||j===0)return P;let ee=j,ie=-1;for(;ie=P.lastIndexOf(q,ee-1),!(ie===-1||ie+V!==ee);){if(ie===0)return"";ee=ie}return P.substring(0,ee)}n.rtrim=b;function u(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=u;function f(P){return P.replace(/\*/g,"")}n.stripWildcards=f;function m(P,q,V={}){if(!P)throw new Error("Cannot create regex from empty string");q||(P=s(P)),V.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let j="";return V.global&&(j+="g"),V.matchCase||(j+="i"),V.multiline&&(j+="m"),V.unicode&&(j+="u"),new RegExp(P,j)}n.createRegExp=m;function c(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=c;function y(P){return P.split(/\r\n|\r|\n/)}n.splitLines=y;function w(P){for(let q=0,V=P.length;q<V;q++){const j=P.charCodeAt(q);if(j!==32&&j!==9)return q}return-1}n.firstNonWhitespaceIndex=w;function N(P,q=0,V=P.length){for(let j=q;j<V;j++){const ee=P.charCodeAt(j);if(ee!==32&&ee!==9)return P.substring(q,j)}return P.substring(q,V)}n.getLeadingWhitespace=N;function p(P,q=P.length-1){for(let V=q;V>=0;V--){const j=P.charCodeAt(V);if(j!==32&&j!==9)return V}return-1}n.lastNonWhitespaceIndex=p;function S(P,q){return P<q?-1:P>q?1:0}n.compare=S;function r(P,q,V=0,j=P.length,ee=0,ie=q.length){for(;V<j&&ee<ie;V++,ee++){const fe=P.charCodeAt(V),re=q.charCodeAt(ee);if(fe<re)return-1;if(fe>re)return 1}const ae=j-V,ce=ie-ee;return ae<ce?-1:ae>ce?1:0}n.compareSubstring=r;function o(P,q){return a(P,q,0,P.length,0,q.length)}n.compareIgnoreCase=o;function a(P,q,V=0,j=P.length,ee=0,ie=q.length){for(;V<j&&ee<ie;V++,ee++){let fe=P.charCodeAt(V),re=q.charCodeAt(ee);if(fe===re)continue;if(fe>=128||re>=128)return r(P.toLowerCase(),q.toLowerCase(),V,j,ee,ie);d(fe)&&(fe-=32),d(re)&&(re-=32);const he=fe-re;if(he!==0)return he}const ae=j-V,ce=ie-ee;return ae<ce?-1:ae>ce?1:0}n.compareSubstringIgnoreCase=a;function v(P){return P>=48&&P<=57}n.isAsciiDigit=v;function d(P){return P>=97&&P<=122}n.isLowerAsciiLetter=d;function C(P){return P>=65&&P<=90}n.isUpperAsciiLetter=C;function R(P,q){return P.length===q.length&&a(P,q)===0}n.equalsIgnoreCase=R;function E(P,q){const V=q.length;return q.length>P.length?!1:a(P,q,0,V)===0}n.startsWithIgnoreCase=E;function D(P,q){const V=Math.min(P.length,q.length);let j;for(j=0;j<V;j++)if(P.charCodeAt(j)!==q.charCodeAt(j))return j;return V}n.commonPrefixLength=D;function F(P,q){const V=Math.min(P.length,q.length);let j;const ee=P.length-1,ie=q.length-1;for(j=0;j<V;j++)if(P.charCodeAt(ee-j)!==q.charCodeAt(ie-j))return j;return V}n.commonSuffixLength=F;function B(P){return 55296<=P&&P<=56319}n.isHighSurrogate=B;function I(P){return 56320<=P&&P<=57343}n.isLowSurrogate=I;function U(P,q){return(P-55296<<10)+(q-56320)+65536}n.computeCodePoint=U;function x(P,q,V){const j=P.charCodeAt(V);if(B(j)&&V+1<q){const ee=P.charCodeAt(V+1);if(I(ee))return U(j,ee)}return j}n.getNextCodePoint=x;function k(P,q){const V=P.charCodeAt(q-1);if(I(V)&&q>1){const j=P.charCodeAt(q-2);if(B(j))return U(j,V)}return V}class O{get offset(){return this._offset}constructor(q,V=0){this._str=q,this._len=q.length,this._offset=V}setOffset(q){this._offset=q}prevCodePoint(){const q=k(this._str,this._offset);return this._offset-=q>=65536?2:1,q}nextCodePoint(){const q=x(this._str,this._len,this._offset);return this._offset+=q>=65536?2:1,q}eol(){return this._offset>=this._len}}n.CodePointIterator=O;class W{get offset(){return this._iterator.offset}constructor(q,V=0){this._iterator=new O(q,V)}nextGraphemeLength(){const q=de.getInstance(),V=this._iterator,j=V.offset;let ee=q.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const ie=V.offset,ae=q.getGraphemeBreakType(V.nextCodePoint());if(_e(ee,ae)){V.setOffset(ie);break}ee=ae}return V.offset-j}prevGraphemeLength(){const q=de.getInstance(),V=this._iterator,j=V.offset;let ee=q.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const ie=V.offset,ae=q.getGraphemeBreakType(V.prevCodePoint());if(_e(ae,ee)){V.setOffset(ie);break}ee=ae}return j-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=W;function z(P,q){return new W(P,q).nextGraphemeLength()}n.nextCharLength=z;function G(P,q){return new W(P,q).prevGraphemeLength()}n.prevCharLength=G;function t(P,q){q>0&&I(P.charCodeAt(q))&&q--;const V=q+z(P,q);return[V-G(P,V),V]}n.getCharContainingOffset=t;let ne;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ue(P){return ne||(ne=se()),ne.test(P)}n.containsRTL=ue;const me=/^[\t\n\r\x20-\x7E]*$/;function Le(P){return me.test(P)}n.isBasicASCII=Le,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function pe(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=pe;function Ce(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=Ce;function be(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=be,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=we;function Se(P,q=!1){return P?(q&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=Se;function ye(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=ye;function _e(P,q){return P===0?q!==5&&q!==7:P===2&&q===3?!1:P===4||P===2||P===3||q===4||q===2||q===3?!0:!(P===8&&(q===8||q===9||q===11||q===12)||(P===11||P===9)&&(q===9||q===10)||(P===12||P===10)&&q===10||q===5||q===13||q===7||P===1||P===13&&q===14||P===6&&q===6)}class de{static getInstance(){return de._INSTANCE||(de._INSTANCE=new de),de._INSTANCE}constructor(){this._data=Z()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const V=this._data,j=V.length/3;let ee=1;for(;ee<=j;)if(q<V[3*ee])ee=2*ee;else if(q>V[3*ee+1])ee=2*ee+1;else return V[3*ee+2];return 0}}de._INSTANCE=null;function Z(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function H(P,q){if(P===0)return 0;const V=$(P,q);if(V!==void 0)return V;const j=new O(q,P);return j.prevCodePoint(),j.offset}n.getLeftDeleteOffset=H;function $(P,q){const V=new O(q,P);let j=V.prevCodePoint();for(;Q(j)||j===65039||j===8419;){if(V.offset===0)return;j=V.prevCodePoint()}if(!be(j))return;let ee=V.offset;return ee>0&&V.prevCodePoint()===8205&&(ee=V.offset),ee}function Q(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class K{static getInstance(q){return i.cache.get(Array.from(q))}static getLocales(){return i._locales.value}constructor(q){this.confusableDictionary=q}isAmbiguous(q){return this.confusableDictionary.has(q)}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=K,i=K,K.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),K.cache=new A.LRUCachedFunction(P=>{function q(re){const he=new Map;for(let ge=0;ge<re.length;ge+=2)he.set(re[ge],re[ge+1]);return he}function V(re,he){const ge=new Map(re);for(const[ve,Ne]of he)ge.set(ve,Ne);return ge}function j(re,he){if(!re)return he;const ge=new Map;for(const[ve,Ne]of re)he.has(ve)&&ge.set(ve,Ne);return ge}const ee=i.ambiguousCharacterData.value;let ie=P.filter(re=>!re.startsWith("_")&&re in ee);ie.length===0&&(ie=["_default"]);let ae;for(const re of ie){const he=q(ee[re]);ae=j(ae,he)}const ce=q(ee._common),fe=V(ce,ae);return new i(fe)}),K._locales=new M.Lazy(()=>Object.keys(i.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")));class te{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(te.getRawData())),this._data}static isInvisibleCharacter(q){return te.getData().has(q)}static get codePoints(){return te.getData()}}n.InvisibleCharacters=te,te._data=void 0}),Y(X[39],J([0,1,6]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(m){return i(m,0)}n.hash=M;function i(m,c){switch(typeof m){case"object":return m===null?h(349,c):Array.isArray(m)?l(m,c):s(m,c);case"string":return L(m,c);case"boolean":return g(m,c);case"number":return h(m,c);case"undefined":return h(937,c);default:return h(617,c)}}n.doHash=i;function h(m,c){return(c<<5)-c+m|0}n.numberHash=h;function g(m,c){return h(m?433:863,c)}function L(m,c){c=h(149417,c);for(let y=0,w=m.length;y<w;y++)c=h(m.charCodeAt(y),c);return c}n.stringHash=L;function l(m,c){return c=h(104579,c),m.reduce((y,w)=>i(w,y),c)}function s(m,c){return c=h(181387,c),Object.keys(m).sort().reduce((y,w)=>(y=L(w,y),i(m[w],y)),c)}function _(m,c,y=32){const w=y-c,N=~((1<<w)-1);return(m<<c|(N&m)>>>w)>>>0}function e(m,c=0,y=m.byteLength,w=0){for(let N=0;N<y;N++)m[c+N]=w}function b(m,c,y="0"){for(;m.length<c;)m=y+m;return m}function u(m,c=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(y=>y.toString(16).padStart(2,"0")).join(""):b((m>>>0).toString(16),c/4)}n.toHexString=u;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const y=c.length;if(y===0)return;const w=this._buff;let N=this._buffLen,p=this._leftoverHighSurrogate,S,r;for(p!==0?(S=p,r=-1,p=0):(S=c.charCodeAt(0),r=0);;){let o=S;if(A.isHighSurrogate(S))if(r+1<y){const a=c.charCodeAt(r+1);A.isLowSurrogate(a)?(r++,o=A.computeCodePoint(S,a)):o=65533}else{p=S;break}else A.isLowSurrogate(S)&&(o=65533);if(N=this._push(w,N,o),r++,r<y)S=c.charCodeAt(r);else break}this._buffLen=N,this._leftoverHighSurrogate=p}_push(c,y,w){return w<128?c[y++]=w:w<2048?(c[y++]=192|(w&1984)>>>6,c[y++]=128|(w&63)>>>0):w<65536?(c[y++]=224|(w&61440)>>>12,c[y++]=128|(w&4032)>>>6,c[y++]=128|(w&63)>>>0):(c[y++]=240|(w&1835008)>>>18,c[y++]=128|(w&258048)>>>12,c[y++]=128|(w&4032)>>>6,c[y++]=128|(w&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=f._bigBlock32,y=this._buffDV;for(let d=0;d<64;d+=4)c.setUint32(d,y.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)c.setUint32(d,_(c.getUint32(d-12,!1)^c.getUint32(d-32,!1)^c.getUint32(d-56,!1)^c.getUint32(d-64,!1),1),!1);let w=this._h0,N=this._h1,p=this._h2,S=this._h3,r=this._h4,o,a,v;for(let d=0;d<80;d++)d<20?(o=N&p|~N&S,a=1518500249):d<40?(o=N^p^S,a=1859775393):d<60?(o=N&p|N&S|p&S,a=2400959708):(o=N^p^S,a=3395469782),v=_(w,5)+o+r+a+c.getUint32(d*4,!1)&4294967295,r=S,S=p,p=_(N,30),N=w,w=v;this._h0=this._h0+w&4294967295,this._h1=this._h1+N&4294967295,this._h2=this._h2+p&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[24],J([0,1,35,39]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,b=new Int32Array(e.length);for(let u=0,f=e.length;u<f;u++)b[u]=e.charCodeAt(u);return b}}n.StringDiffSequence=i;function h(_,e,b){return new s(new i(_),new i(e)).ComputeDiff(b).changes}n.stringDiff=h;class g{static Assert(e,b){if(!e)throw new Error(b)}}class L{static Copy(e,b,u,f,m){for(let c=0;c<m;c++)u[f+c]=e[b+c]}static Copy2(e,b,u,f,m){for(let c=0;c<m;c++)u[f+c]=e[b+c]}}class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new A.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,b){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_originalCount++}AddModifiedElement(e,b){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class s{constructor(e,b,u=null){this.ContinueProcessingPredicate=u,this._originalSequence=e,this._modifiedSequence=b;const[f,m,c]=s._getElements(e),[y,w,N]=s._getElements(b);this._hasStrings=c&&N,this._originalStringElements=f,this._originalElementsOrHash=m,this._modifiedStringElements=y,this._modifiedElementsOrHash=w,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const b=e.getElements();if(s._isStringArray(b)){const u=new Int32Array(b.length);for(let f=0,m=b.length;f<m;f++)u[f]=(0,M.stringHash)(b[f],0);return[b,u,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}ElementsAreEqual(e,b){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[b]:!0}ElementsAreStrictEqual(e,b){if(!this.ElementsAreEqual(e,b))return!1;const u=s._getStrictElement(this._originalSequence,e),f=s._getStrictElement(this._modifiedSequence,b);return u===f}static _getStrictElement(e,b){return typeof e.getStrictElement=="function"?e.getStrictElement(b):null}OriginalElementsAreEqual(e,b){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[b]:!0}ModifiedElementsAreEqual(e,b){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[b]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,b,u,f,m){const c=[!1];let y=this.ComputeDiffRecursive(e,b,u,f,c);return m&&(y=this.PrettifyChanges(y)),{quitEarly:c[0],changes:y}}ComputeDiffRecursive(e,b,u,f,m){for(m[0]=!1;e<=b&&u<=f&&this.ElementsAreEqual(e,u);)e++,u++;for(;b>=e&&f>=u&&this.ElementsAreEqual(b,f);)b--,f--;if(e>b||u>f){let S;return u<=f?(g.Assert(e===b+1,"originalStart should only be one more than originalEnd"),S=[new A.DiffChange(e,0,u,f-u+1)]):e<=b?(g.Assert(u===f+1,"modifiedStart should only be one more than modifiedEnd"),S=[new A.DiffChange(e,b-e+1,u,0)]):(g.Assert(e===b+1,"originalStart should only be one more than originalEnd"),g.Assert(u===f+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const c=[0],y=[0],w=this.ComputeRecursionPoint(e,b,u,f,c,y,m),N=c[0],p=y[0];if(w!==null)return w;if(!m[0]){const S=this.ComputeDiffRecursive(e,N,u,p,m);let r=[];return m[0]?r=[new A.DiffChange(N+1,b-(N+1)+1,p+1,f-(p+1)+1)]:r=this.ComputeDiffRecursive(N+1,b,p+1,f,m),this.ConcatenateChanges(S,r)}return[new A.DiffChange(e,b-e+1,u,f-u+1)]}WALKTRACE(e,b,u,f,m,c,y,w,N,p,S,r,o,a,v,d,C,R){let E=null,D=null,F=new l,B=b,I=u,U=o[0]-d[0]-f,x=-1073741824,k=this.m_forwardHistory.length-1;do{const O=U+e;O===B||O<I&&N[O-1]<N[O+1]?(S=N[O+1],a=S-U-f,S<x&&F.MarkNextChange(),x=S,F.AddModifiedElement(S+1,a),U=O+1-e):(S=N[O-1]+1,a=S-U-f,S<x&&F.MarkNextChange(),x=S-1,F.AddOriginalElement(S,a+1),U=O-1-e),k>=0&&(N=this.m_forwardHistory[k],e=N[0],B=1,I=N.length-1)}while(--k>=-1);if(E=F.getReverseChanges(),R[0]){let O=o[0]+1,W=d[0]+1;if(E!==null&&E.length>0){const z=E[E.length-1];O=Math.max(O,z.getOriginalEnd()),W=Math.max(W,z.getModifiedEnd())}D=[new A.DiffChange(O,r-O+1,W,v-W+1)]}else{F=new l,B=c,I=y,U=o[0]-d[0]-w,x=1073741824,k=C?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const O=U+m;O===B||O<I&&p[O-1]>=p[O+1]?(S=p[O+1]-1,a=S-U-w,S>x&&F.MarkNextChange(),x=S+1,F.AddOriginalElement(S+1,a+1),U=O+1-m):(S=p[O-1],a=S-U-w,S>x&&F.MarkNextChange(),x=S,F.AddModifiedElement(S+1,a+1),U=O-1-m),k>=0&&(p=this.m_reverseHistory[k],m=p[0],B=1,I=p.length-1)}while(--k>=-1);D=F.getChanges()}return this.ConcatenateChanges(E,D)}ComputeRecursionPoint(e,b,u,f,m,c,y){let w=0,N=0,p=0,S=0,r=0,o=0;e--,u--,m[0]=0,c[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=b-e+(f-u),v=a+1,d=new Int32Array(v),C=new Int32Array(v),R=f-u,E=b-e,D=e-u,F=b-f,I=(E-R)%2===0;d[R]=e,C[E]=b,y[0]=!1;for(let U=1;U<=a/2+1;U++){let x=0,k=0;p=this.ClipDiagonalBound(R-U,U,R,v),S=this.ClipDiagonalBound(R+U,U,R,v);for(let W=p;W<=S;W+=2){W===p||W<S&&d[W-1]<d[W+1]?w=d[W+1]:w=d[W-1]+1,N=w-(W-R)-D;const z=w;for(;w<b&&N<f&&this.ElementsAreEqual(w+1,N+1);)w++,N++;if(d[W]=w,w+N>x+k&&(x=w,k=N),!I&&Math.abs(W-E)<=U-1&&w>=C[W])return m[0]=w,c[0]=N,z<=C[W]&&1447>0&&U<=1447+1?this.WALKTRACE(R,p,S,D,E,r,o,F,d,C,w,b,m,N,f,c,I,y):null}const O=(x-e+(k-u)-U)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(x,O))return y[0]=!0,m[0]=x,c[0]=k,O>0&&1447>0&&U<=1447+1?this.WALKTRACE(R,p,S,D,E,r,o,F,d,C,w,b,m,N,f,c,I,y):(e++,u++,[new A.DiffChange(e,b-e+1,u,f-u+1)]);r=this.ClipDiagonalBound(E-U,U,E,v),o=this.ClipDiagonalBound(E+U,U,E,v);for(let W=r;W<=o;W+=2){W===r||W<o&&C[W-1]>=C[W+1]?w=C[W+1]-1:w=C[W-1],N=w-(W-E)-F;const z=w;for(;w>e&&N>u&&this.ElementsAreEqual(w,N);)w--,N--;if(C[W]=w,I&&Math.abs(W-R)<=U&&w<=d[W])return m[0]=w,c[0]=N,z>=d[W]&&1447>0&&U<=1447+1?this.WALKTRACE(R,p,S,D,E,r,o,F,d,C,w,b,m,N,f,c,I,y):null}if(U<=1447){let W=new Int32Array(S-p+2);W[0]=R-p+1,L.Copy2(d,p,W,1,S-p+1),this.m_forwardHistory.push(W),W=new Int32Array(o-r+2),W[0]=E-r+1,L.Copy2(C,r,W,1,o-r+1),this.m_reverseHistory.push(W)}}return this.WALKTRACE(R,p,S,D,E,r,o,F,d,C,w,b,m,N,f,c,I,y)}PrettifyChanges(e){for(let b=0;b<e.length;b++){const u=e[b],f=b<e.length-1?e[b+1].originalStart:this._originalElementsOrHash.length,m=b<e.length-1?e[b+1].modifiedStart:this._modifiedElementsOrHash.length,c=u.originalLength>0,y=u.modifiedLength>0;for(;u.originalStart+u.originalLength<f&&u.modifiedStart+u.modifiedLength<m&&(!c||this.OriginalElementsAreEqual(u.originalStart,u.originalStart+u.originalLength))&&(!y||this.ModifiedElementsAreEqual(u.modifiedStart,u.modifiedStart+u.modifiedLength));){const N=this.ElementsAreStrictEqual(u.originalStart,u.modifiedStart);if(this.ElementsAreStrictEqual(u.originalStart+u.originalLength,u.modifiedStart+u.modifiedLength)&&!N)break;u.originalStart++,u.modifiedStart++}const w=[null];if(b<e.length-1&&this.ChangesOverlap(e[b],e[b+1],w)){e[b]=w[0],e.splice(b+1,1),b--;continue}}for(let b=e.length-1;b>=0;b--){const u=e[b];let f=0,m=0;if(b>0){const S=e[b-1];f=S.originalStart+S.originalLength,m=S.modifiedStart+S.modifiedLength}const c=u.originalLength>0,y=u.modifiedLength>0;let w=0,N=this._boundaryScore(u.originalStart,u.originalLength,u.modifiedStart,u.modifiedLength);for(let S=1;;S++){const r=u.originalStart-S,o=u.modifiedStart-S;if(r<f||o<m||c&&!this.OriginalElementsAreEqual(r,r+u.originalLength)||y&&!this.ModifiedElementsAreEqual(o,o+u.modifiedLength))break;const v=(r===f&&o===m?5:0)+this._boundaryScore(r,u.originalLength,o,u.modifiedLength);v>N&&(N=v,w=S)}u.originalStart-=w,u.modifiedStart-=w;const p=[null];if(b>0&&this.ChangesOverlap(e[b-1],e[b],p)){e[b-1]=p[0],e.splice(b,1),b++;continue}}if(this._hasStrings)for(let b=1,u=e.length;b<u;b++){const f=e[b-1],m=e[b],c=m.originalStart-f.originalStart-f.originalLength,y=f.originalStart,w=m.originalStart+m.originalLength,N=w-y,p=f.modifiedStart,S=m.modifiedStart+m.modifiedLength,r=S-p;if(c<5&&N<20&&r<20){const o=this._findBetterContiguousSequence(y,N,p,r,c);if(o){const[a,v]=o;(a!==f.originalStart+f.originalLength||v!==f.modifiedStart+f.modifiedLength)&&(f.originalLength=a-f.originalStart,f.modifiedLength=v-f.modifiedStart,m.originalStart=a+c,m.modifiedStart=v+c,m.originalLength=w-m.originalStart,m.modifiedLength=S-m.modifiedStart)}}}return e}_findBetterContiguousSequence(e,b,u,f,m){if(b<m||f<m)return null;const c=e+b-m+1,y=u+f-m+1;let w=0,N=0,p=0;for(let S=e;S<c;S++)for(let r=u;r<y;r++){const o=this._contiguousSequenceScore(S,r,m);o>0&&o>w&&(w=o,N=S,p=r)}return w>0?[N,p]:null}_contiguousSequenceScore(e,b,u){let f=0;for(let m=0;m<u;m++){if(!this.ElementsAreEqual(e+m,b+m))return 0;f+=this._originalStringElements[e+m].length}return f}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,b){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(b>0){const u=e+b;if(this._OriginalIsBoundary(u-1)||this._OriginalIsBoundary(u))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,b){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(b>0){const u=e+b;if(this._ModifiedIsBoundary(u-1)||this._ModifiedIsBoundary(u))return!0}return!1}_boundaryScore(e,b,u,f){const m=this._OriginalRegionIsBoundary(e,b)?1:0,c=this._ModifiedRegionIsBoundary(u,f)?1:0;return m+c}ConcatenateChanges(e,b){const u=[];if(e.length===0||b.length===0)return b.length>0?b:e;if(this.ChangesOverlap(e[e.length-1],b[0],u)){const f=new Array(e.length+b.length-1);return L.Copy(e,0,f,0,e.length-1),f[e.length-1]=u[0],L.Copy(b,1,f,e.length,b.length-1),f}else{const f=new Array(e.length+b.length);return L.Copy(e,0,f,0,e.length),L.Copy(b,0,f,e.length,b.length),f}}ChangesOverlap(e,b,u){if(g.Assert(e.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),g.Assert(e.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=b.originalStart||e.modifiedStart+e.modifiedLength>=b.modifiedStart){const f=e.originalStart;let m=e.originalLength;const c=e.modifiedStart;let y=e.modifiedLength;return e.originalStart+e.originalLength>=b.originalStart&&(m=b.originalStart+b.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=b.modifiedStart&&(y=b.modifiedStart+b.modifiedLength-e.modifiedStart),u[0]=new A.DiffChange(f,m,c,y),!0}else return u[0]=null,!1}ClipDiagonalBound(e,b,u,f){if(e>=0&&e<f)return e;const m=u,c=f-u-1,y=b%2===0;if(e<0){const w=m%2===0;return y===w?0:1}else{const w=c%2===0;return y===w?f-1:f-2}}}n.LcsDiff=s}),Y(X[25],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function A(c){return typeof c=="string"}n.isString=A;function M(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}n.isObject=M;function i(c){const y=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof y}n.isTypedArray=i;function h(c){return typeof c=="number"&&!isNaN(c)}n.isNumber=h;function g(c){return!!c&&typeof c[Symbol.iterator]=="function"}n.isIterable=g;function L(c){return c===!0||c===!1}n.isBoolean=L;function l(c){return typeof c>"u"}n.isUndefined=l;function s(c){return!_(c)}n.isDefined=s;function _(c){return l(c)||c===null}n.isUndefinedOrNull=_;function e(c,y){if(!c)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}n.assertType=e;function b(c){if(_(c))throw new Error("Assertion Failed: argument is undefined or null");return c}n.assertIsDefined=b;function u(c){return typeof c=="function"}n.isFunction=u;function f(c,y){const w=Math.min(c.length,y.length);for(let N=0;N<w;N++)m(c[N],y[N])}n.validateConstraints=f;function m(c,y){if(A(y)){if(typeof c!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(u(y)){try{if(c instanceof y)return}catch{}if(!_(c)&&c.constructor===y||y.length===1&&y.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=m}),Y(X[40],J([0,1,25]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(g,L){if((0,A.isString)(L)){const l=M[L];if(l===void 0)throw new Error(`${g} references an unknown codicon: ${L}`);L=l}return M[g]=L,{id:g}}function h(){return M}n.getCodiconFontCharacters=h,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(X[14],J([0,1,25]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const f=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([m,c])=>{f[m]=c&&typeof c=="object"?M(c):c}),f}n.deepClone=M;function i(u){if(!u||typeof u!="object")return u;const f=[u];for(;f.length>0;){const m=f.shift();Object.freeze(m);for(const c in m)if(h.call(m,c)){const y=m[c];typeof y=="object"&&!Object.isFrozen(y)&&!(0,A.isTypedArray)(y)&&f.push(y)}}return u}n.deepFreeze=i;const h=Object.prototype.hasOwnProperty;function g(u,f){return L(u,f,new Set)}n.cloneAndChange=g;function L(u,f,m){if((0,A.isUndefinedOrNull)(u))return u;const c=f(u);if(typeof c<"u")return c;if(Array.isArray(u)){const y=[];for(const w of u)y.push(L(w,f,m));return y}if((0,A.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const y={};for(const w in u)h.call(u,w)&&(y[w]=L(u[w],f,m));return m.delete(u),y}return u}function l(u,f,m=!0){return(0,A.isObject)(u)?((0,A.isObject)(f)&&Object.keys(f).forEach(c=>{c in u?m&&((0,A.isObject)(u[c])&&(0,A.isObject)(f[c])?l(u[c],f[c],m):u[c]=f[c]):u[c]=f[c]}),u):f}n.mixin=l;function s(u,f){if(u===f)return!0;if(u==null||f===null||f===void 0||typeof u!=typeof f||typeof u!="object"||Array.isArray(u)!==Array.isArray(f))return!1;let m,c;if(Array.isArray(u)){if(u.length!==f.length)return!1;for(m=0;m<u.length;m++)if(!s(u[m],f[m]))return!1}else{const y=[];for(c in u)y.push(c);y.sort();const w=[];for(c in f)w.push(c);if(w.sort(),!s(y,w))return!1;for(m=0;m<y.length;m++)if(!s(u[y[m]],f[y[m]]))return!1}return!0}n.equals=s;function _(u){let f=[];for(;Object.prototype!==u;)f=f.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return f}n.getAllPropertyNames=_;function e(u){const f=[];for(const m of _(u))typeof u[m]=="function"&&f.push(m);return f}n.getAllMethodNames=e;function b(u,f){const m=y=>function(){const w=Array.prototype.slice.call(arguments,0);return f(y,w)},c={};for(const y of u)c[y]=m(y);return c}n.createProxyObject=b}),Y(X[26],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function A(i){return i<0?0:i>255?255:i|0}n.toUint8=A;function M(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=M}),Y(X[27],J([0,1,26]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(g){const L=(0,A.toUint8)(g);this._defaultValue=L,this._asciiMap=M._createAsciiMap(L),this._map=new Map}static _createAsciiMap(g){const L=new Uint8Array(256);return L.fill(g),L}set(g,L){const l=(0,A.toUint8)(L);g>=0&&g<256?this._asciiMap[g]=l:this._map.set(g,l)}get(g){return g>=0&&g<256?this._asciiMap[g]:this._map.get(g)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=M;class i{constructor(){this._actual=new M(0)}add(g){this._actual.set(g,1)}has(g){return this._actual.get(g)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),Y(X[3],J([0,1,5]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class M{static addRange(g,L){let l=0;for(;l<L.length&&L[l].endExclusive<g.start;)l++;let s=l;for(;s<L.length&&L[s].start<=g.endExclusive;)s++;if(l===s)L.splice(l,0,g);else{const _=Math.min(g.start,L[l].start),e=Math.max(g.endExclusive,L[s-1].endExclusive);L.splice(l,s-l,new M(_,e))}}static tryCreate(g,L){if(!(g>L))return new M(g,L)}static ofLength(g){return new M(0,g)}constructor(g,L){if(this.start=g,this.endExclusive=L,g>L)throw new A.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(g){return new M(this.start+g,this.endExclusive+g)}deltaStart(g){return new M(this.start+g,this.endExclusive)}deltaEnd(g){return new M(this.start,this.endExclusive+g)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(g){return this.start===g.start&&this.endExclusive===g.endExclusive}containsRange(g){return this.start<=g.start&&g.endExclusive<=this.endExclusive}contains(g){return this.start<=g&&g<this.endExclusive}join(g){return new M(Math.min(this.start,g.start),Math.max(this.endExclusive,g.endExclusive))}intersect(g){const L=Math.max(this.start,g.start),l=Math.min(this.endExclusive,g.endExclusive);if(L<=l)return new M(L,l)}slice(g){return g.slice(this.start,this.endExclusive)}clip(g){if(this.isEmpty)throw new A.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,g))}clipCyclic(g){if(this.isEmpty)throw new A.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return g<this.start?this.endExclusive-(this.start-g)%this.length:g>=this.endExclusive?this.start+(g-this.start)%this.length:g}forEach(g){for(let L=this.start;L<this.endExclusive;L++)g(L)}}n.OffsetRange=M;class i{constructor(){this._sortedRanges=[]}addRange(g){let L=0;for(;L<this._sortedRanges.length&&this._sortedRanges[L].endExclusive<g.start;)L++;let l=L;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=g.endExclusive;)l++;if(L===l)this._sortedRanges.splice(L,0,g);else{const s=Math.min(g.start,this._sortedRanges[L].start),_=Math.max(g.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(L,l-L,new M(s,_))}}toString(){return this._sortedRanges.map(g=>g.toString()).join(", ")}intersectsStrict(g){let L=0;for(;L<this._sortedRanges.length&&this._sortedRanges[L].endExclusive<=g.start;)L++;return L<this._sortedRanges.length&&this._sortedRanges[L].start<g.endExclusive}intersectWithRange(g){const L=new i;for(const l of this._sortedRanges){const s=l.intersect(g);s&&L.addRange(s)}return L}intersectWithRangeLength(g){return this.intersectWithRange(g).length}get length(){return this._sortedRanges.reduce((g,L)=>g+L.length,0)}}n.OffsetRangeSet=i}),Y(X[4],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class A{constructor(i,h){this.lineNumber=i,this.column=h}with(i=this.lineNumber,h=this.column){return i===this.lineNumber&&h===this.column?this:new A(i,h)}delta(i=0,h=0){return this.with(this.lineNumber+i,this.column+h)}equals(i){return A.equals(this,i)}static equals(i,h){return!i&&!h?!0:!!i&&!!h&&i.lineNumber===h.lineNumber&&i.column===h.column}isBefore(i){return A.isBefore(this,i)}static isBefore(i,h){return i.lineNumber<h.lineNumber?!0:h.lineNumber<i.lineNumber?!1:i.column<h.column}isBeforeOrEqual(i){return A.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,h){return i.lineNumber<h.lineNumber?!0:h.lineNumber<i.lineNumber?!1:i.column<=h.column}static compare(i,h){const g=i.lineNumber|0,L=h.lineNumber|0;if(g===L){const l=i.column|0,s=h.column|0;return l-s}return g-L}clone(){return new A(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new A(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=A}),Y(X[2],J([0,1,4]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(h,g,L,l){h>L||h===L&&g>l?(this.startLineNumber=L,this.startColumn=l,this.endLineNumber=h,this.endColumn=g):(this.startLineNumber=h,this.startColumn=g,this.endLineNumber=L,this.endColumn=l)}isEmpty(){return M.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return M.containsPosition(this,h)}static containsPosition(h,g){return!(g.lineNumber<h.startLineNumber||g.lineNumber>h.endLineNumber||g.lineNumber===h.startLineNumber&&g.column<h.startColumn||g.lineNumber===h.endLineNumber&&g.column>h.endColumn)}static strictContainsPosition(h,g){return!(g.lineNumber<h.startLineNumber||g.lineNumber>h.endLineNumber||g.lineNumber===h.startLineNumber&&g.column<=h.startColumn||g.lineNumber===h.endLineNumber&&g.column>=h.endColumn)}containsRange(h){return M.containsRange(this,h)}static containsRange(h,g){return!(g.startLineNumber<h.startLineNumber||g.endLineNumber<h.startLineNumber||g.startLineNumber>h.endLineNumber||g.endLineNumber>h.endLineNumber||g.startLineNumber===h.startLineNumber&&g.startColumn<h.startColumn||g.endLineNumber===h.endLineNumber&&g.endColumn>h.endColumn)}strictContainsRange(h){return M.strictContainsRange(this,h)}static strictContainsRange(h,g){return!(g.startLineNumber<h.startLineNumber||g.endLineNumber<h.startLineNumber||g.startLineNumber>h.endLineNumber||g.endLineNumber>h.endLineNumber||g.startLineNumber===h.startLineNumber&&g.startColumn<=h.startColumn||g.endLineNumber===h.endLineNumber&&g.endColumn>=h.endColumn)}plusRange(h){return M.plusRange(this,h)}static plusRange(h,g){let L,l,s,_;return g.startLineNumber<h.startLineNumber?(L=g.startLineNumber,l=g.startColumn):g.startLineNumber===h.startLineNumber?(L=g.startLineNumber,l=Math.min(g.startColumn,h.startColumn)):(L=h.startLineNumber,l=h.startColumn),g.endLineNumber>h.endLineNumber?(s=g.endLineNumber,_=g.endColumn):g.endLineNumber===h.endLineNumber?(s=g.endLineNumber,_=Math.max(g.endColumn,h.endColumn)):(s=h.endLineNumber,_=h.endColumn),new M(L,l,s,_)}intersectRanges(h){return M.intersectRanges(this,h)}static intersectRanges(h,g){let L=h.startLineNumber,l=h.startColumn,s=h.endLineNumber,_=h.endColumn;const e=g.startLineNumber,b=g.startColumn,u=g.endLineNumber,f=g.endColumn;return L<e?(L=e,l=b):L===e&&(l=Math.max(l,b)),s>u?(s=u,_=f):s===u&&(_=Math.min(_,f)),L>s||L===s&&l>_?null:new M(L,l,s,_)}equalsRange(h){return M.equalsRange(this,h)}static equalsRange(h,g){return!h&&!g?!0:!!h&&!!g&&h.startLineNumber===g.startLineNumber&&h.startColumn===g.startColumn&&h.endLineNumber===g.endLineNumber&&h.endColumn===g.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(h){return new A.Position(h.endLineNumber,h.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(h){return new A.Position(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,g){return new M(this.startLineNumber,this.startColumn,h,g)}setStartPosition(h,g){return new M(h,g,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(h){return new M(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(h){return new M(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new M(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,g=h){return new M(h.lineNumber,h.column,g.lineNumber,g.column)}static lift(h){return h?new M(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,g){return!(h.endLineNumber<g.startLineNumber||h.endLineNumber===g.startLineNumber&&h.endColumn<g.startColumn||g.endLineNumber<h.startLineNumber||g.endLineNumber===h.startLineNumber&&g.endColumn<h.startColumn)}static areIntersecting(h,g){return!(h.endLineNumber<g.startLineNumber||h.endLineNumber===g.startLineNumber&&h.endColumn<=g.startColumn||g.endLineNumber<h.startLineNumber||g.endLineNumber===h.startLineNumber&&g.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,g){if(h&&g){const s=h.startLineNumber|0,_=g.startLineNumber|0;if(s===_){const e=h.startColumn|0,b=g.startColumn|0;if(e===b){const u=h.endLineNumber|0,f=g.endLineNumber|0;if(u===f){const m=h.endColumn|0,c=g.endColumn|0;return m-c}return u-f}return e-b}return s-_}return(h?1:0)-(g?1:0)}static compareRangesUsingEnds(h,g){return h.endLineNumber===g.endLineNumber?h.endColumn===g.endColumn?h.startLineNumber===g.startLineNumber?h.startColumn-g.startColumn:h.startLineNumber-g.startLineNumber:h.endColumn-g.endColumn:h.endLineNumber-g.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}n.Range=M}),Y(X[10],J([0,1,5,3,2,11]),function(T,n,A,M,i,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class g{static fromRange(s){return new g(s.startLineNumber,s.endLineNumber)}static joinMany(s){if(s.length===0)return[];let _=new L(s[0].slice());for(let e=1;e<s.length;e++)_=_.getUnion(new L(s[e].slice()));return _.ranges}static ofLength(s,_){return new g(s,s+_)}static deserialize(s){return new g(s[0],s[1])}constructor(s,_){if(s>_)throw new A.BugIndicatingError(`startLineNumber ${s} cannot be after endLineNumberExclusive ${_}`);this.startLineNumber=s,this.endLineNumberExclusive=_}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new g(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new g(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new g(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const _=Math.max(this.startLineNumber,s.startLineNumber),e=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(_<=e)return new g(_,e)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const _=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)_.push(s(e));return _}forEach(s){for(let _=this.startLineNumber;_<this.endLineNumberExclusive;_++)s(_)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new M.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=g;class L{constructor(s=[]){this._normalizedRanges=s}get ranges(){return this._normalizedRanges}addRange(s){if(s.length===0)return;const _=(0,h.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,b=>b.endLineNumberExclusive>=s.startLineNumber),e=(0,h.findLastIdxMonotonous)(this._normalizedRanges,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(_===e)this._normalizedRanges.splice(_,0,s);else if(_===e-1){const b=this._normalizedRanges[_];this._normalizedRanges[_]=b.join(s)}else{const b=this._normalizedRanges[_].join(this._normalizedRanges[e-1]).join(s);this._normalizedRanges.splice(_,e-_,b)}}contains(s){const _=(0,h.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=s);return!!_&&_.endLineNumberExclusive>s}getUnion(s){if(this._normalizedRanges.length===0)return s;if(s._normalizedRanges.length===0)return this;const _=[];let e=0,b=0,u=null;for(;e<this._normalizedRanges.length||b<s._normalizedRanges.length;){let f=null;if(e<this._normalizedRanges.length&&b<s._normalizedRanges.length){const m=this._normalizedRanges[e],c=s._normalizedRanges[b];m.startLineNumber<c.startLineNumber?(f=m,e++):(f=c,b++)}else e<this._normalizedRanges.length?(f=this._normalizedRanges[e],e++):(f=s._normalizedRanges[b],b++);u===null?u=f:u.endLineNumberExclusive>=f.startLineNumber?u=new g(u.startLineNumber,Math.max(u.endLineNumberExclusive,f.endLineNumberExclusive)):(_.push(u),u=f)}return u!==null&&_.push(u),new L(_)}subtractFrom(s){const _=(0,h.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,f=>f.endLineNumberExclusive>=s.startLineNumber),e=(0,h.findLastIdxMonotonous)(this._normalizedRanges,f=>f.startLineNumber<=s.endLineNumberExclusive)+1;if(_===e)return new L([s]);const b=[];let u=s.startLineNumber;for(let f=_;f<e;f++){const m=this._normalizedRanges[f];m.startLineNumber>u&&b.push(new g(u,m.startLineNumber)),u=m.endLineNumberExclusive}return u<s.endLineNumberExclusive&&b.push(new g(u,s.endLineNumberExclusive)),new L(b)}toString(){return this._normalizedRanges.map(s=>s.toString()).join(", ")}getIntersection(s){const _=[];let e=0,b=0;for(;e<this._normalizedRanges.length&&b<s._normalizedRanges.length;){const u=this._normalizedRanges[e],f=s._normalizedRanges[b],m=u.intersect(f);m&&!m.isEmpty&&_.push(m),u.endLineNumberExclusive<f.endLineNumberExclusive?e++:b++}return new L(_)}getWithDelta(s){return new L(this._normalizedRanges.map(_=>_.delta(s)))}}n.LineRangeSet=L}),Y(X[41],J([0,1,4,2]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends M.Range{constructor(g,L,l,s){super(g,L,l,s),this.selectionStartLineNumber=g,this.selectionStartColumn=L,this.positionLineNumber=l,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return i.selectionsEqual(this,g)}static selectionsEqual(g,L){return g.selectionStartLineNumber===L.selectionStartLineNumber&&g.selectionStartColumn===L.selectionStartColumn&&g.positionLineNumber===L.positionLineNumber&&g.positionColumn===L.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,L){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,g,L):new i(g,L,this.startLineNumber,this.startColumn)}getPosition(){return new A.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new A.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,L){return this.getDirection()===0?new i(g,L,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,g,L)}static fromPositions(g,L=g){return new i(g.lineNumber,g.column,L.lineNumber,L.column)}static fromRange(g,L){return L===0?new i(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new i(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new i(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,L){if(g&&!L||!g&&L)return!1;if(!g&&!L)return!0;if(g.length!==L.length)return!1;for(let l=0,s=g.length;l<s;l++)if(!this.selectionsEqual(g[l],L[l]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,L,l,s,_){return _===0?new i(g,L,l,s):new i(l,s,g,L)}}n.Selection=i}),Y(X[42],J([0,1,27]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends A.CharacterClassifier{constructor(g){super(0);for(let L=0,l=g.length;L<l;L++)this.set(g.charCodeAt(L),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function i(h){const g={};return L=>(g.hasOwnProperty(L)||(g[L]=h(L)),g[L])}n.getMapForWordSeparators=i(h=>new M(h))}),Y(X[28],J([0,1,21,22]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(s=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)s.indexOf(e)>=0||(_+="\\"+e);return _+="\\s]+)",new RegExp(_,"g")}n.DEFAULT_WORD_REGEXP=i();function h(s){let _=n.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)_=s;else{let e="g";s.ignoreCase&&(e+="i"),s.multiline&&(e+="m"),s.unicode&&(e+="u"),_=new RegExp(s.source,e)}return _.lastIndex=0,_}n.ensureValidWordDefinition=h;const g=new M.LinkedList;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function L(s,_,e,b,u){if(u||(u=A.Iterable.first(g)),e.length>u.maxLen){let w=s-u.maxLen/2;return w<0?w=0:b+=w,e=e.substring(w,s+u.maxLen/2),L(s,_,e,b,u)}const f=Date.now(),m=s-1-b;let c=-1,y=null;for(let w=1;!(Date.now()-f>=u.timeBudget);w++){const N=m-u.windowSize*w;_.lastIndex=Math.max(0,N);const p=l(_,e,m,c);if(!p&&y||(y=p,N<=0))break;c=N}if(y){const w={word:y[0],startColumn:b+1+y.index,endColumn:b+1+y.index+y[0].length};return _.lastIndex=0,w}return null}n.getWordAtText=L;function l(s,_,e,b){let u;for(;u=s.exec(_);){const f=u.index||0;if(f<=e&&s.lastIndex>=e)return u;if(b>0&&f>b)return null}return null}}),Y(X[7],J([0,1,8,5,3]),function(T,n,A,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class h{static trivial(_,e){return new h([new g(new i.OffsetRange(0,_.length),new i.OffsetRange(0,e.length))],!1)}static trivialTimedOut(_,e){return new h([new g(new i.OffsetRange(0,_.length),new i.OffsetRange(0,e.length))],!0)}constructor(_,e){this.diffs=_,this.hitTimeout=e}}n.DiffAlgorithmResult=h;class g{static invert(_,e){const b=[];return(0,A.forEachAdjacent)(_,(u,f)=>{const m=u?u.seq1Range.endExclusive:0,c=u?u.seq2Range.endExclusive:0,y=f?f.seq1Range.start:e,w=f?f.seq2Range.start:(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+e;b.push(new g(new i.OffsetRange(m,y),new i.OffsetRange(c,w)))}),b}constructor(_,e){this.seq1Range=_,this.seq2Range=e}swap(){return new g(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(_){return new g(this.seq1Range.join(_.seq1Range),this.seq2Range.join(_.seq2Range))}delta(_){return _===0?this:new g(this.seq1Range.delta(_),this.seq2Range.delta(_))}}n.SequenceDiff=g;class L{isValid(){return!0}}n.InfiniteTimeout=L,L.instance=new L;class l{constructor(_){if(this.timeout=_,this.startTime=Date.now(),this.valid=!0,_<=0)throw new M.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=l}),Y(X[29],J([0,1,3,7]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(s,_,e=M.InfiniteTimeout.instance){if(s.length===0||_.length===0)return M.DiffAlgorithmResult.trivial(s,_);function b(S,r){for(;S<s.length&&r<_.length&&s.getElement(S)===_.getElement(r);)S++,r++;return S}let u=0;const f=new g;f.set(0,b(0,0));const m=new L;m.set(0,f.get(0)===0?null:new h(null,0,0,f.get(0)));let c=0;e:for(;;){if(u++,!e.isValid())return M.DiffAlgorithmResult.trivialTimedOut(s,_);const S=-Math.min(u,_.length+u%2),r=Math.min(u,s.length+u%2);for(c=S;c<=r;c+=2){const o=c===r?-1:f.get(c+1),a=c===S?-1:f.get(c-1)+1,v=Math.min(Math.max(o,a),s.length),d=v-c;if(v>s.length||d>_.length)continue;const C=b(v,d);f.set(c,C);const R=v===o?m.get(c+1):m.get(c-1);if(m.set(c,C!==v?new h(R,v,d,C-v):R),f.get(c)===s.length&&f.get(c)-c===_.length)break e}}let y=m.get(c);const w=[];let N=s.length,p=_.length;for(;;){const S=y?y.x+y.length:0,r=y?y.y+y.length:0;if((S!==N||r!==p)&&w.push(new M.SequenceDiff(new A.OffsetRange(S,N),new A.OffsetRange(r,p))),!y)break;N=y.x,p=y.y,y=y.prev}return w.reverse(),new M.DiffAlgorithmResult(w,!1)}}n.MyersDiffAlgorithm=i;class h{constructor(s,_,e,b){this.prev=s,this.x=_,this.y=e,this.length=b}}class g{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,_){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[s]=_}else{if(s>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[s]=_}}}class L{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,_){s<0?(s=-s-1,this.negativeArr[s]=_):this.positiveArr[s]=_}}}),Y(X[43],J([0,1,3,7]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.removeVeryShortMatchingTextBetweenLongDiffs=n.removeVeryShortMatchingLinesBetweenDiffs=n.extendDiffsToEntireWordIfAppropriate=n.removeShortMatches=n.optimizeSequenceDiffs=void 0;function i(u,f,m){let c=m;return c=h(u,f,c),c=g(u,f,c),c}n.optimizeSequenceDiffs=i;function h(u,f,m){if(m.length===0)return m;const c=[];c.push(m[0]);for(let w=1;w<m.length;w++){const N=c[c.length-1];let p=m[w];if(p.seq1Range.isEmpty||p.seq2Range.isEmpty){const S=p.seq1Range.start-N.seq1Range.endExclusive;let r;for(r=1;r<=S&&!(u.getElement(p.seq1Range.start-r)!==u.getElement(p.seq1Range.endExclusive-r)||f.getElement(p.seq2Range.start-r)!==f.getElement(p.seq2Range.endExclusive-r));r++);if(r--,r===S){c[c.length-1]=new M.SequenceDiff(new A.OffsetRange(N.seq1Range.start,p.seq1Range.endExclusive-S),new A.OffsetRange(N.seq2Range.start,p.seq2Range.endExclusive-S));continue}p=p.delta(-r)}c.push(p)}const y=[];for(let w=0;w<c.length-1;w++){const N=c[w+1];let p=c[w];if(p.seq1Range.isEmpty||p.seq2Range.isEmpty){const S=N.seq1Range.start-p.seq1Range.endExclusive;let r;for(r=0;r<S&&!(u.getElement(p.seq1Range.start+r)!==u.getElement(p.seq1Range.endExclusive+r)||f.getElement(p.seq2Range.start+r)!==f.getElement(p.seq2Range.endExclusive+r));r++);if(r===S){c[w+1]=new M.SequenceDiff(new A.OffsetRange(p.seq1Range.start+S,N.seq1Range.endExclusive),new A.OffsetRange(p.seq2Range.start+S,N.seq2Range.endExclusive));continue}r>0&&(p=p.delta(r))}y.push(p)}return c.length>0&&y.push(c[c.length-1]),y}function g(u,f,m){if(!u.getBoundaryScore||!f.getBoundaryScore)return m;for(let c=0;c<m.length;c++){const y=c>0?m[c-1]:void 0,w=m[c],N=c+1<m.length?m[c+1]:void 0,p=new A.OffsetRange(y?y.seq1Range.start+1:0,N?N.seq1Range.endExclusive-1:u.length),S=new A.OffsetRange(y?y.seq2Range.start+1:0,N?N.seq2Range.endExclusive-1:f.length);w.seq1Range.isEmpty?m[c]=L(w,u,f,p,S):w.seq2Range.isEmpty&&(m[c]=L(w.swap(),f,u,S,p).swap())}return m}function L(u,f,m,c,y){let N=1;for(;u.seq1Range.start-N>=c.start&&u.seq2Range.start-N>=y.start&&m.isStronglyEqual(u.seq2Range.start-N,u.seq2Range.endExclusive-N)&&N<100;)N++;N--;let p=0;for(;u.seq1Range.start+p<c.endExclusive&&u.seq2Range.endExclusive+p<y.endExclusive&&m.isStronglyEqual(u.seq2Range.start+p,u.seq2Range.endExclusive+p)&&p<100;)p++;if(N===0&&p===0)return u;let S=0,r=-1;for(let o=-N;o<=p;o++){const a=u.seq2Range.start+o,v=u.seq2Range.endExclusive+o,d=u.seq1Range.start+o,C=f.getBoundaryScore(d)+m.getBoundaryScore(a)+m.getBoundaryScore(v);C>r&&(r=C,S=o)}return u.delta(S)}function l(u,f,m){const c=[];for(const y of m){const w=c[c.length-1];if(!w){c.push(y);continue}y.seq1Range.start-w.seq1Range.endExclusive<=2||y.seq2Range.start-w.seq2Range.endExclusive<=2?c[c.length-1]=new M.SequenceDiff(w.seq1Range.join(y.seq1Range),w.seq2Range.join(y.seq2Range)):c.push(y)}return c}n.removeShortMatches=l;function s(u,f,m){const c=[];let y;function w(){if(!y)return;const p=y.s1Range.length-y.deleted,S=y.s2Range.length-y.added;Math.max(y.deleted,y.added)+(y.count-1)>p&&c.push(new M.SequenceDiff(y.s1Range,y.s2Range)),y=void 0}for(const p of m){let S=function(d,C){var R,E,D,F;if(!y||!y.s1Range.containsRange(d)||!y.s2Range.containsRange(C))if(y&&!(y.s1Range.endExclusive<d.start&&y.s2Range.endExclusive<C.start)){const U=A.OffsetRange.tryCreate(y.s1Range.endExclusive,d.start),x=A.OffsetRange.tryCreate(y.s2Range.endExclusive,C.start);y.deleted+=(R=U?.length)!==null&&R!==void 0?R:0,y.added+=(E=x?.length)!==null&&E!==void 0?E:0,y.s1Range=y.s1Range.join(d),y.s2Range=y.s2Range.join(C)}else w(),y={added:0,deleted:0,count:0,s1Range:d,s2Range:C};const B=d.intersect(p.seq1Range),I=C.intersect(p.seq2Range);y.count++,y.deleted+=(D=B?.length)!==null&&D!==void 0?D:0,y.added+=(F=I?.length)!==null&&F!==void 0?F:0};const r=u.findWordContaining(p.seq1Range.start-1),o=f.findWordContaining(p.seq2Range.start-1),a=u.findWordContaining(p.seq1Range.endExclusive),v=f.findWordContaining(p.seq2Range.endExclusive);r&&a&&o&&v&&r.equals(a)&&o.equals(v)?S(r,o):(r&&o&&S(r,o),a&&v&&S(a,v))}return w(),_(m,c)}n.extendDiffsToEntireWordIfAppropriate=s;function _(u,f){const m=[];for(;u.length>0||f.length>0;){const c=u[0],y=f[0];let w;c&&(!y||c.seq1Range.start<y.seq1Range.start)?w=u.shift():w=f.shift(),m.length>0&&m[m.length-1].seq1Range.endExclusive>=w.seq1Range.start?m[m.length-1]=m[m.length-1].join(w):m.push(w)}return m}function e(u,f,m){let c=m;if(c.length===0)return c;let y=0,w;do{w=!1;const N=[c[0]];for(let p=1;p<c.length;p++){let o=function(v,d){const C=new A.OffsetRange(r.seq1Range.endExclusive,S.seq1Range.start);return u.getText(C).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||d.seq1Range.length+d.seq2Range.length>5)};const S=c[p],r=N[N.length-1];o(r,S)?(w=!0,N[N.length-1]=N[N.length-1].join(S)):N.push(S)}c=N}while(y++<10&&w);return c}n.removeVeryShortMatchingLinesBetweenDiffs=e;function b(u,f,m){let c=m;if(c.length===0)return c;let y=0,w;do{w=!1;const N=[c[0]];for(let p=1;p<c.length;p++){let o=function(v,d){const C=new A.OffsetRange(r.seq1Range.endExclusive,S.seq1Range.start);if(u.countLinesIn(C)>5||C.length>500)return!1;const E=u.getText(C).trim();if(E.length>20||E.split(/\r\n|\r|\n/).length>1)return!1;const D=u.countLinesIn(v.seq1Range),F=v.seq1Range.length,B=f.countLinesIn(v.seq2Range),I=v.seq2Range.length,U=u.countLinesIn(d.seq1Range),x=d.seq1Range.length,k=f.countLinesIn(d.seq2Range),O=d.seq2Range.length,W=2*40+50;function z(G){return Math.min(G,W)}return Math.pow(Math.pow(z(D*40+F),1.5)+Math.pow(z(B*40+I),1.5),1.5)+Math.pow(Math.pow(z(U*40+x),1.5)+Math.pow(z(k*40+O),1.5),1.5)>Math.pow(Math.pow(W,1.5),1.5)*1.3};const S=c[p],r=N[N.length-1];o(r,S)?(w=!0,N[N.length-1]=N[N.length-1].join(S)):N.push(S)}c=N}while(y++<10&&w);for(let N=0;N<c.length;N++){const p=c[N];let S=p.seq1Range,r=p.seq2Range;const o=u.extendToFullLines(p.seq1Range),a=u.getText(new A.OffsetRange(o.start,p.seq1Range.start));a.length>0&&a.trim().length<=3&&p.seq1Range.length+p.seq2Range.length>100&&(S=p.seq1Range.deltaStart(-a.length),r=p.seq2Range.deltaStart(-a.length));const v=u.getText(new A.OffsetRange(p.seq1Range.endExclusive,o.endExclusive));v.length>0&&v.trim().length<=3&&p.seq1Range.length+p.seq2Range.length>150&&(S=S.deltaEnd(v.length),r=r.deltaEnd(v.length)),c[N]=new M.SequenceDiff(S,r)}return c}n.removeVeryShortMatchingTextBetweenLongDiffs=b}),Y(X[44],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class A{constructor(h,g){this.trimmedHash=h,this.lines=g}getElement(h){return this.trimmedHash[h]}get length(){return this.trimmedHash.length}getBoundaryScore(h){const g=h===0?0:M(this.lines[h-1]),L=h===this.lines.length?0:M(this.lines[h]);return 1e3-(g+L)}getText(h){return this.lines.slice(h.start,h.endExclusive).join(`
`)}isStronglyEqual(h,g){return this.lines[h]===this.lines[g]}}n.LineSequence=A;function M(i){let h=0;for(;h<i.length&&(i.charCodeAt(h)===32||i.charCodeAt(h)===9);)h++;return h}}),Y(X[15],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.isSpace=n.Array2D=void 0;class A{constructor(g,L){this.width=g,this.height=L,this.array=[],this.array=new Array(g*L)}get(g,L){return this.array[g+L*this.width]}set(g,L,l){this.array[g+L*this.width]=l}}n.Array2D=A;function M(h){return h===32||h===9}n.isSpace=M;class i{static getKey(g){let L=this.chrKeys.get(g);return L===void 0&&(L=this.chrKeys.size,this.chrKeys.set(g,L)),L}constructor(g,L,l){this.range=g,this.lines=L,this.source=l,this.histogram=[];let s=0;for(let _=g.startLineNumber-1;_<g.endLineNumberExclusive-1;_++){const e=L[_];for(let u=0;u<e.length;u++){s++;const f=e[u],m=i.getKey(f);this.histogram[m]=(this.histogram[m]||0)+1}s++;const b=i.getKey(`
`);this.histogram[b]=(this.histogram[b]||0)+1}this.totalCount=s}computeSimilarity(g){var L,l;let s=0;const _=Math.max(this.histogram.length,g.histogram.length);for(let e=0;e<_;e++)s+=Math.abs(((L=this.histogram[e])!==null&&L!==void 0?L:0)-((l=g.histogram[e])!==null&&l!==void 0?l:0));return 1-s/(this.totalCount+g.totalCount)}}n.LineRangeFragment=i,i.chrKeys=new Map}),Y(X[45],J([0,1,3,7,15]),function(T,n,A,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class h{compute(L,l,s=M.InfiniteTimeout.instance,_){if(L.length===0||l.length===0)return M.DiffAlgorithmResult.trivial(L,l);const e=new i.Array2D(L.length,l.length),b=new i.Array2D(L.length,l.length),u=new i.Array2D(L.length,l.length);for(let p=0;p<L.length;p++)for(let S=0;S<l.length;S++){if(!s.isValid())return M.DiffAlgorithmResult.trivialTimedOut(L,l);const r=p===0?0:e.get(p-1,S),o=S===0?0:e.get(p,S-1);let a;L.getElement(p)===l.getElement(S)?(p===0||S===0?a=0:a=e.get(p-1,S-1),p>0&&S>0&&b.get(p-1,S-1)===3&&(a+=u.get(p-1,S-1)),a+=_?_(p,S):1):a=-1;const v=Math.max(r,o,a);if(v===a){const d=p>0&&S>0?u.get(p-1,S-1):0;u.set(p,S,d+1),b.set(p,S,3)}else v===r?(u.set(p,S,0),b.set(p,S,1)):v===o&&(u.set(p,S,0),b.set(p,S,2));e.set(p,S,v)}const f=[];let m=L.length,c=l.length;function y(p,S){(p+1!==m||S+1!==c)&&f.push(new M.SequenceDiff(new A.OffsetRange(p+1,m),new A.OffsetRange(S+1,c))),m=p,c=S}let w=L.length-1,N=l.length-1;for(;w>=0&&N>=0;)b.get(w,N)===3?(y(w,N),w--,N--):b.get(w,N)===1?w--:N--;return y(-1,-1),f.reverse(),new M.DiffAlgorithmResult(f,!1)}}n.DynamicProgrammingDiffing=h}),Y(X[30],J([0,1,11,3,4,2,15]),function(T,n,A,M,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class L{constructor(u,f,m){this.lines=u,this.considerWhitespaceChanges=m,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let c=!1;f.start>0&&f.endExclusive>=u.length&&(f=new M.OffsetRange(f.start-1,f.endExclusive),c=!0),this.lineRange=f,this.firstCharOffsetByLine[0]=0;for(let y=this.lineRange.start;y<this.lineRange.endExclusive;y++){let w=u[y],N=0;if(c)N=w.length,w="",c=!1;else if(!m){const p=w.trimStart();N=w.length-p.length,w=p.trimEnd()}this.additionalOffsetByLine.push(N);for(let p=0;p<w.length;p++)this.elements.push(w.charCodeAt(p));y<u.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLine[y-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new M.OffsetRange(0,this.length))}getText(u){return this.elements.slice(u.start,u.endExclusive).map(f=>String.fromCharCode(f)).join("")}getElement(u){return this.elements[u]}get length(){return this.elements.length}getBoundaryScore(u){const f=e(u>0?this.elements[u-1]:-1),m=e(u<this.elements.length?this.elements[u]:-1);if(f===6&&m===7)return 0;let c=0;return f!==m&&(c+=10,m===1&&(c+=1)),c+=_(f),c+=_(m),c}translateOffset(u){if(this.lineRange.isEmpty)return new i.Position(this.lineRange.start+1,1);const f=(0,A.findLastIdxMonotonous)(this.firstCharOffsetByLine,m=>m<=u);return new i.Position(this.lineRange.start+f+1,u-this.firstCharOffsetByLine[f]+this.additionalOffsetByLine[f]+1)}translateRange(u){return h.Range.fromPositions(this.translateOffset(u.start),this.translateOffset(u.endExclusive))}findWordContaining(u){if(u<0||u>=this.elements.length||!l(this.elements[u]))return;let f=u;for(;f>0&&l(this.elements[f-1]);)f--;let m=u;for(;m<this.elements.length&&l(this.elements[m]);)m++;return new M.OffsetRange(f,m)}countLinesIn(u){return this.translateOffset(u.endExclusive).lineNumber-this.translateOffset(u.start).lineNumber}isStronglyEqual(u,f){return this.elements[u]===this.elements[f]}extendToFullLines(u){var f,m;const c=(f=(0,A.findLastMonotonous)(this.firstCharOffsetByLine,w=>w<=u.start))!==null&&f!==void 0?f:0,y=(m=(0,A.findFirstMonotonous)(this.firstCharOffsetByLine,w=>u.endExclusive<=w))!==null&&m!==void 0?m:this.elements.length;return new M.OffsetRange(c,y)}}n.LinesSliceCharSequence=L;function l(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}const s={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function _(b){return s[b]}function e(b){return b===10?7:b===13?6:(0,g.isSpace)(b)?5:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:4}}),Y(X[31],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class A{constructor(h,g,L){this.changes=h,this.moves=g,this.hitTimeout=L}}n.LinesDiff=A;class M{constructor(h,g){this.lineRangeMapping=h,this.changes=g}}n.MovedText=M}),Y(X[16],J([0,1,10]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class M{static inverse(L,l,s){const _=[];let e=1,b=1;for(const f of L){const m=new i(new A.LineRange(e,f.original.startLineNumber),new A.LineRange(b,f.modified.startLineNumber),void 0);m.modified.isEmpty||_.push(m),e=f.original.endLineNumberExclusive,b=f.modified.endLineNumberExclusive}const u=new i(new A.LineRange(e,l+1),new A.LineRange(b,s+1),void 0);return u.modified.isEmpty||_.push(u),_}constructor(L,l){this.original=L,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}join(L){return new M(this.original.join(L.original),this.modified.join(L.modified))}}n.LineRangeMapping=M;class i extends M{constructor(L,l,s){super(L,l),this.innerChanges=s}}n.DetailedLineRangeMapping=i;class h{constructor(L,l){this.originalRange=L,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=h}),Y(X[46],J([0,1,7,16,8,11,33,10,3,30,15,29]),function(T,n,A,M,i,h,g,L,l,s,_,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=void 0;function b(w,N,p,S,r,o){let{moves:a,excludedChanges:v}=u(w,N,p,o);if(!o.isValid())return[];const d=w.filter(R=>!v.has(R)),C=f(d,S,r,N,p,o);return(0,i.pushMany)(a,C),a=c(a),a=a.filter(R=>R.original.toOffsetRange().slice(N).map(D=>D.trim()).join(`
`).length>=10),a=y(w,a),a}n.computeMovedLines=b;function u(w,N,p,S){const r=[],o=w.filter(d=>d.modified.isEmpty&&d.original.length>=3).map(d=>new _.LineRangeFragment(d.original,N,d)),a=new Set(w.filter(d=>d.original.isEmpty&&d.modified.length>=3).map(d=>new _.LineRangeFragment(d.modified,p,d))),v=new Set;for(const d of o){let C=-1,R;for(const E of a){const D=d.computeSimilarity(E);D>C&&(C=D,R=E)}if(C>.9&&R&&(a.delete(R),r.push(new M.LineRangeMapping(d.range,R.range)),v.add(d.source),v.add(R.source)),!S.isValid())return{moves:r,excludedChanges:v}}return{moves:r,excludedChanges:v}}function f(w,N,p,S,r,o){const a=[],v=new g.SetMap;for(const D of w)for(let F=D.original.startLineNumber;F<D.original.endLineNumberExclusive-2;F++){const B=`${N[F-1]}:${N[F+1-1]}:${N[F+2-1]}`;v.add(B,{range:new L.LineRange(F,F+3)})}const d=[];w.sort((0,i.compareBy)(D=>D.modified.startLineNumber,i.numberComparator));for(const D of w){let F=[];for(let B=D.modified.startLineNumber;B<D.modified.endLineNumberExclusive-2;B++){const I=`${p[B-1]}:${p[B+1-1]}:${p[B+2-1]}`,U=new L.LineRange(B,B+3),x=[];v.forEach(I,({range:k})=>{for(const W of F)if(W.originalLineRange.endLineNumberExclusive+1===k.endLineNumberExclusive&&W.modifiedLineRange.endLineNumberExclusive+1===U.endLineNumberExclusive){W.originalLineRange=new L.LineRange(W.originalLineRange.startLineNumber,k.endLineNumberExclusive),W.modifiedLineRange=new L.LineRange(W.modifiedLineRange.startLineNumber,U.endLineNumberExclusive),x.push(W);return}const O={modifiedLineRange:U,originalLineRange:k};d.push(O),x.push(O)}),F=x}if(!o.isValid())return[]}d.sort((0,i.reverseOrder)((0,i.compareBy)(D=>D.modifiedLineRange.length,i.numberComparator)));const C=new L.LineRangeSet,R=new L.LineRangeSet;for(const D of d){const F=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,B=C.subtractFrom(D.modifiedLineRange),I=R.subtractFrom(D.originalLineRange).getWithDelta(F),U=B.getIntersection(I);for(const x of U.ranges){if(x.length<3)continue;const k=x,O=x.delta(-F);a.push(new M.LineRangeMapping(O,k)),C.addRange(k),R.addRange(O)}}a.sort((0,i.compareBy)(D=>D.original.startLineNumber,i.numberComparator));const E=new h.MonotonousArray(w);for(let D=0;D<a.length;D++){const F=a[D],B=E.findLastMonotonous(G=>G.original.startLineNumber<=F.original.startLineNumber),I=(0,h.findLastMonotonous)(w,G=>G.modified.startLineNumber<=F.modified.startLineNumber),U=Math.max(F.original.startLineNumber-B.original.startLineNumber,F.modified.startLineNumber-I.modified.startLineNumber),x=E.findLastMonotonous(G=>G.original.startLineNumber<F.original.endLineNumberExclusive),k=(0,h.findLastMonotonous)(w,G=>G.modified.startLineNumber<F.modified.endLineNumberExclusive),O=Math.max(x.original.endLineNumberExclusive-F.original.endLineNumberExclusive,k.modified.endLineNumberExclusive-F.modified.endLineNumberExclusive);let W;for(W=0;W<U;W++){const G=F.original.startLineNumber-W-1,t=F.modified.startLineNumber-W-1;if(C.contains(t)||R.contains(G)||!m(S[G-1],r[t-1],o))break}W>0&&(R.addRange(new L.LineRange(F.original.startLineNumber-W,F.original.startLineNumber)),C.addRange(new L.LineRange(F.modified.startLineNumber-W,F.modified.startLineNumber)));let z;for(z=0;z<O;z++){const G=F.original.endLineNumberExclusive+z,t=F.modified.endLineNumberExclusive+z;if(C.contains(t)||R.contains(G)||!m(S[G-1],r[t-1],o))break}z>0&&(R.addRange(new L.LineRange(F.original.endLineNumberExclusive,F.original.endLineNumberExclusive+z)),C.addRange(new L.LineRange(F.modified.endLineNumberExclusive,F.modified.endLineNumberExclusive+z))),(W>0||z>0)&&(a[D]=new M.LineRangeMapping(new L.LineRange(F.original.startLineNumber-W,F.original.endLineNumberExclusive+z),new L.LineRange(F.modified.startLineNumber-W,F.modified.endLineNumberExclusive+z)))}return a}function m(w,N,p){if(w.trim()===N.trim())return!0;if(w.length>300&&N.length>300)return!1;const r=new e.MyersDiffAlgorithm().compute(new s.LinesSliceCharSequence([w],new l.OffsetRange(0,1),!1),new s.LinesSliceCharSequence([N],new l.OffsetRange(0,1),!1),p);let o=0;const a=A.SequenceDiff.invert(r.diffs,w.length);for(const R of a)R.seq1Range.forEach(E=>{(0,_.isSpace)(w.charCodeAt(E))||o++});function v(R){let E=0;for(let D=0;D<w.length;D++)(0,_.isSpace)(R.charCodeAt(D))||E++;return E}const d=v(w.length>N.length?w:N);return o/d>.6&&d>10}function c(w){if(w.length===0)return w;w.sort((0,i.compareBy)(p=>p.original.startLineNumber,i.numberComparator));const N=[w[0]];for(let p=1;p<w.length;p++){const S=N[N.length-1],r=w[p],o=r.original.startLineNumber-S.original.endLineNumberExclusive,a=r.modified.startLineNumber-S.modified.endLineNumberExclusive;if(o>=0&&a>=0&&o+a<=2){N[N.length-1]=S.join(r);continue}N.push(r)}return N}function y(w,N){const p=new h.MonotonousArray(w);return N=N.filter(S=>{const r=p.findLastMonotonous(d=>d.original.endLineNumberExclusive<=S.original.startLineNumber)||new M.LineRangeMapping(new L.LineRange(1,1),new L.LineRange(1,1)),o=S.modified.startLineNumber-r.modified.endLineNumberExclusive,a=S.original.startLineNumber-r.original.endLineNumberExclusive;return o!==a}),N}}),Y(X[47],J([0,1,8,12,10,3,2,7,45,29,46,43,31,16,30,44]),function(T,n,A,M,i,h,g,L,l,s,_,e,b,u,f,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.DefaultLinesDiffComputer=void 0;class c{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new s.MyersDiffAlgorithm}computeDiff(p,S,r){if(p.length<=1&&(0,A.equals)(p,S,(G,t)=>G===t))return new b.LinesDiff([],[],!1);if(p.length===1&&p[0].length===0||S.length===1&&S[0].length===0)return new b.LinesDiff([new u.DetailedLineRangeMapping(new i.LineRange(1,p.length+1),new i.LineRange(1,S.length+1),[new u.RangeMapping(new g.Range(1,1,p.length,p[0].length+1),new g.Range(1,1,S.length,S[0].length+1))])],[],!1);const o=r.maxComputationTimeMs===0?L.InfiniteTimeout.instance:new L.DateTimeout(r.maxComputationTimeMs),a=!r.ignoreTrimWhitespace,v=new Map;function d(G){let t=v.get(G);return t===void 0&&(t=v.size,v.set(G,t)),t}const C=p.map(G=>d(G.trim())),R=S.map(G=>d(G.trim())),E=new m.LineSequence(C,p),D=new m.LineSequence(R,S),F=(()=>E.length+D.length<1700?this.dynamicProgrammingDiffing.compute(E,D,o,(G,t)=>p[G]===S[t]?S[t].length===0?.1:1+Math.log(1+S[t].length):.99):this.myersDiffingAlgorithm.compute(E,D))();let B=F.diffs,I=F.hitTimeout;B=(0,e.optimizeSequenceDiffs)(E,D,B),B=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(E,D,B);const U=[],x=G=>{if(a)for(let t=0;t<G;t++){const ne=k+t,se=O+t;if(p[ne]!==S[se]){const ue=this.refineDiff(p,S,new L.SequenceDiff(new h.OffsetRange(ne,ne+1),new h.OffsetRange(se,se+1)),o,a);for(const me of ue.mappings)U.push(me);ue.hitTimeout&&(I=!0)}}};let k=0,O=0;for(const G of B){(0,M.assertFn)(()=>G.seq1Range.start-k===G.seq2Range.start-O);const t=G.seq1Range.start-k;x(t),k=G.seq1Range.endExclusive,O=G.seq2Range.endExclusive;const ne=this.refineDiff(p,S,G,o,a);ne.hitTimeout&&(I=!0);for(const se of ne.mappings)U.push(se)}x(p.length-k);const W=y(U,p,S);let z=[];return r.computeMoves&&(z=this.computeMoves(W,p,S,C,R,o,a)),(0,M.assertFn)(()=>{function G(ne,se){if(ne.lineNumber<1||ne.lineNumber>se.length)return!1;const ue=se[ne.lineNumber-1];return!(ne.column<1||ne.column>ue.length+1)}function t(ne,se){return!(ne.startLineNumber<1||ne.startLineNumber>se.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>se.length+1)}for(const ne of W){if(!ne.innerChanges)return!1;for(const se of ne.innerChanges)if(!(G(se.modifiedRange.getStartPosition(),S)&&G(se.modifiedRange.getEndPosition(),S)&&G(se.originalRange.getStartPosition(),p)&&G(se.originalRange.getEndPosition(),p)))return!1;if(!t(ne.modified,S)||!t(ne.original,p))return!1}return!0}),new b.LinesDiff(W,z,I)}computeMoves(p,S,r,o,a,v,d){return(0,_.computeMovedLines)(p,S,r,o,a,v).map(E=>{const D=this.refineDiff(S,r,new L.SequenceDiff(E.original.toOffsetRange(),E.modified.toOffsetRange()),v,d),F=y(D.mappings,S,r,!0);return new b.MovedText(E,F)})}refineDiff(p,S,r,o,a){const v=new f.LinesSliceCharSequence(p,r.seq1Range,a),d=new f.LinesSliceCharSequence(S,r.seq2Range,a),C=v.length+d.length<500?this.dynamicProgrammingDiffing.compute(v,d,o):this.myersDiffingAlgorithm.compute(v,d,o);let R=C.diffs;return R=(0,e.optimizeSequenceDiffs)(v,d,R),R=(0,e.extendDiffsToEntireWordIfAppropriate)(v,d,R),R=(0,e.removeShortMatches)(v,d,R),R=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(v,d,R),{mappings:R.map(D=>new u.RangeMapping(v.translateRange(D.seq1Range),d.translateRange(D.seq2Range))),hitTimeout:C.hitTimeout}}}n.DefaultLinesDiffComputer=c;function y(N,p,S,r=!1){const o=[];for(const a of(0,A.groupAdjacentBy)(N.map(v=>w(v,p,S)),(v,d)=>v.original.overlapOrTouch(d.original)||v.modified.overlapOrTouch(d.modified))){const v=a[0],d=a[a.length-1];o.push(new u.DetailedLineRangeMapping(v.original.join(d.original),v.modified.join(d.modified),a.map(C=>C.innerChanges[0])))}return(0,M.assertFn)(()=>!r&&o.length>0&&o[0].original.startLineNumber!==o[0].modified.startLineNumber?!1:(0,M.checkAdjacentItems)(o,(a,v)=>v.original.startLineNumber-a.original.endLineNumberExclusive===v.modified.startLineNumber-a.modified.endLineNumberExclusive&&a.original.endLineNumberExclusive<v.original.startLineNumber&&a.modified.endLineNumberExclusive<v.modified.startLineNumber)),o}n.lineRangeMappingFromRangeMappings=y;function w(N,p,S){let r=0,o=0;N.modifiedRange.endColumn===1&&N.originalRange.endColumn===1&&N.originalRange.startLineNumber+r<=N.originalRange.endLineNumber&&N.modifiedRange.startLineNumber+r<=N.modifiedRange.endLineNumber&&(o=-1),N.modifiedRange.startColumn-1>=S[N.modifiedRange.startLineNumber-1].length&&N.originalRange.startColumn-1>=p[N.originalRange.startLineNumber-1].length&&N.originalRange.startLineNumber<=N.originalRange.endLineNumber+o&&N.modifiedRange.startLineNumber<=N.modifiedRange.endLineNumber+o&&(r=1);const a=new i.LineRange(N.originalRange.startLineNumber+r,N.originalRange.endLineNumber+1+o),v=new i.LineRange(N.modifiedRange.startLineNumber+r,N.modifiedRange.endLineNumber+1+o);return new u.DetailedLineRangeMapping(a,v,[N])}n.getLineRangeMapping=w}),Y(X[48],J([0,1,24,31,16,6,2,12,10]),function(T,n,A,M,i,h,g,L,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const s=3;class _{computeDiff(r,o,a){var v;const C=new y(r,o,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),R=[];let E=null;for(const D of C.changes){let F;D.originalEndLineNumber===0?F=new l.LineRange(D.originalStartLineNumber+1,D.originalStartLineNumber+1):F=new l.LineRange(D.originalStartLineNumber,D.originalEndLineNumber+1);let B;D.modifiedEndLineNumber===0?B=new l.LineRange(D.modifiedStartLineNumber+1,D.modifiedStartLineNumber+1):B=new l.LineRange(D.modifiedStartLineNumber,D.modifiedEndLineNumber+1);let I=new i.DetailedLineRangeMapping(F,B,(v=D.charChanges)===null||v===void 0?void 0:v.map(U=>new i.RangeMapping(new g.Range(U.originalStartLineNumber,U.originalStartColumn,U.originalEndLineNumber,U.originalEndColumn),new g.Range(U.modifiedStartLineNumber,U.modifiedStartColumn,U.modifiedEndLineNumber,U.modifiedEndColumn))));E&&(E.modified.endLineNumberExclusive===I.modified.startLineNumber||E.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new i.DetailedLineRangeMapping(E.original.join(I.original),E.modified.join(I.modified),E.innerChanges&&I.innerChanges?E.innerChanges.concat(I.innerChanges):void 0),R.pop()),R.push(I),E=I}return(0,L.assertFn)(()=>(0,L.checkAdjacentItems)(R,(D,F)=>F.original.startLineNumber-D.original.endLineNumberExclusive===F.modified.startLineNumber-D.modified.endLineNumberExclusive&&D.original.endLineNumberExclusive<F.original.startLineNumber&&D.modified.endLineNumberExclusive<F.modified.startLineNumber)),new M.LinesDiff(R,[],C.quitEarly)}}n.LegacyLinesDiffComputer=_;function e(S,r,o,a){return new A.LcsDiff(S,r,o).ComputeDiff(a)}class b{constructor(r){const o=[],a=[];for(let v=0,d=r.length;v<d;v++)o[v]=w(r[v],1),a[v]=N(r[v],1);this.lines=r,this._startColumns=o,this._endColumns=a}getElements(){const r=[];for(let o=0,a=this.lines.length;o<a;o++)r[o]=this.lines[o].substring(this._startColumns[o]-1,this._endColumns[o]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,o,a){const v=[],d=[],C=[];let R=0;for(let E=o;E<=a;E++){const D=this.lines[E],F=r?this._startColumns[E]:1,B=r?this._endColumns[E]:D.length+1;for(let I=F;I<B;I++)v[R]=D.charCodeAt(I-1),d[R]=E+1,C[R]=I,R++;!r&&E<a&&(v[R]=10,d[R]=E+1,C[R]=D.length+1,R++)}return new u(v,d,C)}}class u{constructor(r,o,a){this._charCodes=r,this._lineNumbers=o,this._columns=a}toString(){return"["+this._charCodes.map((r,o)=>(r===10?"\\n":String.fromCharCode(r))+`-(${this._lineNumbers[o]},${this._columns[o]})`).join(", ")+"]"}_assertIndex(r,o){if(r<0||r>=o.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(r){return r>0&&r===this._lineNumbers.length?this.getEndLineNumber(r-1):(this._assertIndex(r,this._lineNumbers),this._lineNumbers[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this._assertIndex(r,this._lineNumbers),this._charCodes[r]===10?this._lineNumbers[r]+1:this._lineNumbers[r])}getStartColumn(r){return r>0&&r===this._columns.length?this.getEndColumn(r-1):(this._assertIndex(r,this._columns),this._columns[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this._assertIndex(r,this._columns),this._charCodes[r]===10?1:this._columns[r]+1)}}class f{constructor(r,o,a,v,d,C,R,E){this.originalStartLineNumber=r,this.originalStartColumn=o,this.originalEndLineNumber=a,this.originalEndColumn=v,this.modifiedStartLineNumber=d,this.modifiedStartColumn=C,this.modifiedEndLineNumber=R,this.modifiedEndColumn=E}static createFromDiffChange(r,o,a){const v=o.getStartLineNumber(r.originalStart),d=o.getStartColumn(r.originalStart),C=o.getEndLineNumber(r.originalStart+r.originalLength-1),R=o.getEndColumn(r.originalStart+r.originalLength-1),E=a.getStartLineNumber(r.modifiedStart),D=a.getStartColumn(r.modifiedStart),F=a.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),B=a.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new f(v,d,C,R,E,D,F,B)}}function m(S){if(S.length<=1)return S;const r=[S[0]];let o=r[0];for(let a=1,v=S.length;a<v;a++){const d=S[a],C=d.originalStart-(o.originalStart+o.originalLength),R=d.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(C,R)<s?(o.originalLength=d.originalStart+d.originalLength-o.originalStart,o.modifiedLength=d.modifiedStart+d.modifiedLength-o.modifiedStart):(r.push(d),o=d)}return r}class c{constructor(r,o,a,v,d){this.originalStartLineNumber=r,this.originalEndLineNumber=o,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=v,this.charChanges=d}static createFromDiffResult(r,o,a,v,d,C,R){let E,D,F,B,I;if(o.originalLength===0?(E=a.getStartLineNumber(o.originalStart)-1,D=0):(E=a.getStartLineNumber(o.originalStart),D=a.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(F=v.getStartLineNumber(o.modifiedStart)-1,B=0):(F=v.getStartLineNumber(o.modifiedStart),B=v.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),C&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&d()){const U=a.createCharSequence(r,o.originalStart,o.originalStart+o.originalLength-1),x=v.createCharSequence(r,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(U.getElements().length>0&&x.getElements().length>0){let k=e(U,x,d,!0).changes;R&&(k=m(k)),I=[];for(let O=0,W=k.length;O<W;O++)I.push(f.createFromDiffChange(k[O],U,x))}}return new c(E,D,F,B,I)}}class y{constructor(r,o,a){this.shouldComputeCharChanges=a.shouldComputeCharChanges,this.shouldPostProcessCharChanges=a.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=a.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=a.shouldMakePrettyDiff,this.originalLines=r,this.modifiedLines=o,this.original=new b(r),this.modified=new b(o),this.continueLineDiff=p(a.maxComputationTime),this.continueCharDiff=p(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),o=r.changes,a=r.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let E=0,D=o.length;E<D;E++)R.push(c.createFromDiffResult(this.shouldIgnoreTrimWhitespace,o[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:a,changes:R}}const v=[];let d=0,C=0;for(let R=-1,E=o.length;R<E;R++){const D=R+1<E?o[R+1]:null,F=D?D.originalStart:this.originalLines.length,B=D?D.modifiedStart:this.modifiedLines.length;for(;d<F&&C<B;){const I=this.originalLines[d],U=this.modifiedLines[C];if(I!==U){{let x=w(I,1),k=w(U,1);for(;x>1&&k>1;){const O=I.charCodeAt(x-2),W=U.charCodeAt(k-2);if(O!==W)break;x--,k--}(x>1||k>1)&&this._pushTrimWhitespaceCharChange(v,d+1,1,x,C+1,1,k)}{let x=N(I,1),k=N(U,1);const O=I.length+1,W=U.length+1;for(;x<O&&k<W;){const z=I.charCodeAt(x-1),G=I.charCodeAt(k-1);if(z!==G)break;x++,k++}(x<O||k<W)&&this._pushTrimWhitespaceCharChange(v,d+1,x,O,C+1,k,W)}}d++,C++}D&&(v.push(c.createFromDiffResult(this.shouldIgnoreTrimWhitespace,D,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),d+=D.originalLength,C+=D.modifiedLength)}return{quitEarly:a,changes:v}}_pushTrimWhitespaceCharChange(r,o,a,v,d,C,R){if(this._mergeTrimWhitespaceCharChange(r,o,a,v,d,C,R))return;let E;this.shouldComputeCharChanges&&(E=[new f(o,a,o,v,d,C,d,R)]),r.push(new c(o,o,d,d,E))}_mergeTrimWhitespaceCharChange(r,o,a,v,d,C,R){const E=r.length;if(E===0)return!1;const D=r[E-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===o&&D.modifiedEndLineNumber===d?(this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new f(o,a,o,v,d,C,d,R)),!0):D.originalEndLineNumber+1===o&&D.modifiedEndLineNumber+1===d?(D.originalEndLineNumber=o,D.modifiedEndLineNumber=d,this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new f(o,a,o,v,d,C,d,R)),!0):!1}}n.DiffComputer=y;function w(S,r){const o=h.firstNonWhitespaceIndex(S);return o===-1?r:o+1}function N(S,r){const o=h.lastNonWhitespaceIndex(S);return o===-1?r:o+2}function p(S){if(S===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<S}}),Y(X[49],J([0,1,48,47]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new A.LegacyLinesDiffComputer,getDefault:()=>new M.DefaultLinesDiffComputer}}),Y(X[50],J([0,1,34]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function M(b){const u=[];for(const f of b){const m=Number(f);(m||m===0&&f.replace(/\s/g,"")!=="")&&u.push(m)}return u}function i(b,u,f,m){return{red:b/255,blue:f/255,green:u/255,alpha:m}}function h(b,u){const f=u.index,m=u[0].length;if(!f)return;const c=b.positionAt(f);return{startLineNumber:c.lineNumber,startColumn:c.column,endLineNumber:c.lineNumber,endColumn:c.column+m}}function g(b,u){if(!b)return;const f=A.Color.Format.CSS.parseHex(u);if(f)return{range:b,color:i(f.rgba.r,f.rgba.g,f.rgba.b,f.rgba.a)}}function L(b,u,f){if(!b||u.length!==1)return;const c=u[0].values(),y=M(c);return{range:b,color:i(y[0],y[1],y[2],f?y[3]:1)}}function l(b,u,f){if(!b||u.length!==1)return;const c=u[0].values(),y=M(c),w=new A.Color(new A.HSLA(y[0],y[1]/100,y[2]/100,f?y[3]:1));return{range:b,color:i(w.rgba.r,w.rgba.g,w.rgba.b,w.rgba.a)}}function s(b,u){return typeof b=="string"?[...b.matchAll(u)]:b.findMatches(u)}function _(b){const u=[],m=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const c of m){const y=c.filter(S=>S!==void 0),w=y[1],N=y[2];if(!N)continue;let p;if(w==="rgb"){const S=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;p=L(h(b,c),s(N,S),!1)}else if(w==="rgba"){const S=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=L(h(b,c),s(N,S),!0)}else if(w==="hsl"){const S=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;p=l(h(b,c),s(N,S),!1)}else if(w==="hsla"){const S=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=l(h(b,c),s(N,S),!0)}else w==="#"&&(p=g(h(b,c),w+N));p&&u.push(p)}return u}function e(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:_(b)}n.computeDefaultDocumentColors=e}),Y(X[51],J([0,1,27]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class M{constructor(b,u,f){const m=new Uint8Array(b*u);for(let c=0,y=b*u;c<y;c++)m[c]=f;this._data=m,this.rows=b,this.cols=u}get(b,u){return this._data[b*this.cols+u]}set(b,u,f){this._data[b*this.cols+u]=f}}class i{constructor(b){let u=0,f=0;for(let c=0,y=b.length;c<y;c++){const[w,N,p]=b[c];N>u&&(u=N),w>f&&(f=w),p>f&&(f=p)}u++,f++;const m=new M(f,u,0);for(let c=0,y=b.length;c<y;c++){const[w,N,p]=b[c];m.set(w,N,p)}this._states=m,this._maxCharCode=u}nextState(b,u){return u<0||u>=this._maxCharCode?0:this._states.get(b,u)}}n.StateMachine=i;let h=null;function g(){return h===null&&(h=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),h}let L=null;function l(){if(L===null){L=new A.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<e.length;u++)L.set(e.charCodeAt(u),1);const b=".,;:";for(let u=0;u<b.length;u++)L.set(b.charCodeAt(u),2)}return L}class s{static _createLink(b,u,f,m,c){let y=c-1;do{const w=u.charCodeAt(y);if(b.get(w)!==2)break;y--}while(y>m);if(m>0){const w=u.charCodeAt(m-1),N=u.charCodeAt(y);(w===40&&N===41||w===91&&N===93||w===123&&N===125)&&y--}return{range:{startLineNumber:f,startColumn:m+1,endLineNumber:f,endColumn:y+2},url:u.substring(m,y+1)}}static computeLinks(b,u=g()){const f=l(),m=[];for(let c=1,y=b.getLineCount();c<=y;c++){const w=b.getLineContent(c),N=w.length;let p=0,S=0,r=0,o=1,a=!1,v=!1,d=!1,C=!1;for(;p<N;){let R=!1;const E=w.charCodeAt(p);if(o===13){let D;switch(E){case 40:a=!0,D=0;break;case 41:D=a?0:1;break;case 91:d=!0,v=!0,D=0;break;case 93:d=!1,D=v?0:1;break;case 123:C=!0,D=0;break;case 125:D=C?0:1;break;case 39:case 34:case 96:r===E?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=d?0:1;break;default:D=f.get(E)}D===1&&(m.push(s._createLink(f,w,c,S,p)),R=!0)}else if(o===12){let D;E===91?(v=!0,D=0):D=f.get(E),D===1?R=!0:o=13}else o=u.nextState(o,E),o===0&&(R=!0);R&&(o=1,a=!1,v=!1,C=!1,S=p+1,r=E),p++}o===13&&m.push(s._createLink(f,w,c,S,N))}return m}}n.LinkComputer=s;function _(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:s.computeLinks(e)}n.computeLinks=_}),Y(X[52],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class A{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,h,g,L,l){if(i&&h){const s=this.doNavigateValueSet(h,l);if(s)return{range:i,value:s}}if(g&&L){const s=this.doNavigateValueSet(L,l);if(s)return{range:g,value:s}}return null}doNavigateValueSet(i,h){const g=this.numberReplace(i,h);return g!==null?g:this.textReplace(i,h)}numberReplace(i,h){const g=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let L=Number(i);const l=parseFloat(i);return!isNaN(L)&&!isNaN(l)&&L===l?L===0&&!h?null:(L=Math.floor(L*g),L+=h?g:-g,String(L/g)):null}textReplace(i,h){return this.valueSetsReplace(this._defaultValueSet,i,h)}valueSetsReplace(i,h,g){let L=null;for(let l=0,s=i.length;L===null&&l<s;l++)L=this.valueSetReplace(i[l],h,g);return L}valueSetReplace(i,h,g){let L=i.indexOf(h);return L>=0?(L+=g?1:-1,L<0?L=i.length-1:L%=i.length,i[L]):null}}n.BasicInplaceReplace=A,A.INSTANCE=new A}),Y(X[53],J([0,1,14]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var M;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(M||(n.OverviewRulerLane=M={}));var i;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var h;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(h||(n.MinimapPosition=h={}));var g;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(g||(n.InjectedTextCursorStops=g={}));class L{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,m.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!m.insertSpaces,this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=!!m.trimAutoWhitespace,this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this._indentSizeIsTabSize===m._indentSizeIsTabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,A.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}n.TextModelResolvedOptions=L;class l{constructor(m,c){this._findMatchBrand=void 0,this.range=m,this.matches=c}}n.FindMatch=l;function s(f){return f&&typeof f.read=="function"}n.isITextSnapshot=s;class _{constructor(m,c,y,w,N,p){this.identifier=m,this.range=c,this.text=y,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=N,this._isTracked=p}}n.ValidAnnotatedEditOperation=_;class e{constructor(m,c,y){this.regex=m,this.wordSeparators=c,this.simpleSearch=y}}n.SearchData=e;class b{constructor(m,c,y){this.reverseEdits=m,this.changes=c,this.trimAutoWhitespaceLineNumbers=y}}n.ApplyEditsResult=b;function u(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}n.shouldSynchronizeModel=u}),Y(X[54],J([0,1,8,26]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(l,s){l=(0,M.toUint32)(l);const _=this.values,e=this.prefixSum,b=s.length;return b===0?!1:(this.values=new Uint32Array(_.length+b),this.values.set(_.subarray(0,l),0),this.values.set(_.subarray(l),l+b),this.values.set(s,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,s){return l=(0,M.toUint32)(l),s=(0,M.toUint32)(s),this.values[l]===s?!1:(this.values[l]=s,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,s){l=(0,M.toUint32)(l),s=(0,M.toUint32)(s);const _=this.values,e=this.prefixSum;if(l>=_.length)return!1;const b=_.length-l;return s>=b&&(s=b),s===0?!1:(this.values=new Uint32Array(_.length-s),this.values.set(_.subarray(0,l),0),this.values.set(_.subarray(l+s),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,M.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),l>=this.values.length&&(l=this.values.length-1);for(let _=s;_<=l;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,_=this.values.length-1,e=0,b=0,u=0;for(;s<=_;)if(e=s+(_-s)/2|0,b=this.prefixSum[e],u=b-this.values[e],l<u)_=e-1;else if(l>=b)s=e+1;else break;return new g(e,l-u)}}n.PrefixSumComputer=i;class h{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const s=this._indexBySum[l],_=s>0?this._prefixSum[s-1]:0;return new g(s,l-_)}removeValues(l,s){this._values.splice(l,s),this._invalidate(l)}insertValues(l,s){this._values=(0,A.arrayInsert)(this._values,l,s),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,s=this._values.length;l<s;l++){const _=this._values[l],e=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=e+_;for(let b=0;b<_;b++)this._indexBySum[e+b]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,s){this._values[l]!==s&&(this._values[l]=s,this._invalidate(l))}}n.ConstantTimePrefixSumComputer=h;class g{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}n.PrefixSumIndexOfResult=g}),Y(X[55],J([0,1,6,4,54]),function(T,n,A,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class h{constructor(L,l,s,_){this._uri=L,this._lines=l,this._eol=s,this._versionId=_,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(L){L.eol&&L.eol!==this._eol&&(this._eol=L.eol,this._lineStarts=null);const l=L.changes;for(const s of l)this._acceptDeleteRange(s.range),this._acceptInsertText(new M.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=L.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const L=this._eol.length,l=this._lines.length,s=new Uint32Array(l);for(let _=0;_<l;_++)s[_]=this._lines[_].length+L;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(L,l){this._lines[L]=l,this._lineStarts&&this._lineStarts.setValue(L,this._lines[L].length+this._eol.length)}_acceptDeleteRange(L){if(L.startLineNumber===L.endLineNumber){if(L.startColumn===L.endColumn)return;this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.startLineNumber-1].substring(L.endColumn-1));return}this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.endLineNumber-1].substring(L.endColumn-1)),this._lines.splice(L.startLineNumber,L.endLineNumber-L.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(L.startLineNumber,L.endLineNumber-L.startLineNumber)}_acceptInsertText(L,l){if(l.length===0)return;const s=(0,A.splitLines)(l);if(s.length===1){this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+s[0]+this._lines[L.lineNumber-1].substring(L.column-1));return}s[s.length-1]+=this._lines[L.lineNumber-1].substring(L.column-1),this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+s[0]);const _=new Uint32Array(s.length-1);for(let e=1;e<s.length;e++)this._lines.splice(L.lineNumber+e-1,0,s[e]),_[e-1]=s[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(L.lineNumber,_)}}n.MirrorTextModel=h}),Y(X[56],J([0,1,6,42,4,2,53]),function(T,n,A,M,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const L=999;class l{constructor(w,N,p,S){this.searchString=w,this.isRegex=N,this.matchCase=p,this.wordSeparators=S}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=s(this.searchString):w=this.searchString.indexOf(`
`)>=0;let N=null;try{N=A.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!N)return null;let p=!this.isRegex&&!w;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new g.SearchData(N,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}n.SearchParams=l;function s(y){if(!y||y.length===0)return!1;for(let w=0,N=y.length;w<N;w++){const p=y.charCodeAt(w);if(p===10)return!0;if(p===92){if(w++,w>=N)break;const S=y.charCodeAt(w);if(S===110||S===114||S===87)return!0}}return!1}n.isMultilineRegexSource=s;function _(y,w,N){if(!N)return new g.FindMatch(y,null);const p=[];for(let S=0,r=w.length;S<r;S++)p[S]=w[S];return new g.FindMatch(y,p)}n.createFindMatch=_;class e{constructor(w){const N=[];let p=0;for(let S=0,r=w.length;S<r;S++)w.charCodeAt(S)===10&&(N[p++]=S);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(w){const N=this._lineFeedsOffsets;let p=0,S=N.length-1;if(S===-1||w<=N[0])return 0;for(;p<S;){const r=p+((S-p)/2>>0);N[r]>=w?S=r-1:N[r+1]>=w?(p=r,S=r):p=r+1}return p+1}}class b{static findMatches(w,N,p,S,r){const o=N.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(w,p,new c(o.wordSeparators,o.regex),S,r):this._doFindMatchesLineByLine(w,p,o,S,r):[]}static _getMultilineMatchRange(w,N,p,S,r,o){let a,v=0;S?(v=S.findLineFeedCountBeforeOffset(r),a=N+r+v):a=N+r;let d;if(S){const D=S.findLineFeedCountBeforeOffset(r+o.length)-v;d=a+o.length+D}else d=a+o.length;const C=w.getPositionAt(a),R=w.getPositionAt(d);return new h.Range(C.lineNumber,C.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(w,N,p,S,r){const o=w.getOffsetAt(N.getStartPosition()),a=w.getValueInRange(N,1),v=w.getEOL()===`\r
`?new e(a):null,d=[];let C=0,R;for(p.reset(0);R=p.next(a);)if(d[C++]=_(this._getMultilineMatchRange(w,o,a,v,R.index,R[0]),R,S),C>=r)return d;return d}static _doFindMatchesLineByLine(w,N,p,S,r){const o=[];let a=0;if(N.startLineNumber===N.endLineNumber){const d=w.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return a=this._findMatchesInLine(p,d,N.startLineNumber,N.startColumn-1,a,o,S,r),o}const v=w.getLineContent(N.startLineNumber).substring(N.startColumn-1);a=this._findMatchesInLine(p,v,N.startLineNumber,N.startColumn-1,a,o,S,r);for(let d=N.startLineNumber+1;d<N.endLineNumber&&a<r;d++)a=this._findMatchesInLine(p,w.getLineContent(d),d,0,a,o,S,r);if(a<r){const d=w.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);a=this._findMatchesInLine(p,d,N.endLineNumber,0,a,o,S,r)}return o}static _findMatchesInLine(w,N,p,S,r,o,a,v){const d=w.wordSeparators;if(!a&&w.simpleSearch){const E=w.simpleSearch,D=E.length,F=N.length;let B=-D;for(;(B=N.indexOf(E,B+D))!==-1;)if((!d||m(d,N,F,B,D))&&(o[r++]=new g.FindMatch(new h.Range(p,B+1+S,p,B+1+D+S),null),r>=v))return r;return r}const C=new c(w.wordSeparators,w.regex);let R;C.reset(0);do if(R=C.next(N),R&&(o[r++]=_(new h.Range(p,R.index+1+S,p,R.index+1+R[0].length+S),R,a),r>=v))return r;while(R);return r}static findNextMatch(w,N,p,S){const r=N.parseSearchRequest();if(!r)return null;const o=new c(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(w,p,o,S):this._doFindNextMatchLineByLine(w,p,o,S)}static _doFindNextMatchMultiline(w,N,p,S){const r=new i.Position(N.lineNumber,1),o=w.getOffsetAt(r),a=w.getLineCount(),v=w.getValueInRange(new h.Range(r.lineNumber,r.column,a,w.getLineMaxColumn(a)),1),d=w.getEOL()===`\r
`?new e(v):null;p.reset(N.column-1);const C=p.next(v);return C?_(this._getMultilineMatchRange(w,o,v,d,C.index,C[0]),C,S):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(w,new i.Position(1,1),p,S):null}static _doFindNextMatchLineByLine(w,N,p,S){const r=w.getLineCount(),o=N.lineNumber,a=w.getLineContent(o),v=this._findFirstMatchInLine(p,a,o,N.column,S);if(v)return v;for(let d=1;d<=r;d++){const C=(o+d-1)%r,R=w.getLineContent(C+1),E=this._findFirstMatchInLine(p,R,C+1,1,S);if(E)return E}return null}static _findFirstMatchInLine(w,N,p,S,r){w.reset(S-1);const o=w.next(N);return o?_(new h.Range(p,o.index+1,p,o.index+1+o[0].length),o,r):null}static findPreviousMatch(w,N,p,S){const r=N.parseSearchRequest();if(!r)return null;const o=new c(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(w,p,o,S):this._doFindPreviousMatchLineByLine(w,p,o,S)}static _doFindPreviousMatchMultiline(w,N,p,S){const r=this._doFindMatchesMultiline(w,new h.Range(1,1,N.lineNumber,N.column),p,S,10*L);if(r.length>0)return r[r.length-1];const o=w.getLineCount();return N.lineNumber!==o||N.column!==w.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(w,new i.Position(o,w.getLineMaxColumn(o)),p,S):null}static _doFindPreviousMatchLineByLine(w,N,p,S){const r=w.getLineCount(),o=N.lineNumber,a=w.getLineContent(o).substring(0,N.column-1),v=this._findLastMatchInLine(p,a,o,S);if(v)return v;for(let d=1;d<=r;d++){const C=(r+o-d-1)%r,R=w.getLineContent(C+1),E=this._findLastMatchInLine(p,R,C+1,S);if(E)return E}return null}static _findLastMatchInLine(w,N,p,S){let r=null,o;for(w.reset(0);o=w.next(N);)r=_(new h.Range(p,o.index+1,p,o.index+1+o[0].length),o,S);return r}}n.TextModelSearch=b;function u(y,w,N,p,S){if(p===0)return!0;const r=w.charCodeAt(p-1);if(y.get(r)!==0||r===13||r===10)return!0;if(S>0){const o=w.charCodeAt(p);if(y.get(o)!==0)return!0}return!1}function f(y,w,N,p,S){if(p+S===N)return!0;const r=w.charCodeAt(p+S);if(y.get(r)!==0||r===13||r===10)return!0;if(S>0){const o=w.charCodeAt(p+S-1);if(y.get(o)!==0)return!0}return!1}function m(y,w,N,p,S){return u(y,w,N,p,S)&&f(y,w,N,p,S)}n.isValidMatch=m;class c{constructor(w,N){this._wordSeparators=w,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(w){this._searchRegex.lastIndex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(w){const N=w.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(p=this._searchRegex.exec(w),!p))return null;const S=p.index,r=p[0].length;if(S===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){A.getNextCodePoint(w,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=S,this._prevMatchLength=r,!this._wordSeparators||m(this._wordSeparators,w,N,S,r))return p}while(p);return null}}n.Searcher=c}),Y(X[57],J([0,1,2,56,6,12,28]),function(T,n,A,M,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class L{static computeUnicodeHighlights(b,u,f){const m=f?f.startLineNumber:1,c=f?f.endLineNumber:b.getLineCount(),y=new s(u),w=y.getCandidateCodePoints();let N;w==="allNonBasicAscii"?N=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):N=new RegExp(`${l(Array.from(w))}`,"g");const p=new M.Searcher(null,N),S=[];let r=!1,o,a=0,v=0,d=0;e:for(let C=m,R=c;C<=R;C++){const E=b.getLineContent(C),D=E.length;p.reset(0);do if(o=p.next(E),o){let F=o.index,B=o.index+o[0].length;if(F>0){const k=E.charCodeAt(F-1);i.isHighSurrogate(k)&&F--}if(B+1<D){const k=E.charCodeAt(B-1);i.isHighSurrogate(k)&&B++}const I=E.substring(F,B);let U=(0,g.getWordAtText)(F+1,g.DEFAULT_WORD_REGEXP,E,0);U&&U.endColumn<=F+1&&(U=null);const x=y.shouldHighlightNonBasicASCII(I,U?U.word:null);if(x!==0){x===3?a++:x===2?v++:x===1?d++:(0,h.assertNever)(x);const k=1e3;if(S.length>=k){r=!0;break e}S.push(new A.Range(C,F+1,C,B+1))}}while(o)}return{ranges:S,hasMore:r,ambiguousCharacterCount:a,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:d}}static computeUnicodeHighlightReason(b,u){const f=new s(u);switch(f.shouldHighlightNonBasicASCII(b,null)){case 0:return null;case 2:return{kind:1};case 3:{const c=b.codePointAt(0),y=f.ambiguousCharacters.getPrimaryConfusable(c),w=i.AmbiguousCharacters.getLocales().filter(N=>!i.AmbiguousCharacters.getInstance(new Set([...u.allowedLocales,N])).isAmbiguous(c));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:w}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=L;function l(e,b){return`[${i.escapeRegExpCharacters(e.map(f=>String.fromCodePoint(f)).join(""))}]`}class s{constructor(b){this.options=b,this.allowedCodePoints=new Set(b.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(b.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const b=new Set;if(this.options.invisibleCharacters)for(const u of i.InvisibleCharacters.codePoints)_(String.fromCodePoint(u))||b.add(u);if(this.options.ambiguousCharacters)for(const u of this.ambiguousCharacters.getConfusableCodePoints())b.add(u);for(const u of this.allowedCodePoints)b.delete(u);return b}shouldHighlightNonBasicASCII(b,u){const f=b.codePointAt(0);if(this.allowedCodePoints.has(f))return 0;if(this.options.nonBasicASCII)return 1;let m=!1,c=!1;if(u)for(const y of u){const w=y.codePointAt(0),N=i.isBasicASCII(y);m=m||N,!N&&!this.ambiguousCharacters.isAmbiguous(w)&&!i.InvisibleCharacters.isInvisibleCharacter(w)&&(c=!0)}return!m&&c?0:this.options.invisibleCharacters&&!_(b)&&i.InvisibleCharacters.isInvisibleCharacter(f)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(f)?3:0}}function _(e){return e===" "||e===`
`||e==="	"}}),Y(X[58],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var A;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(A||(n.AccessibilitySupport=A={}));var M;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(M||(n.CodeActionTriggerType=M={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var h;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(h||(n.CompletionItemKind=h={}));var g;(function(t){t[t.Deprecated=1]="Deprecated"})(g||(n.CompletionItemTag=g={}));var L;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(n.CompletionTriggerKind=L={}));var l;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(l||(n.ContentWidgetPositionPreference=l={}));var s;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(s||(n.CursorChangeReason=s={}));var _;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(_||(n.DefaultEndOfLine=_={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var b;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(b||(n.EditorAutoIndentStrategy=b={}));var u;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=8]="autoClosingDelete",t[t.autoClosingOvertype=9]="autoClosingOvertype",t[t.autoClosingQuotes=10]="autoClosingQuotes",t[t.autoIndent=11]="autoIndent",t[t.automaticLayout=12]="automaticLayout",t[t.autoSurround=13]="autoSurround",t[t.bracketPairColorization=14]="bracketPairColorization",t[t.guides=15]="guides",t[t.codeLens=16]="codeLens",t[t.codeLensFontFamily=17]="codeLensFontFamily",t[t.codeLensFontSize=18]="codeLensFontSize",t[t.colorDecorators=19]="colorDecorators",t[t.colorDecoratorsLimit=20]="colorDecoratorsLimit",t[t.columnSelection=21]="columnSelection",t[t.comments=22]="comments",t[t.contextmenu=23]="contextmenu",t[t.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",t[t.cursorBlinking=25]="cursorBlinking",t[t.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",t[t.cursorStyle=27]="cursorStyle",t[t.cursorSurroundingLines=28]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",t[t.cursorWidth=30]="cursorWidth",t[t.disableLayerHinting=31]="disableLayerHinting",t[t.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",t[t.domReadOnly=33]="domReadOnly",t[t.dragAndDrop=34]="dragAndDrop",t[t.dropIntoEditor=35]="dropIntoEditor",t[t.emptySelectionClipboard=36]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",t[t.extraEditorClassName=38]="extraEditorClassName",t[t.fastScrollSensitivity=39]="fastScrollSensitivity",t[t.find=40]="find",t[t.fixedOverflowWidgets=41]="fixedOverflowWidgets",t[t.folding=42]="folding",t[t.foldingStrategy=43]="foldingStrategy",t[t.foldingHighlight=44]="foldingHighlight",t[t.foldingImportsByDefault=45]="foldingImportsByDefault",t[t.foldingMaximumRegions=46]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=48]="fontFamily",t[t.fontInfo=49]="fontInfo",t[t.fontLigatures=50]="fontLigatures",t[t.fontSize=51]="fontSize",t[t.fontWeight=52]="fontWeight",t[t.fontVariations=53]="fontVariations",t[t.formatOnPaste=54]="formatOnPaste",t[t.formatOnType=55]="formatOnType",t[t.glyphMargin=56]="glyphMargin",t[t.gotoLocation=57]="gotoLocation",t[t.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",t[t.hover=59]="hover",t[t.inDiffEditor=60]="inDiffEditor",t[t.inlineSuggest=61]="inlineSuggest",t[t.letterSpacing=62]="letterSpacing",t[t.lightbulb=63]="lightbulb",t[t.lineDecorationsWidth=64]="lineDecorationsWidth",t[t.lineHeight=65]="lineHeight",t[t.lineNumbers=66]="lineNumbers",t[t.lineNumbersMinChars=67]="lineNumbersMinChars",t[t.linkedEditing=68]="linkedEditing",t[t.links=69]="links",t[t.matchBrackets=70]="matchBrackets",t[t.minimap=71]="minimap",t[t.mouseStyle=72]="mouseStyle",t[t.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=74]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",t[t.multiCursorModifier=76]="multiCursorModifier",t[t.multiCursorPaste=77]="multiCursorPaste",t[t.multiCursorLimit=78]="multiCursorLimit",t[t.occurrencesHighlight=79]="occurrencesHighlight",t[t.overviewRulerBorder=80]="overviewRulerBorder",t[t.overviewRulerLanes=81]="overviewRulerLanes",t[t.padding=82]="padding",t[t.pasteAs=83]="pasteAs",t[t.parameterHints=84]="parameterHints",t[t.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",t[t.quickSuggestions=87]="quickSuggestions",t[t.quickSuggestionsDelay=88]="quickSuggestionsDelay",t[t.readOnly=89]="readOnly",t[t.readOnlyMessage=90]="readOnlyMessage",t[t.renameOnType=91]="renameOnType",t[t.renderControlCharacters=92]="renderControlCharacters",t[t.renderFinalNewline=93]="renderFinalNewline",t[t.renderLineHighlight=94]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=96]="renderValidationDecorations",t[t.renderWhitespace=97]="renderWhitespace",t[t.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",t[t.roundedSelection=99]="roundedSelection",t[t.rulers=100]="rulers",t[t.scrollbar=101]="scrollbar",t[t.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=103]="scrollBeyondLastLine",t[t.scrollPredominantAxis=104]="scrollPredominantAxis",t[t.selectionClipboard=105]="selectionClipboard",t[t.selectionHighlight=106]="selectionHighlight",t[t.selectOnLineNumbers=107]="selectOnLineNumbers",t[t.showFoldingControls=108]="showFoldingControls",t[t.showUnused=109]="showUnused",t[t.snippetSuggestions=110]="snippetSuggestions",t[t.smartSelect=111]="smartSelect",t[t.smoothScrolling=112]="smoothScrolling",t[t.stickyScroll=113]="stickyScroll",t[t.stickyTabStops=114]="stickyTabStops",t[t.stopRenderingLineAfter=115]="stopRenderingLineAfter",t[t.suggest=116]="suggest",t[t.suggestFontSize=117]="suggestFontSize",t[t.suggestLineHeight=118]="suggestLineHeight",t[t.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",t[t.suggestSelection=120]="suggestSelection",t[t.tabCompletion=121]="tabCompletion",t[t.tabIndex=122]="tabIndex",t[t.unicodeHighlighting=123]="unicodeHighlighting",t[t.unusualLineTerminators=124]="unusualLineTerminators",t[t.useShadowDOM=125]="useShadowDOM",t[t.useTabStops=126]="useTabStops",t[t.wordBreak=127]="wordBreak",t[t.wordSeparators=128]="wordSeparators",t[t.wordWrap=129]="wordWrap",t[t.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=132]="wordWrapColumn",t[t.wordWrapOverride1=133]="wordWrapOverride1",t[t.wordWrapOverride2=134]="wordWrapOverride2",t[t.wrappingIndent=135]="wrappingIndent",t[t.wrappingStrategy=136]="wrappingStrategy",t[t.showDeprecated=137]="showDeprecated",t[t.inlayHints=138]="inlayHints",t[t.editorClassName=139]="editorClassName",t[t.pixelRatio=140]="pixelRatio",t[t.tabFocusMode=141]="tabFocusMode",t[t.layoutInfo=142]="layoutInfo",t[t.wrappingInfo=143]="wrappingInfo",t[t.defaultColorDecorators=144]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(u||(n.EditorOption=u={}));var f;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(f||(n.EndOfLinePreference=f={}));var m;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(m||(n.EndOfLineSequence=m={}));var c;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(c||(n.GlyphMarginLane=c={}));var y;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(y||(n.IndentAction=y={}));var w;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(w||(n.InjectedTextCursorStops=w={}));var N;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(N||(n.InlayHintKind=N={}));var p;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(p||(n.InlineCompletionTriggerKind=p={}));var S;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(S||(n.KeyCode=S={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var o;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(o||(n.MarkerTag=o={}));var a;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(a||(n.MinimapPosition=a={}));var v;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(v||(n.MouseTargetType=v={}));var d;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(d||(n.OverlayWidgetPositionPreference=d={}));var C;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(C||(n.OverviewRulerLane=C={}));var R;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(R||(n.PositionAffinity=R={}));var E;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(E||(n.RenderLineNumbersType=E={}));var D;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(D||(n.RenderMinimap=D={}));var F;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(F||(n.ScrollType=F={}));var B;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(B||(n.ScrollbarVisibility=B={}));var I;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(I||(n.SelectionDirection=I={}));var U;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(U||(n.SignatureHelpTriggerKind=U={}));var x;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(x||(n.SymbolKind=x={}));var k;(function(t){t[t.Deprecated=1]="Deprecated"})(k||(n.SymbolTag=k={}));var O;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(O||(n.TextEditorCursorBlinkingStyle=O={}));var W;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(W||(n.TextEditorCursorStyle=W={}));var z;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(z||(n.TrackedRangeStickiness=z={}));var G;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(G||(n.WrappingIndent=G={}))}),Y(X[59],J([0,1,9,13]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(L){this._onDidChange.fire({changedLanguages:L,changedColorMap:!1})}register(L,l){return this._tokenizationSupports.set(L,l),this.handleChange([L]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(L)===l&&(this._tokenizationSupports.delete(L),this.handleChange([L]))})}get(L){return this._tokenizationSupports.get(L)||null}registerFactory(L,l){var s;(s=this._factories.get(L))===null||s===void 0||s.dispose();const _=new h(this,L,l);return this._factories.set(L,_),(0,M.toDisposable)(()=>{const e=this._factories.get(L);!e||e!==_||(this._factories.delete(L),e.dispose())})}getOrCreate(L){return le(this,void 0,void 0,function*(){const l=this.get(L);if(l)return l;const s=this._factories.get(L);return!s||s.isResolved?null:(yield s.resolve(),this.get(L))})}isResolved(L){if(this.get(L))return!0;const s=this._factories.get(L);return!!(!s||s.isResolved)}setColorMap(L){this._colorMap=L,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class h extends M.Disposable{get isResolved(){return this._isResolved}constructor(L,l,s){super(),this._registry=L,this._languageId=l,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return le(this,void 0,void 0,function*(){const L=yield this._factory.tokenizationSupport;this._isResolved=!0,L&&!this._isDisposed&&this._register(this._registry.register(this._languageId,L))})}}}),Y(X[60],J([19,61]),function(T,n){return T.create("vs/base/common/platform",n)}),Y(X[17],J([0,1,60]),function(T,n,A){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,h=!1,g=!1,L=!1,l=!1,s=!1,_=!1,e=!1,b=!1,u=!1,f,m=n.LANGUAGE_DEFAULT,c=n.LANGUAGE_DEFAULT,y,w;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let N;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?N=n.globals.vscode.process:typeof process<"u"&&(N=process);const p=typeof((M=N?.versions)===null||M===void 0?void 0:M.electron)=="string",S=p&&N?.type==="renderer";if(typeof navigator=="object"&&!S)w=navigator.userAgent,i=w.indexOf("Windows")>=0,h=w.indexOf("Macintosh")>=0,e=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,g=w.indexOf("Linux")>=0,u=w?.indexOf("Mobi")>=0,s=!0,f=A.getConfiguredDefaultLocale(A.localize(0,null))||n.LANGUAGE_DEFAULT,m=f,c=navigator.language;else if(typeof N=="object"){i=N.platform==="win32",h=N.platform==="darwin",g=N.platform==="linux",L=g&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,_=p,b=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=n.LANGUAGE_DEFAULT,m=n.LANGUAGE_DEFAULT;const d=N.env.VSCODE_NLS_CONFIG;if(d)try{const C=JSON.parse(d),R=C.availableLanguages["*"];f=C.locale,c=C.osLocale,m=R||n.LANGUAGE_DEFAULT,y=C._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");let r=0;h?r=1:i?r=3:g&&(r=2),n.isWindows=i,n.isMacintosh=h,n.isLinux=g,n.isNative=l,n.isWeb=s,n.isWebWorker=s&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=u,n.userAgent=w,n.language=m,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const d=[];n.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let E=0,D=d.length;E<D;E++){const F=d[E];if(F.id===R.data.vscodeScheduleAsyncWork){d.splice(E,1),F.callback();return}}});let C=0;return R=>{const E=++C;d.push({id:E,callback:R}),n.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return d=>setTimeout(d)})(),n.OS=h||e?2:i?1:3;let o=!0,a=!1;function v(){if(!a){a=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,o=new Uint16Array(d.buffer)[0]===(2<<8)+1}return o}n.isLittleEndian=v,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[62],J([0,1,17]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const i=A.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),Y(X[63],J([0,1,62]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,i=97,h=90,g=122,L=46,l=47,s=92,_=58,e=63;class b extends Error{constructor(o,a,v){let d;typeof a=="string"&&a.indexOf("not ")===0?(d="must not be",a=a.replace(/^not /,"")):d="must be";const C=o.indexOf(".")!==-1?"property":"argument";let R=`The "${o}" ${C} ${d} of type ${a}`;R+=`. Received type ${typeof v}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function u(r,o){if(r===null||typeof r!="object")throw new b(o,"Object",r)}function f(r,o){if(typeof r!="string")throw new b(o,"string",r)}const m=A.platform==="win32";function c(r){return r===l||r===s}function y(r){return r===l}function w(r){return r>=M&&r<=h||r>=i&&r<=g}function N(r,o,a,v){let d="",C=0,R=-1,E=0,D=0;for(let F=0;F<=r.length;++F){if(F<r.length)D=r.charCodeAt(F);else{if(v(D))break;D=l}if(v(D)){if(!(R===F-1||E===1))if(E===2){if(d.length<2||C!==2||d.charCodeAt(d.length-1)!==L||d.charCodeAt(d.length-2)!==L){if(d.length>2){const B=d.lastIndexOf(a);B===-1?(d="",C=0):(d=d.slice(0,B),C=d.length-1-d.lastIndexOf(a)),R=F,E=0;continue}else if(d.length!==0){d="",C=0,R=F,E=0;continue}}o&&(d+=d.length>0?`${a}..`:"..",C=2)}else d.length>0?d+=`${a}${r.slice(R+1,F)}`:d=r.slice(R+1,F),C=F-R-1;R=F,E=0}else D===L&&E!==-1?++E:E=-1}return d}function p(r,o){u(o,"pathObject");const a=o.dir||o.root,v=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${v}`:`${a}${r}${v}`:v}n.win32={resolve(...r){let o="",a="",v=!1;for(let d=r.length-1;d>=-1;d--){let C;if(d>=0){if(C=r[d],f(C,"path"),C.length===0)continue}else o.length===0?C=A.cwd():(C=A.env[`=${o}`]||A.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==o.toLowerCase()&&C.charCodeAt(2)===s)&&(C=`${o}\\`));const R=C.length;let E=0,D="",F=!1;const B=C.charCodeAt(0);if(R===1)c(B)&&(E=1,F=!0);else if(c(B))if(F=!0,c(C.charCodeAt(1))){let I=2,U=I;for(;I<R&&!c(C.charCodeAt(I));)I++;if(I<R&&I!==U){const x=C.slice(U,I);for(U=I;I<R&&c(C.charCodeAt(I));)I++;if(I<R&&I!==U){for(U=I;I<R&&!c(C.charCodeAt(I));)I++;(I===R||I!==U)&&(D=`\\\\${x}\\${C.slice(U,I)}`,E=I)}}}else E=1;else w(B)&&C.charCodeAt(1)===_&&(D=C.slice(0,2),E=2,R>2&&c(C.charCodeAt(2))&&(F=!0,E=3));if(D.length>0)if(o.length>0){if(D.toLowerCase()!==o.toLowerCase())continue}else o=D;if(v){if(o.length>0)break}else if(a=`${C.slice(E)}\\${a}`,v=F,F&&o.length>0)break}return a=N(a,!v,"\\",c),v?`${o}\\${a}`:`${o}${a}`||"."},normalize(r){f(r,"path");const o=r.length;if(o===0)return".";let a=0,v,d=!1;const C=r.charCodeAt(0);if(o===1)return y(C)?"\\":r;if(c(C))if(d=!0,c(r.charCodeAt(1))){let E=2,D=E;for(;E<o&&!c(r.charCodeAt(E));)E++;if(E<o&&E!==D){const F=r.slice(D,E);for(D=E;E<o&&c(r.charCodeAt(E));)E++;if(E<o&&E!==D){for(D=E;E<o&&!c(r.charCodeAt(E));)E++;if(E===o)return`\\\\${F}\\${r.slice(D)}\\`;E!==D&&(v=`\\\\${F}\\${r.slice(D,E)}`,a=E)}}}else a=1;else w(C)&&r.charCodeAt(1)===_&&(v=r.slice(0,2),a=2,o>2&&c(r.charCodeAt(2))&&(d=!0,a=3));let R=a<o?N(r.slice(a),!d,"\\",c):"";return R.length===0&&!d&&(R="."),R.length>0&&c(r.charCodeAt(o-1))&&(R+="\\"),v===void 0?d?`\\${R}`:R:d?`${v}\\${R}`:`${v}${R}`},isAbsolute(r){f(r,"path");const o=r.length;if(o===0)return!1;const a=r.charCodeAt(0);return c(a)||o>2&&w(a)&&r.charCodeAt(1)===_&&c(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let o,a;for(let C=0;C<r.length;++C){const R=r[C];f(R,"path"),R.length>0&&(o===void 0?o=a=R:o+=`\\${R}`)}if(o===void 0)return".";let v=!0,d=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++d;const C=a.length;C>1&&c(a.charCodeAt(1))&&(++d,C>2&&(c(a.charCodeAt(2))?++d:v=!1))}if(v){for(;d<o.length&&c(o.charCodeAt(d));)d++;d>=2&&(o=`\\${o.slice(d)}`)}return n.win32.normalize(o)},relative(r,o){if(f(r,"from"),f(o,"to"),r===o)return"";const a=n.win32.resolve(r),v=n.win32.resolve(o);if(a===v||(r=a.toLowerCase(),o=v.toLowerCase(),r===o))return"";let d=0;for(;d<r.length&&r.charCodeAt(d)===s;)d++;let C=r.length;for(;C-1>d&&r.charCodeAt(C-1)===s;)C--;const R=C-d;let E=0;for(;E<o.length&&o.charCodeAt(E)===s;)E++;let D=o.length;for(;D-1>E&&o.charCodeAt(D-1)===s;)D--;const F=D-E,B=R<F?R:F;let I=-1,U=0;for(;U<B;U++){const k=r.charCodeAt(d+U);if(k!==o.charCodeAt(E+U))break;k===s&&(I=U)}if(U!==B){if(I===-1)return v}else{if(F>B){if(o.charCodeAt(E+U)===s)return v.slice(E+U+1);if(U===2)return v.slice(E+U)}R>B&&(r.charCodeAt(d+U)===s?I=U:U===2&&(I=3)),I===-1&&(I=0)}let x="";for(U=d+I+1;U<=C;++U)(U===C||r.charCodeAt(U)===s)&&(x+=x.length===0?"..":"\\..");return E+=I,x.length>0?`${x}${v.slice(E,D)}`:(v.charCodeAt(E)===s&&++E,v.slice(E,D))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const o=n.win32.resolve(r);if(o.length<=2)return r;if(o.charCodeAt(0)===s){if(o.charCodeAt(1)===s){const a=o.charCodeAt(2);if(a!==e&&a!==L)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(w(o.charCodeAt(0))&&o.charCodeAt(1)===_&&o.charCodeAt(2)===s)return`\\\\?\\${o}`;return r},dirname(r){f(r,"path");const o=r.length;if(o===0)return".";let a=-1,v=0;const d=r.charCodeAt(0);if(o===1)return c(d)?r:".";if(c(d)){if(a=v=1,c(r.charCodeAt(1))){let E=2,D=E;for(;E<o&&!c(r.charCodeAt(E));)E++;if(E<o&&E!==D){for(D=E;E<o&&c(r.charCodeAt(E));)E++;if(E<o&&E!==D){for(D=E;E<o&&!c(r.charCodeAt(E));)E++;if(E===o)return r;E!==D&&(a=v=E+1)}}}}else w(d)&&r.charCodeAt(1)===_&&(a=o>2&&c(r.charCodeAt(2))?3:2,v=a);let C=-1,R=!0;for(let E=o-1;E>=v;--E)if(c(r.charCodeAt(E))){if(!R){C=E;break}}else R=!1;if(C===-1){if(a===-1)return".";C=a}return r.slice(0,C)},basename(r,o){o!==void 0&&f(o,"ext"),f(r,"path");let a=0,v=-1,d=!0,C;if(r.length>=2&&w(r.charCodeAt(0))&&r.charCodeAt(1)===_&&(a=2),o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let R=o.length-1,E=-1;for(C=r.length-1;C>=a;--C){const D=r.charCodeAt(C);if(c(D)){if(!d){a=C+1;break}}else E===-1&&(d=!1,E=C+1),R>=0&&(D===o.charCodeAt(R)?--R===-1&&(v=C):(R=-1,v=E))}return a===v?v=E:v===-1&&(v=r.length),r.slice(a,v)}for(C=r.length-1;C>=a;--C)if(c(r.charCodeAt(C))){if(!d){a=C+1;break}}else v===-1&&(d=!1,v=C+1);return v===-1?"":r.slice(a,v)},extname(r){f(r,"path");let o=0,a=-1,v=0,d=-1,C=!0,R=0;r.length>=2&&r.charCodeAt(1)===_&&w(r.charCodeAt(0))&&(o=v=2);for(let E=r.length-1;E>=o;--E){const D=r.charCodeAt(E);if(c(D)){if(!C){v=E+1;break}continue}d===-1&&(C=!1,d=E+1),D===L?a===-1?a=E:R!==1&&(R=1):a!==-1&&(R=-1)}return a===-1||d===-1||R===0||R===1&&a===d-1&&a===v+1?"":r.slice(a,d)},format:p.bind(null,"\\"),parse(r){f(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const a=r.length;let v=0,d=r.charCodeAt(0);if(a===1)return c(d)?(o.root=o.dir=r,o):(o.base=o.name=r,o);if(c(d)){if(v=1,c(r.charCodeAt(1))){let I=2,U=I;for(;I<a&&!c(r.charCodeAt(I));)I++;if(I<a&&I!==U){for(U=I;I<a&&c(r.charCodeAt(I));)I++;if(I<a&&I!==U){for(U=I;I<a&&!c(r.charCodeAt(I));)I++;I===a?v=I:I!==U&&(v=I+1)}}}}else if(w(d)&&r.charCodeAt(1)===_){if(a<=2)return o.root=o.dir=r,o;if(v=2,c(r.charCodeAt(2))){if(a===3)return o.root=o.dir=r,o;v=3}}v>0&&(o.root=r.slice(0,v));let C=-1,R=v,E=-1,D=!0,F=r.length-1,B=0;for(;F>=v;--F){if(d=r.charCodeAt(F),c(d)){if(!D){R=F+1;break}continue}E===-1&&(D=!1,E=F+1),d===L?C===-1?C=F:B!==1&&(B=1):C!==-1&&(B=-1)}return E!==-1&&(C===-1||B===0||B===1&&C===E-1&&C===R+1?o.base=o.name=r.slice(R,E):(o.name=r.slice(R,C),o.base=r.slice(R,E),o.ext=r.slice(C,E))),R>0&&R!==v?o.dir=r.slice(0,R-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(m){const r=/\\/g;return()=>{const o=A.cwd().replace(r,"/");return o.slice(o.indexOf("/"))}}return()=>A.cwd()})();n.posix={resolve(...r){let o="",a=!1;for(let v=r.length-1;v>=-1&&!a;v--){const d=v>=0?r[v]:S();f(d,"path"),d.length!==0&&(o=`${d}/${o}`,a=d.charCodeAt(0)===l)}return o=N(o,!a,"/",y),a?`/${o}`:o.length>0?o:"."},normalize(r){if(f(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===l,a=r.charCodeAt(r.length-1)===l;return r=N(r,!o,"/",y),r.length===0?o?"/":a?"./":".":(a&&(r+="/"),o?`/${r}`:r)},isAbsolute(r){return f(r,"path"),r.length>0&&r.charCodeAt(0)===l},join(...r){if(r.length===0)return".";let o;for(let a=0;a<r.length;++a){const v=r[a];f(v,"path"),v.length>0&&(o===void 0?o=v:o+=`/${v}`)}return o===void 0?".":n.posix.normalize(o)},relative(r,o){if(f(r,"from"),f(o,"to"),r===o||(r=n.posix.resolve(r),o=n.posix.resolve(o),r===o))return"";const a=1,v=r.length,d=v-a,C=1,R=o.length-C,E=d<R?d:R;let D=-1,F=0;for(;F<E;F++){const I=r.charCodeAt(a+F);if(I!==o.charCodeAt(C+F))break;I===l&&(D=F)}if(F===E)if(R>E){if(o.charCodeAt(C+F)===l)return o.slice(C+F+1);if(F===0)return o.slice(C+F)}else d>E&&(r.charCodeAt(a+F)===l?D=F:F===0&&(D=0));let B="";for(F=a+D+1;F<=v;++F)(F===v||r.charCodeAt(F)===l)&&(B+=B.length===0?"..":"/..");return`${B}${o.slice(C+D)}`},toNamespacedPath(r){return r},dirname(r){if(f(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===l;let a=-1,v=!0;for(let d=r.length-1;d>=1;--d)if(r.charCodeAt(d)===l){if(!v){a=d;break}}else v=!1;return a===-1?o?"/":".":o&&a===1?"//":r.slice(0,a)},basename(r,o){o!==void 0&&f(o,"ext"),f(r,"path");let a=0,v=-1,d=!0,C;if(o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let R=o.length-1,E=-1;for(C=r.length-1;C>=0;--C){const D=r.charCodeAt(C);if(D===l){if(!d){a=C+1;break}}else E===-1&&(d=!1,E=C+1),R>=0&&(D===o.charCodeAt(R)?--R===-1&&(v=C):(R=-1,v=E))}return a===v?v=E:v===-1&&(v=r.length),r.slice(a,v)}for(C=r.length-1;C>=0;--C)if(r.charCodeAt(C)===l){if(!d){a=C+1;break}}else v===-1&&(d=!1,v=C+1);return v===-1?"":r.slice(a,v)},extname(r){f(r,"path");let o=-1,a=0,v=-1,d=!0,C=0;for(let R=r.length-1;R>=0;--R){const E=r.charCodeAt(R);if(E===l){if(!d){a=R+1;break}continue}v===-1&&(d=!1,v=R+1),E===L?o===-1?o=R:C!==1&&(C=1):o!==-1&&(C=-1)}return o===-1||v===-1||C===0||C===1&&o===v-1&&o===a+1?"":r.slice(o,v)},format:p.bind(null,"/"),parse(r){f(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const a=r.charCodeAt(0)===l;let v;a?(o.root="/",v=1):v=0;let d=-1,C=0,R=-1,E=!0,D=r.length-1,F=0;for(;D>=v;--D){const B=r.charCodeAt(D);if(B===l){if(!E){C=D+1;break}continue}R===-1&&(E=!1,R=D+1),B===L?d===-1?d=D:F!==1&&(F=1):d!==-1&&(F=-1)}if(R!==-1){const B=C===0&&a?1:C;d===-1||F===0||F===1&&d===R-1&&d===C+1?o.base=o.name=r.slice(B,R):(o.name=r.slice(B,d),o.base=r.slice(B,R),o.ext=r.slice(d,R))}return C>0?o.dir=r.slice(0,C-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=m?n.win32.normalize:n.posix.normalize,n.resolve=m?n.win32.resolve:n.posix.resolve,n.relative=m?n.win32.relative:n.posix.relative,n.dirname=m?n.win32.dirname:n.posix.dirname,n.basename=m?n.win32.basename:n.posix.basename,n.extname=m?n.win32.extname:n.posix.extname,n.sep=m?n.win32.sep:n.posix.sep}),Y(X[18],J([0,1,63,17]),function(T,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,h=/^\//,g=/^\/\//;function L(a,v){if(!a.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!i.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!h.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(g.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(a,v){return!a&&!v?"file":a}function s(a,v){switch(a){case"https":case"http":case"file":v?v[0]!==e&&(v=e+v):v=e;break}return v}const _="",e="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(v){return v instanceof u?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,d,C,R,E,D=!1){typeof v=="object"?(this.scheme=v.scheme||_,this.authority=v.authority||_,this.path=v.path||_,this.query=v.query||_,this.fragment=v.fragment||_):(this.scheme=l(v,D),this.authority=d||_,this.path=s(this.scheme,C||_),this.query=R||_,this.fragment=E||_,L(this,D))}get fsPath(){return N(this,!1)}with(v){if(!v)return this;let{scheme:d,authority:C,path:R,query:E,fragment:D}=v;return d===void 0?d=this.scheme:d===null&&(d=_),C===void 0?C=this.authority:C===null&&(C=_),R===void 0?R=this.path:R===null&&(R=_),E===void 0?E=this.query:E===null&&(E=_),D===void 0?D=this.fragment:D===null&&(D=_),d===this.scheme&&C===this.authority&&R===this.path&&E===this.query&&D===this.fragment?this:new m(d,C,R,E,D)}static parse(v,d=!1){const C=b.exec(v);return C?new m(C[2]||_,o(C[4]||_),o(C[5]||_),o(C[7]||_),o(C[9]||_),d):new m(_,_,_,_,_)}static file(v){let d=_;if(M.isWindows&&(v=v.replace(/\\/g,e)),v[0]===e&&v[1]===e){const C=v.indexOf(e,2);C===-1?(d=v.substring(2),v=e):(d=v.substring(2,C),v=v.substring(C)||e)}return new m("file",d,v,_,_)}static from(v,d){return new m(v.scheme,v.authority,v.path,v.query,v.fragment,d)}static joinPath(v,...d){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return M.isWindows&&v.scheme==="file"?C=u.file(A.win32.join(N(v,!0),...d)).path:C=A.posix.join(v.path,...d),v.with({path:C})}toString(v=!1){return p(this,v)}toJSON(){return this}static revive(v){var d,C;if(v){if(v instanceof u)return v;{const R=new m(v);return R._formatted=(d=v.external)!==null&&d!==void 0?d:null,R._fsPath=v._sep===f&&(C=v.fsPath)!==null&&C!==void 0?C:null,R}}else return v}}n.URI=u;const f=M.isWindows?1:void 0;class m extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(v=!1){return v?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=f),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(a,v,d){let C,R=-1;for(let E=0;E<a.length;E++){const D=a.charCodeAt(E);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||v&&D===47||d&&D===91||d&&D===93||d&&D===58)R!==-1&&(C+=encodeURIComponent(a.substring(R,E)),R=-1),C!==void 0&&(C+=a.charAt(E));else{C===void 0&&(C=a.substr(0,E));const F=c[D];F!==void 0?(R!==-1&&(C+=encodeURIComponent(a.substring(R,E)),R=-1),C+=F):R===-1&&(R=E)}}return R!==-1&&(C+=encodeURIComponent(a.substring(R))),C!==void 0?C:a}function w(a){let v;for(let d=0;d<a.length;d++){const C=a.charCodeAt(d);C===35||C===63?(v===void 0&&(v=a.substr(0,d)),v+=c[C]):v!==void 0&&(v+=a[d])}return v!==void 0?v:a}function N(a,v){let d;return a.authority&&a.path.length>1&&a.scheme==="file"?d=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?v?d=a.path.substr(1):d=a.path[1].toLowerCase()+a.path.substr(2):d=a.path,M.isWindows&&(d=d.replace(/\//g,"\\")),d}n.uriToFsPath=N;function p(a,v){const d=v?w:y;let C="",{scheme:R,authority:E,path:D,query:F,fragment:B}=a;if(R&&(C+=R,C+=":"),(E||R==="file")&&(C+=e,C+=e),E){let I=E.indexOf("@");if(I!==-1){const U=E.substr(0,I);E=E.substr(I+1),I=U.lastIndexOf(":"),I===-1?C+=d(U,!1,!1):(C+=d(U.substr(0,I),!1,!1),C+=":",C+=d(U.substr(I+1),!1,!0)),C+="@"}E=E.toLowerCase(),I=E.lastIndexOf(":"),I===-1?C+=d(E,!1,!0):(C+=d(E.substr(0,I),!1,!0),C+=E.substr(I))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const I=D.charCodeAt(1);I>=65&&I<=90&&(D=`/${String.fromCharCode(I+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const I=D.charCodeAt(0);I>=65&&I<=90&&(D=`${String.fromCharCode(I+32)}:${D.substr(2)}`)}C+=d(D,!0,!1)}return F&&(C+="?",C+=d(F,!1,!1)),B&&(C+="#",C+=v?B:y(B,!1,!1)),C}function S(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+S(a.substr(3)):a}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(a){return a.match(r)?a.replace(r,v=>S(v)):a}}),Y(X[67],J([0,1,5,9,13,14,17,6]),function(T,n,A,M,i,h,g,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function _(o){g.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}n.logOnceWebWorkerWarning=_;class e{constructor(a,v,d,C){this.vsWorker=a,this.req=v,this.method=d,this.args=C,this.type=0}}class b{constructor(a,v,d,C){this.vsWorker=a,this.seq=v,this.res=d,this.err=C,this.type=1}}class u{constructor(a,v,d,C){this.vsWorker=a,this.req=v,this.eventName=d,this.arg=C,this.type=2}}class f{constructor(a,v,d){this.vsWorker=a,this.req=v,this.event=d,this.type=3}}class m{constructor(a,v){this.vsWorker=a,this.req=v,this.type=4}}class c{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,v){const d=String(++this._lastSentReq);return new Promise((C,R)=>{this._pendingReplies[d]={resolve:C,reject:R},this._send(new e(this._workerId,d,a,v))})}listen(a,v){let d=null;const C=new M.Emitter({onWillAddFirstListener:()=>{d=String(++this._lastSentReq),this._pendingEmitters.set(d,C),this._send(new u(this._workerId,d,a,v))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(d),this._send(new m(this._workerId,d)),d=null}});return C.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const v=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let d=a.err;a.err.$isError&&(d=new Error,d.name=a.err.name,d.message=a.err.message,d.stack=a.err.stack),v.reject(d);return}v.resolve(a.res)}_handleRequestMessage(a){const v=a.req;this._handler.handleMessage(a.method,a.args).then(C=>{this._send(new b(this._workerId,v,C,void 0))},C=>{C.detail instanceof Error&&(C.detail=(0,A.transformErrorForSerialization)(C.detail)),this._send(new b(this._workerId,v,void 0,(0,A.transformErrorForSerialization)(C)))})}_handleSubscribeEventMessage(a){const v=a.req,d=this._handler.handleEvent(a.eventName,a.arg)(C=>{this._send(new f(this._workerId,v,C))});this._pendingEvents.set(v,d)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const v=[];if(a.type===0)for(let d=0;d<a.args.length;d++)a.args[d]instanceof ArrayBuffer&&v.push(a.args[d]);else a.type===1&&a.res instanceof ArrayBuffer&&v.push(a.res);this._handler.sendMessage(a,v)}}class y extends i.Disposable{constructor(a,v,d){super();let C=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",I=>{this._protocol.handleMessage(I)},I=>{C?.(I)})),this._protocol=new c({sendMessage:(I,U)=>{this._worker.postMessage(I,U)},handleMessage:(I,U)=>{if(typeof d[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(d[I].apply(d,U))}catch(x){return Promise.reject(x)}},handleEvent:(I,U)=>{if(N(I)){const x=d[I].call(d,U);if(typeof x!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return x}if(w(I)){const x=d[I];if(typeof x!="function")throw new Error(`Missing event ${I} on main thread host.`);return x}throw new Error(`Malformed event name ${I}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;const E=globalThis.require;typeof E<"u"&&typeof E.getConfig=="function"?R=E.getConfig():typeof globalThis.requirejs<"u"&&(R=globalThis.requirejs.s.contexts._.config);const D=(0,h.getAllMethodNames)(d);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(R)),v,D]);const F=(I,U)=>this._request(I,U),B=(I,U)=>this._protocol.listen(I,U);this._lazyProxy=new Promise((I,U)=>{C=U,this._onModuleLoaded.then(x=>{I(p(x,F,B))},x=>{U(x),this._onError("Worker failed to load "+v,x)})})}getProxyObject(){return this._lazyProxy}_request(a,v){return new Promise((d,C)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,v).then(d,C)},C)})}_onError(a,v){console.error(a),console.info(v)}}n.SimpleWorkerClient=y;function w(o){return o[0]==="o"&&o[1]==="n"&&L.isUpperAsciiLetter(o.charCodeAt(2))}function N(o){return/^onDynamic/.test(o)&&L.isUpperAsciiLetter(o.charCodeAt(9))}function p(o,a,v){const d=E=>function(){const D=Array.prototype.slice.call(arguments,0);return a(E,D)},C=E=>function(D){return v(E,D)},R={};for(const E of o){if(N(E)){R[E]=C(E);continue}if(w(E)){R[E]=v(E,void 0);continue}R[E]=d(E)}return R}class S{constructor(a,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new c({sendMessage:(d,C)=>{a(d,C)},handleMessage:(d,C)=>this._handleMessage(d,C),handleEvent:(d,C)=>this._handleEvent(d,C)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,v){if(a===l)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,v))}catch(d){return Promise.reject(d)}}_handleEvent(a,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(a)){const d=this._requestHandler[a].call(this._requestHandler,v);if(typeof d!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return d}if(w(a)){const d=this._requestHandler[a];if(typeof d!="function")throw new Error(`Missing event ${a} on request handler.`);return d}throw new Error(`Malformed event name ${a}`)}initialize(a,v,d,C){this._protocol.setWorkerId(a);const D=p(C,(F,B)=>this._protocol.sendMessage(F,B),(F,B)=>this._protocol.listen(F,B));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve((0,h.getAllMethodNames)(this._requestHandler))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((F,B)=>{(globalThis.require||T)([d],U=>{if(this._requestHandler=U.create(D),!this._requestHandler){B(new Error("No RequestHandler!"));return}F((0,h.getAllMethodNames)(this._requestHandler))},B)}))}}n.SimpleWorkerServer=S;function r(o){return new S(o,null)}n.create=r}),Y(X[64],J([19,61]),function(T,n){return T.create("vs/editor/common/languages",n)}),Y(X[65],J([0,1,40,18,2,59,64]),function(T,n,A,M,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.getAriaLabelForSymbol=n.symbolKindNames=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class L{constructor(a,v,d){this.offset=a,this.type=v,this.language=d,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=L;class l{constructor(a,v){this.tokens=a,this.endState=v,this._tokenizationResultBrand=void 0}}n.TokenizationResult=l;class s{constructor(a,v){this.tokens=a,this.endState=v,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=s;var _;(function(o){const a=new Map;a.set(0,A.Codicon.symbolMethod),a.set(1,A.Codicon.symbolFunction),a.set(2,A.Codicon.symbolConstructor),a.set(3,A.Codicon.symbolField),a.set(4,A.Codicon.symbolVariable),a.set(5,A.Codicon.symbolClass),a.set(6,A.Codicon.symbolStruct),a.set(7,A.Codicon.symbolInterface),a.set(8,A.Codicon.symbolModule),a.set(9,A.Codicon.symbolProperty),a.set(10,A.Codicon.symbolEvent),a.set(11,A.Codicon.symbolOperator),a.set(12,A.Codicon.symbolUnit),a.set(13,A.Codicon.symbolValue),a.set(15,A.Codicon.symbolEnum),a.set(14,A.Codicon.symbolConstant),a.set(15,A.Codicon.symbolEnum),a.set(16,A.Codicon.symbolEnumMember),a.set(17,A.Codicon.symbolKeyword),a.set(27,A.Codicon.symbolSnippet),a.set(18,A.Codicon.symbolText),a.set(19,A.Codicon.symbolColor),a.set(20,A.Codicon.symbolFile),a.set(21,A.Codicon.symbolReference),a.set(22,A.Codicon.symbolCustomColor),a.set(23,A.Codicon.symbolFolder),a.set(24,A.Codicon.symbolTypeParameter),a.set(25,A.Codicon.account),a.set(26,A.Codicon.issues);function v(R){let E=a.get(R);return E||(console.info("No codicon found for CompletionItemKind "+R),E=A.Codicon.symbolProperty),E}o.toIcon=v;const d=new Map;d.set("method",0),d.set("function",1),d.set("constructor",2),d.set("field",3),d.set("variable",4),d.set("class",5),d.set("struct",6),d.set("interface",7),d.set("module",8),d.set("property",9),d.set("event",10),d.set("operator",11),d.set("unit",12),d.set("value",13),d.set("constant",14),d.set("enum",15),d.set("enum-member",16),d.set("enumMember",16),d.set("keyword",17),d.set("snippet",27),d.set("text",18),d.set("color",19),d.set("file",20),d.set("reference",21),d.set("customcolor",22),d.set("folder",23),d.set("type-parameter",24),d.set("typeParameter",24),d.set("account",25),d.set("issue",26);function C(R,E){let D=d.get(R);return typeof D>"u"&&!E&&(D=9),D}o.fromString=C})(_||(n.CompletionItemKinds=_={}));var e;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class b{constructor(a,v,d,C){this.range=a,this.text=v,this.completionKind=d,this.isSnippetText=C}equals(a){return i.Range.lift(this.range).equalsRange(a.range)&&this.text===a.text&&this.completionKind===a.completionKind&&this.isSnippetText===a.isSnippetText}}n.SelectedSuggestionInfo=b;var u;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(u||(n.SignatureHelpTriggerKind=u={}));var f;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(f||(n.DocumentHighlightKind=f={}));function m(o){return o&&M.URI.isUri(o.uri)&&i.Range.isIRange(o.range)&&(i.Range.isIRange(o.originSelectionRange)||i.Range.isIRange(o.targetSelectionRange))}n.isLocationLink=m,n.symbolKindNames={[17]:(0,g.localize)(0,null),[16]:(0,g.localize)(1,null),[4]:(0,g.localize)(2,null),[13]:(0,g.localize)(3,null),[8]:(0,g.localize)(4,null),[9]:(0,g.localize)(5,null),[21]:(0,g.localize)(6,null),[23]:(0,g.localize)(7,null),[7]:(0,g.localize)(8,null),[0]:(0,g.localize)(9,null),[11]:(0,g.localize)(10,null),[10]:(0,g.localize)(11,null),[19]:(0,g.localize)(12,null),[5]:(0,g.localize)(13,null),[1]:(0,g.localize)(14,null),[2]:(0,g.localize)(15,null),[20]:(0,g.localize)(16,null),[15]:(0,g.localize)(17,null),[18]:(0,g.localize)(18,null),[24]:(0,g.localize)(19,null),[3]:(0,g.localize)(20,null),[6]:(0,g.localize)(21,null),[14]:(0,g.localize)(22,null),[22]:(0,g.localize)(23,null),[25]:(0,g.localize)(24,null),[12]:(0,g.localize)(25,null)};function c(o,a){return(0,g.localize)(26,null,o,n.symbolKindNames[a])}n.getAriaLabelForSymbol=c;var y;(function(o){const a=new Map;a.set(0,A.Codicon.symbolFile),a.set(1,A.Codicon.symbolModule),a.set(2,A.Codicon.symbolNamespace),a.set(3,A.Codicon.symbolPackage),a.set(4,A.Codicon.symbolClass),a.set(5,A.Codicon.symbolMethod),a.set(6,A.Codicon.symbolProperty),a.set(7,A.Codicon.symbolField),a.set(8,A.Codicon.symbolConstructor),a.set(9,A.Codicon.symbolEnum),a.set(10,A.Codicon.symbolInterface),a.set(11,A.Codicon.symbolFunction),a.set(12,A.Codicon.symbolVariable),a.set(13,A.Codicon.symbolConstant),a.set(14,A.Codicon.symbolString),a.set(15,A.Codicon.symbolNumber),a.set(16,A.Codicon.symbolBoolean),a.set(17,A.Codicon.symbolArray),a.set(18,A.Codicon.symbolObject),a.set(19,A.Codicon.symbolKey),a.set(20,A.Codicon.symbolNull),a.set(21,A.Codicon.symbolEnumMember),a.set(22,A.Codicon.symbolStruct),a.set(23,A.Codicon.symbolEvent),a.set(24,A.Codicon.symbolOperator),a.set(25,A.Codicon.symbolTypeParameter);function v(d){let C=a.get(d);return C||(console.info("No codicon found for SymbolKind "+d),C=A.Codicon.symbolProperty),C}o.toIcon=v})(y||(n.SymbolKinds=y={}));class w{}n.TextEdit=w;class N{static fromValue(a){switch(a){case"comment":return N.Comment;case"imports":return N.Imports;case"region":return N.Region}return new N(a)}constructor(a){this.value=a}}n.FoldingRangeKind=N,N.Comment=new N("comment"),N.Imports=new N("imports"),N.Region=new N("region");var p;(function(o){function a(v){return!v||typeof v!="object"?!1:typeof v.id=="string"&&typeof v.title=="string"}o.is=a})(p||(n.Command=p={}));var S;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(S||(n.InlayHintKind=S={}));class r{constructor(a){this.createSupport=a,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(a=>{a&&a.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=r,n.TokenizationRegistry=new h.TokenizationRegistry}),Y(X[66],J([0,1,38,9,36,18,4,2,41,65,58]),function(T,n,A,M,i,h,g,L,l,s,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(f,m){return(0,i.KeyChord)(f,m)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:A.CancellationTokenSource,Emitter:M.Emitter,KeyCode:_.KeyCode,KeyMod:e,Position:g.Position,Range:L.Range,Selection:l.Selection,SelectionDirection:_.SelectionDirection,MarkerSeverity:_.MarkerSeverity,MarkerTag:_.MarkerTag,Uri:h.URI,Token:s.Token}}n.createMonacoBaseAPI=b}),Y(X[68],J([0,1,24,18,4,2,55,28,51,52,66,23,57,49,14,50]),function(T,n,A,M,i,h,g,L,l,s,_,e,b,u,f,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class c extends g.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(p){const S=[];for(let r=0;r<this._lines.length;r++){const o=this._lines[r],a=this.offsetAt(new i.Position(r+1,1)),v=o.matchAll(p);for(const d of v)(d.index||d.index===0)&&(d.index=d.index+a),S.push(d)}return S}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(p){return this._lines[p-1]}getWordAtPosition(p,S){const r=(0,L.getWordAtText)(p.column,(0,L.ensureValidWordDefinition)(S),this._lines[p.lineNumber-1],0);return r?new h.Range(p.lineNumber,r.startColumn,p.lineNumber,r.endColumn):null}words(p){const S=this._lines,r=this._wordenize.bind(this);let o=0,a="",v=0,d=[];return{*[Symbol.iterator](){for(;;)if(v<d.length){const C=a.substring(d[v].start,d[v].end);v+=1,yield C}else if(o<S.length)a=S[o],d=r(a,p),v=0,o+=1;else break}}}getLineWords(p,S){const r=this._lines[p-1],o=this._wordenize(r,S),a=[];for(const v of o)a.push({word:r.substring(v.start,v.end),startColumn:v.start+1,endColumn:v.end+1});return a}_wordenize(p,S){const r=[];let o;for(S.lastIndex=0;(o=S.exec(p))&&o[0].length!==0;)r.push({start:o.index,end:o.index+o[0].length});return r}getValueInRange(p){if(p=this._validateRange(p),p.startLineNumber===p.endLineNumber)return this._lines[p.startLineNumber-1].substring(p.startColumn-1,p.endColumn-1);const S=this._eol,r=p.startLineNumber-1,o=p.endLineNumber-1,a=[];a.push(this._lines[r].substring(p.startColumn-1));for(let v=r+1;v<o;v++)a.push(this._lines[v]);return a.push(this._lines[o].substring(0,p.endColumn-1)),a.join(S)}offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.lineNumber-2)+(p.column-1)}positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(p),r=this._lines[S.index].length;return{lineNumber:1+S.index,column:1+Math.min(S.remainder,r)}}_validateRange(p){const S=this._validatePosition({lineNumber:p.startLineNumber,column:p.startColumn}),r=this._validatePosition({lineNumber:p.endLineNumber,column:p.endColumn});return S.lineNumber!==p.startLineNumber||S.column!==p.startColumn||r.lineNumber!==p.endLineNumber||r.column!==p.endColumn?{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:r.lineNumber,endColumn:r.column}:p}_validatePosition(p){if(!i.Position.isIPosition(p))throw new Error("bad position");let{lineNumber:S,column:r}=p,o=!1;if(S<1)S=1,r=1,o=!0;else if(S>this._lines.length)S=this._lines.length,r=this._lines[S-1].length+1,o=!0;else{const a=this._lines[S-1].length+1;r<1?(r=1,o=!0):r>a&&(r=a,o=!0)}return o?{lineNumber:S,column:r}:p}}class y{constructor(p,S){this._host=p,this._models=Object.create(null),this._foreignModuleFactory=S,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(p){return this._models[p]}_getModels(){const p=[];return Object.keys(this._models).forEach(S=>p.push(this._models[S])),p}acceptNewModel(p){this._models[p.url]=new c(M.URI.parse(p.url),p.lines,p.EOL,p.versionId)}acceptModelChanged(p,S){if(!this._models[p])return;this._models[p].onEvents(S)}acceptRemovedModel(p){this._models[p]&&delete this._models[p]}computeUnicodeHighlights(p,S,r){return le(this,void 0,void 0,function*(){const o=this._getModel(p);return o?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(o,S,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(p,S,r,o){return le(this,void 0,void 0,function*(){const a=this._getModel(p),v=this._getModel(S);return!a||!v?null:y.computeDiff(a,v,r,o)})}static computeDiff(p,S,r,o){const a=o==="advanced"?u.linesDiffComputers.getDefault():u.linesDiffComputers.getLegacy(),v=p.getLinesContent(),d=S.getLinesContent(),C=a.computeDiff(v,d,r),R=C.changes.length>0?!1:this._modelsAreIdentical(p,S);function E(D){return D.map(F=>{var B;return[F.original.startLineNumber,F.original.endLineNumberExclusive,F.modified.startLineNumber,F.modified.endLineNumberExclusive,(B=F.innerChanges)===null||B===void 0?void 0:B.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])]})}return{identical:R,quitEarly:C.hitTimeout,changes:E(C.changes),moves:C.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,E(D.changes)])}}static _modelsAreIdentical(p,S){const r=p.getLineCount(),o=S.getLineCount();if(r!==o)return!1;for(let a=1;a<=r;a++){const v=p.getLineContent(a),d=S.getLineContent(a);if(v!==d)return!1}return!0}computeMoreMinimalEdits(p,S,r){return le(this,void 0,void 0,function*(){const o=this._getModel(p);if(!o)return S;const a=[];let v;S=S.slice(0).sort((C,R)=>{if(C.range&&R.range)return h.Range.compareRangesUsingStarts(C.range,R.range);const E=C.range?0:1,D=R.range?0:1;return E-D});let d=0;for(let C=1;C<S.length;C++)h.Range.getEndPosition(S[d].range).equals(h.Range.getStartPosition(S[C].range))?(S[d].range=h.Range.fromPositions(h.Range.getStartPosition(S[d].range),h.Range.getEndPosition(S[C].range)),S[d].text+=S[C].text):(d++,S[d]=S[C]);S.length=d+1;for(let{range:C,text:R,eol:E}of S){if(typeof E=="number"&&(v=E),h.Range.isEmpty(C)&&!R)continue;const D=o.getValueInRange(C);if(R=R.replace(/\r\n|\n|\r/g,o.eol),D===R)continue;if(Math.max(R.length,D.length)>y._diffLimit){a.push({range:C,text:R});continue}const F=(0,A.stringDiff)(D,R,r),B=o.offsetAt(h.Range.lift(C).getStartPosition());for(const I of F){const U=o.positionAt(B+I.originalStart),x=o.positionAt(B+I.originalStart+I.originalLength),k={text:R.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:U.lineNumber,startColumn:U.column,endLineNumber:x.lineNumber,endColumn:x.column}};o.getValueInRange(k.range)!==k.text&&a.push(k)}}return typeof v=="number"&&a.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a})}computeLinks(p){return le(this,void 0,void 0,function*(){const S=this._getModel(p);return S?(0,l.computeLinks)(S):null})}computeDefaultDocumentColors(p){return le(this,void 0,void 0,function*(){const S=this._getModel(p);return S?(0,m.computeDefaultDocumentColors)(S):null})}textualSuggest(p,S,r,o){return le(this,void 0,void 0,function*(){const a=new e.StopWatch,v=new RegExp(r,o),d=new Set;e:for(const C of p){const R=this._getModel(C);if(R){for(const E of R.words(v))if(!(E===S||!isNaN(Number(E)))&&(d.add(E),d.size>y._suggestionsLimit))break e}}return{words:Array.from(d),duration:a.elapsed()}})}computeWordRanges(p,S,r,o){return le(this,void 0,void 0,function*(){const a=this._getModel(p);if(!a)return Object.create(null);const v=new RegExp(r,o),d=Object.create(null);for(let C=S.startLineNumber;C<S.endLineNumber;C++){const R=a.getLineWords(C,v);for(const E of R){if(!isNaN(Number(E.word)))continue;let D=d[E.word];D||(D=[],d[E.word]=D),D.push({startLineNumber:C,startColumn:E.startColumn,endLineNumber:C,endColumn:E.endColumn})}}return d})}navigateValueSet(p,S,r,o,a){return le(this,void 0,void 0,function*(){const v=this._getModel(p);if(!v)return null;const d=new RegExp(o,a);S.startColumn===S.endColumn&&(S={startLineNumber:S.startLineNumber,startColumn:S.startColumn,endLineNumber:S.endLineNumber,endColumn:S.endColumn+1});const C=v.getValueInRange(S),R=v.getWordAtPosition({lineNumber:S.startLineNumber,column:S.startColumn},d);if(!R)return null;const E=v.getValueInRange(R);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(S,C,R,E,r)})}loadForeignModule(p,S,r){const o=(d,C)=>this._host.fhr(d,C),v={host:(0,f.createProxyObject)(r,o),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(v,S),Promise.resolve((0,f.getAllMethodNames)(this._foreignModule))):new Promise((d,C)=>{T([p],R=>{this._foreignModule=R.create(v,S),d((0,f.getAllMethodNames)(this._foreignModule))},C)})}fmr(p,S){if(!this._foreignModule||typeof this._foreignModule[p]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+p));try{return Promise.resolve(this._foreignModule[p].apply(this._foreignModule,S))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=y,y._diffLimit=1e5,y._suggestionsLimit=1e4;function w(N){return new y(N,null)}n.create=w,typeof importScripts=="function"&&(globalThis.monaco=(0,_.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map